// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.MemoryMonitor;


import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;

   public class TabBottom extends JPanel {

    public static final long serialVersionUID = 109;
    
    public JTextField tx1;
    public JTextField tx2;
    public JTextField MCField;
    public static JButton brun;
    public static JProgressBar  pb1;
    private MemoryMonitor memMon;   
    private JPanel topPanel;
    private JPanel outPanel1;
    private JPanel outPanel2;
    private static JPanel infoPanel;
    public static JLabel statusBar;
    public static JLabel outFiles;
    public static JLabel outHisto;
    public static JLabel iniState;
    public static JLabel finState; 
    public static JLabel canvasOut;
 
    public TabBottom() {     
  
//    mainPanel = new JPanel();  
//    mainPanel.setLayout( new BorderLayout() );
//    this.add( mainPanel );

    this.setLayout( new BorderLayout() );
 
//    topPanel = new JPanel();
//    topPanel.setBackground(new java.awt.Color(22, 22, 252));   
//    topPanel.setPreferredSize(new java.awt.Dimension(500, 112));
//    topPanel.setMinimumSize(new java.awt.Dimension(55, 50));
//    topPanel.setMaximumSize(new java.awt.Dimension(10000, 2000));

    infoPanel = new JPanel();
    infoPanel.setLayout( new BorderLayout() );  
//    infoPanel.setBackground(new java.awt.Color(200, 200, 200)); 
    infoPanel.setBorder(new javax.swing.border.EtchedBorder());
//     infoPanel.setBorder(new BevelBorder(BevelBorder.LOWERED));


    topPanel = new JPanel();
    topPanel.setLayout( new BorderLayout() );
    topPanel.setBackground(new java.awt.Color(240, 240, 230));


    outPanel1 = new JPanel();
    outPanel1.setPreferredSize(new java.awt.Dimension(100, 80));
    outPanel1.setLayout(new GridLayout(0,1));  
    outPanel1.setBackground(new java.awt.Color(240, 240, 230));
    this.add(outPanel1, BorderLayout.WEST);

    outPanel2 = new JPanel();
//    outPanel2.setPreferredSize(new java.awt.Dimension(320, 140));
//    outPanel2.setLayout( new BorderLayout() );
    outPanel2.setLayout(new GridLayout(0,1));
//    outPanel2.setBackground(new java.awt.Color(100, 100, 30));
    this.add(outPanel2, BorderLayout.CENTER);

    this.add(infoPanel, BorderLayout.SOUTH);
    this.add(topPanel,  BorderLayout.NORTH);


    statusBar = new JLabel("RunMC is active");
//    statusBar.setPreferredSize(new java.awt.Dimension(420, 24));
    statusBar.setMinimumSize(new java.awt.Dimension(420, 24)); 
    statusBar.setMaximumSize(new java.awt.Dimension(10000, 2000)); 
//    statusBar.setBorder(new BevelBorder(BevelBorder.LOWERED));
    // this.add(mainPanel, BorderLayout.CENTER);
//    mainPanel.add(urlPanel, BorderLayout.CENTER);
    infoPanel.add(statusBar,BorderLayout.WEST);

     Font  fon1= new Font("Lucida Sans", Font.BOLD, 14); 
     Font  fon2= new Font("Lucida Sans", Font.BOLD, 16);

     iniState = new JLabel("defaults"); 
     finState = new JLabel("defaults"); 
     outFiles = new JLabel("defaults");
     outHisto = new JLabel("defaults");
     canvasOut = new JLabel("defaults"); 

     iniState.setFont(fon1);
     finState.setFont(fon1);
     outFiles.setFont(fon1);
     outHisto.setFont(fon1);
     canvasOut.setFont(fon1);

     outPanel2.add(iniState);
     outPanel2.add(finState);
     outPanel2.add(outFiles);
     outPanel2.add(outHisto);
     outPanel2.add(canvasOut);


     JLabel iniState1 = new JLabel("Initial state:"); 
     JLabel finState1 = new JLabel("Final state:");
     JLabel outFiles1 = new JLabel("Output:");
     JLabel outHisto1 = new JLabel("Histograms:");
     JLabel canvasOut1 = new JLabel("Canvas:");
     iniState1.setFont(fon2); 
     finState1.setFont(fon2); 
     outFiles1.setFont(fon2); 
     outHisto1.setFont(fon2); 
     canvasOut1.setFont(fon2);
 
     outPanel1.add(iniState1);
     outPanel1.add(finState1);
     outPanel1.add(outFiles1);
     outPanel1.add(outHisto1); 
     outPanel1.add(canvasOut1); 

    // bottom pannel
    // this.setPreferredSize(new java.awt.Dimension(500, 112));
    // this.setMinimumSize(new java.awt.Dimension(55, 50));


    MCField = new JTextField("PYTHIA");
    // MCField.setFont(SetEnv.FontBold);
    MCField.setFont(new java.awt.Font("Dialog", 1, 18));
    MCField.setPreferredSize(new java.awt.Dimension(160, 45));
    MCField.setMinimumSize(new java.awt.Dimension(80, 25)); 
    MCField.setBackground(new java.awt.Color(240, 240, 230)); 
    MCField.setEditable(false); 
    MCField.setRequestFocusEnabled(false);
    MCField.setAutoscrolls(false);
//    MCField.setOpaque(false); 
    MCField.setBorder(new TitledBorder(null,
                                   "Selected model:",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
    
    MCField.setToolTipText("selected model");
 
    topPanel.add(MCField, BorderLayout.WEST);

    tx1 = new JTextField();
//    tx1.setBackground(new java.awt.Color(252, 252, 252));
    tx1.setBackground(new java.awt.Color(240, 240, 230));   
    tx1.setFont(SetEnv.FontBold);
    tx1.setPreferredSize(new java.awt.Dimension(100, 45));
    tx1.setMinimumSize(new java.awt.Dimension(50, 25));
    tx1.setHorizontalAlignment(JTextField.RIGHT);
    tx1.setText("1000");
    tx1.setBorder(new TitledBorder(null,
                                   "Events No:",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
     topPanel.add(tx1,BorderLayout.EAST);
    
     tx1.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
       String ss=tx1.getText(); ss=ss.trim();
       if (ss.length()>0) {
           SetIni.Nevents=Utility.GetInt(ss);
          }
     }
     public void removeUpdate(DocumentEvent e) {
     // text was deleted
        String ss=tx1.getText(); ss=ss.trim();
        if (ss.length()>0) SetIni.Nevents=Utility.GetInt(ss);
   //  System.out.print(SetIni.Nevents);
     }
     public void insertUpdate(DocumentEvent e) {
        String ss=tx1.getText(); ss=ss.trim();
       // text was inserted
     if (ss.length()>0) SetIni.Nevents=Utility.GetIntError(ss);
  //   System.out.print(SetIni.Nevents);
    }  });


 
     tx2 = new JTextField();
//     tx2.setBackground(new java.awt.Color(252, 252, 252));
     tx2.setBackground(new java.awt.Color(240, 240, 230)); 
     tx2.setFont(SetEnv.FontBold);
     tx2.setPreferredSize(new java.awt.Dimension(140, 45));
     tx2.setMinimumSize(new java.awt.Dimension(50, 25));
     tx2.setHorizontalAlignment(JTextField.RIGHT);
     tx2.setText("default");
     tx2.setBorder(new TitledBorder(null,
                                   "Project name:",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
     topPanel.add(tx2,BorderLayout.CENTER);

     
     tx2.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
     SetIni.MOutput=tx2.getText(); }
     public void removeUpdate(DocumentEvent e) {
     // text was deleted
     SetIni.MOutput=tx2.getText();  setMessage();  }
     public void insertUpdate(DocumentEvent e) {
     // text was inserted
     SetIni.MOutput=tx2.getText();   setMessage();  }  });


     
     brun = new JButton("Run");
     brun.setBackground( new Color(230, 230, 240)  );
     brun.setToolTipText("To start running, click here");
     brun.setFont(SetEnv.FontBold);
     this.add(brun,BorderLayout.EAST);
    
   
     pb1 = new  JProgressBar(JProgressBar.HORIZONTAL,0,100);
     pb1.setValue(0); 
     pb1.setPreferredSize(new java.awt.Dimension(480, 12));
     pb1.setMinimumSize(new java.awt.Dimension(50, 10));
     pb1.setForeground(new Color(120, 100, 255)); // blue
     infoPanel.add(pb1,BorderLayout.NORTH);
     
     
     memMon = new MemoryMonitor();   
     memMon.setPreferredSize(new java.awt.Dimension(65, 24));
     memMon.setMinimumSize(new java.awt.Dimension(30, 10));
     infoPanel.add(memMon,BorderLayout.EAST);
   
      
    }
    
// update this pannel with new settings
     public void setPan()  {


     tx2.setText(SetIni.MOutput); // set name

     String s="undefined"; 
     if (SetIni.MCtype>0) s=SetIni.MC [ SetIni.MCtype-1 ]; // set MC name 
     if (SetIni.MCtype == -1)  s= SetIni.NTUPLES[0];
     if (SetIni.MCtype == -2)  s= SetIni.NTUPLES[1];
     if (SetIni.MCtype == -3)  s= SetIni.NTUPLES[2];
     MCField.setText(s); // set MC name




      tx1.setText(Integer.toString(SetIni.Nevents)); // set number of events



     // show summary
     int m1=Utility.GetID(SetIni.IDparticle1);
     int m2=Utility.GetID(SetIni.IDparticle2);
     String par1=SetIni.PIDname[m1];
     String par2=SetIni.PIDname[m2];
     String ssum1=par1+"("+Double.toString(SetIni.Energy1)+" GeV)";
     String ssum2=par2+"("+Double.toString(SetIni.Energy2)+" GeV)";
     String ssum=ssum1+"    "+ssum2;
     SetIni.ShowInitState=ssum;
     iniState.setText(ssum);

//      Highlighter hl = Dsummary.getHighlighter();
//      DefaultHighlighter.DefaultHighlightPainter hld =
//      new DefaultHighlighter.DefaultHighlightPainter(new java.awt.Color(100, 210, 213));
//      try { hl.addHighlight(0,6,hld); } catch (BadLocationException e) { };


// show output 
     String f1=SetIni.MOutput+".root";
     String f2=SetIni.MOutput+".htup";
     String f3=SetIni.MOutput+".rtup";
     String f2a="-//-.htup";
     String f3a="-//-.rtup";
     String outs="";
     int n1=SetIni.HistoOptions[9];
     int n2=SetIni.HistoOptions[10];
     int n3=SetIni.HistoOptions[11];
     if (n1 == 1 && n2 ==0 && n3 == 0 ) outs=f1;
     if (n1 == 1 && n2 ==1 && n3 == 0 ) outs=f1+", "+f2a;
     if (n1 == 1 && n2 ==0 && n3 == 1 ) outs=f1+", "+f3a;
     if (n1 == 1 && n2 ==1 && n3 == 1 ) outs=f1+", "+f2a+", "+f3a;
     if (n1 == 0 && n2 ==0 && n3 == 0 ) outs="none";
     if (n1 == 0 && n2 ==1 && n3 == 0 ) outs=f2;
     if (n1 == 0 && n2 ==0 && n3 == 1 ) outs=f3;
     if (n1 == 0 && n2 ==1 && n3 == 1 ) outs=f2+", "+f3a; 
     outFiles.setText(outs); 
     SetIni.ShowFout=outs;
//     Global.mainFrame.ShowFileOut(outs);
// histograms 
     SetIni.ShowHistoN=Integer.toString(SetIni.HistoN)+" histograms";

// final state
    String FSouts=SetIni.FS[SetIni.FStype-1];
    String Jetouts="none";
    if (SetIni.JetType == 1) Jetouts="none";
    if (SetIni.JetType == 2) Jetouts="Jade jets";
    if (SetIni.JetType == 3) Jetouts="Durham jets";
    if (SetIni.JetType == 4) Jetouts="Kt jets";
    String sumTEX=FSouts+"; jets: "+Jetouts;
    finState.setText(sumTEX);

// canvas option
//   String scan=SetIni.OPT2[SetIni.HistoOptions[1]-1];
//   canvasOut.setText(scan); 
 
   }


// show output

// update this pannel with new settings
     private void setMessage()  {
     String f1=SetIni.MOutput+".root";
     String f2=SetIni.MOutput+".htup";
     String f3=SetIni.MOutput+".rtup";
     String f2a="-//-.htup";
     String f3a="-//-.rtup";
     String outs="";
     int n1=SetIni.HistoOptions[9];
     int n2=SetIni.HistoOptions[10];
     int n3=SetIni.HistoOptions[11];
     if (n1 == 1 && n2 ==0 && n3 == 0 ) outs=f1;
     if (n1 == 1 && n2 ==1 && n3 == 0 ) outs=f1+", "+f2a;
     if (n1 == 1 && n2 ==0 && n3 == 1 ) outs=f1+", "+f3a;
     if (n1 == 1 && n2 ==1 && n3 == 1 ) outs=f1+", "+f2a+", "+f3a;
     if (n1 == 0 && n2 ==0 && n3 == 0 ) outs="none";
     if (n1 == 0 && n2 ==1 && n3 == 0 ) outs=f2;
     if (n1 == 0 && n2 ==0 && n3 == 1 ) outs=f3;
     if (n1 == 0 && n2 ==1 && n3 == 1 ) outs=f2+", "+f3a;
     SetIni.ShowFout=outs;
//     Global.mainFrame.ShowFileOut(outs);
     };



 

   } // end main class
