// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.
package JRunMC.ui;

import JRunMC.util.*;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.util.StringTokenizer;

 public class Tab1 extends JPanel {
     
  
     public static final long serialVersionUID = 101; 

     private static int MaxMC = 100;    
     private JTable jMCinstalled;
     private MyTableModelInfo myModel;
     private JPanel jtop; 
     private Timer timerProc;  // to run 
     private int delay = 0;   // delay for 5 sec.
     private int period = 2000;  // repeat every sec.
     private static boolean ichanged = false;
// 100 - max number of MC models
     private static int istatus[] = new int[MaxMC];
     private static int istatus_old[] = new int[MaxMC];
     private static int oldrowlocation=0;
     private static JPopupMenu menu;
     private static JMenuItem ikill;
 
  //  SetIni  SetIni = new SetIni();
    
    public Tab1() {
    this.setPreferredSize(new java.awt.Dimension(500, 250));
    this.setMinimumSize(new java.awt.Dimension(50, 50)); 
  
     this.setLayout( new BorderLayout() );
     JScrollPane JScrollPane1 = new JScrollPane();
     JScrollPane1.setMinimumSize(new Dimension(10, 24));

      jtop=new JPanel();
      jtop.setPreferredSize(new java.awt.Dimension(500,45));
      jtop.setMinimumSize(new java.awt.Dimension(50, 45));
      this.add(jtop,java.awt.BorderLayout.NORTH);
 
  
     JLabel about2 = new JLabel();
     about2.setPreferredSize(new java.awt.Dimension(500, 40));
     about2.setMinimumSize(new java.awt.Dimension(100, 10));
     if (SetEnv.RUNDIR.length()>2) { 
       about2.setText( SetEnv.RUNDIR ); 
     } else {
       about2.setForeground(new java.awt.Color(255, 0, 0));
       about2.setText("$RUNMC was not set - error");
     } 
     about2.setFont(SetEnv.FontBold);
     
     about2.setBorder(new TitledBorder(null,
                                   "Base directory:",TitledBorder.DEFAULT_JUSTIFICATION,
                                    TitledBorder.DEFAULT_POSITION, 
                                     new java.awt.Font("Dialog", 0, 12)));
          
    jtop.add(about2);


   myModel = new MyTableModelInfo();
   jMCinstalled = new JTable(myModel);
   jMCinstalled.setRowHeight(20);
   myModel.addColumn(ResourceLoader.getDisplay("ui.mcinstalled"));
   myModel.addColumn(ResourceLoader.getDisplay("ui.mcalias"));
   myModel.addColumn(ResourceLoader.getDisplay("ui.mcstatus"));

   jMCinstalled.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);


     // pop-up menu for table
    menu = new JPopupMenu();
    ikill = new JMenuItem("kill");
    menu.add(ikill);

// Set the component to show the popup menu
    jMCinstalled.addMouseListener(new MouseAdapter() {
        public void mousePressed(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
        public void mouseReleased(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                menu.show(evt.getComponent(), evt.getX(), evt.getY());
            }
        }
    });


  // kill
    ikill.addActionListener(new java.awt.event.ActionListener() {
    public void actionPerformed(java.awt.event.ActionEvent evt) {
    // kill

        int selected=jMCinstalled.getSelectedRow();
       //  System.out.println( selected );
        if (selected>-1) { 
  
         Object tmp1=jMCinstalled.getValueAt(selected, 0);
         Object tmp2=jMCinstalled.getValueAt(selected, 1);
         Object tmp3=jMCinstalled.getValueAt(selected, 2);

         String stmp1=tmp1.toString();
         String stmp2=tmp2.toString();
         String stmp3=tmp3.toString();


         if (stmp3.equals("idle")) {
         
          JOptionPane dialog1 = new JOptionPane();
           dialog1.showMessageDialog(dialog1,
           "This program "+stmp2+" (executable runmc."+stmp1+") is already in IDLE state",
             "Warning", JOptionPane.WARNING_MESSAGE);

          } else {

           String  mess="Kill process of "+stmp2+" (executable runmc."+stmp1+
           ")?\n To save output, you should use \"STOP\"  button instead!"; 
           JOptionPane dialog2 = new JOptionPane();
           int ask=dialog2.showConfirmDialog(dialog2,
           mess, "Question", JOptionPane.YES_NO_OPTION,
           JOptionPane.QUESTION_MESSAGE, null );
          if (ask == JOptionPane.YES_OPTION) {

            try {
  //  System.out.println("read status");
            String sh = "bash"; String cop = "-c";
            String cmd1 = "pkill runmc."+stmp1;
            String[] exe1 = new String[] {sh, cop, cmd1};
            Process p = Runtime.getRuntime().exec(exe1); // invoke shell
            } catch (Exception err) {
             err.printStackTrace();
            };
            // show message on GUI 
            Global.mainFrame.StopRunning();

           }
          } // end else

     } // non -1

     }  });



     // channge size
          TableColumn column = null;
          column = jMCinstalled.getColumnModel().getColumn(0);
          column.setPreferredWidth(150);
          column.setMinWidth(50);
          column.setMaxWidth(600);

          column = jMCinstalled.getColumnModel().getColumn(1);
          column.setPreferredWidth(150);
          column.setMinWidth(50);
          column.setMaxWidth(600);

          column = jMCinstalled.getColumnModel().getColumn(2);
          column.setPreferredWidth(80);
          column.setMinWidth(30);
          column.setMaxWidth(120);

// fill the table
           FillMCtable();
/*
         for (int i=0; i<SetMC.available.size();  i++) {
         String smc=(String)SetMC.available.elementAt(i);
         String salias=(String)SetMC.available_alias.elementAt(i);
         String status=(String)SetMC.status.elementAt(i);

         myModel.addRow(
                new Object[]{new String(smc), new String(salias),  new String(status) });
         }
*/

       JScrollPane1.getViewport().add(jMCinstalled);
       this.add(JScrollPane1,java.awt.BorderLayout.CENTER);


//   define timer for status checks 
//     istatus = new int[SetMC.available.size()];
//     istatus_old = new int[SetMC.available.size()];

//       istatus = new int[SetMC.available.size()];
//       istatus_old = new int[SetMC.available.size()];

     for (int i=0; i<MaxMC; i++) istatus[i]=0;
     for (int i=0; i<MaxMC; i++) istatus_old[i]=0;

     if (SetMC.available.size()>MaxMC-1) {
        System.out.println("Too many program files! More than 100 are not supported!");
        System.exit(0); 
      }; 



     timerProc = new Timer(period, taskCheckProc);
     timerProc.setInitialDelay(delay);
     timerProc.setRepeats(true);

 }


// timer task
  ActionListener taskCheckProc = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent eProc) {


     
    for (int i=0; i<MaxMC; i++) istatus[i]=0;

   //  System.out.println( SetMC.available.size() );

    try {
  //  System.out.println("read status");
    String sh = "bash"; String cop = "-c";       
    String cmd1 = "$RUNMC/main/scripts/show_process.sh";
    String[] exe1 = new String[] {sh, cop, cmd1};
    Process p = Runtime.getRuntime().exec(exe1); // invoke shell
    PrintWriter out = new PrintWriter(new BufferedWriter(
    new OutputStreamWriter(p.getOutputStream())));
    out.println("$RUNMC/main/scripts/show_process.sh"); // place commands here
    out.println("exit");
    out.flush();
    BufferedReader inp = new BufferedReader(
    new InputStreamReader(p.getInputStream()));

    String line;
    while ((line = inp.readLine()) != null) {
    if (line.length()>4) {
    //    System.out.println( line  );
        for (int i=0; i<SetMC.available.size();  i++) {
        String smc="runmc."+(String)SetMC.available.elementAt(i);
          if (line.indexOf(smc)>0) istatus[i]=1; 
        }

     }
    }
    inp.close();


// check status
    ichanged=false;
    for (int i=0; i<SetMC.available.size(); i++) {
        if (istatus_old[i] !=istatus[i] ) ichanged=true;
    }



      if (ichanged) { // only if status has changed

       
      for (int i=0; i<SetMC.available.size();  i++) {
        // copy new status

        if (istatus_old[i] != istatus[i] && istatus[i] == 1) {
           myModel.moveRow(i, i, 0);
           String status="<html><font color=#ee0000><b>running</b></font></html>"; 
           myModel.setValueAt(new String(status), 0, 2);
           oldrowlocation=i;
        } 

// if not active put to old location  
       if (istatus_old[i] != istatus[i] && istatus[i] == 0) {
            String status="idle"; 
            myModel.moveRow(0, 0, oldrowlocation);
            myModel.setValueAt(new String(status), oldrowlocation, 2);
        }


        istatus_old[i]=istatus[i];
        }


      } // endif


    // retrieve data from standard output stream
    } catch (Exception err) {
     err.printStackTrace();
     };

    }; }; 



public void StartTimer() {
    timerProc.start();
 }   


public void StopTimer() {
    timerProc.stop();
 }



// fill table 
public void FillMCtable() {


         // check for MC 
         SetMC.FillMCexe();
         // clear
         myModel.setRowCount(0);

         // fill table
         for (int i=0; i<SetMC.available.size();  i++) {
         String smc=(String)SetMC.available.elementAt(i);
         String salias=(String)SetMC.available_alias.elementAt(i);
         String status=(String)SetMC.status.elementAt(i);
         myModel.addRow(
                new Object[]{new String(smc), new String(salias),  new String(status) });
         }

   
}




     
  } // end main class
