CDECK  ID>, HWEGAM.
*CMZ :-        -26/04/91  11.11.55  by  Bryan Webber
*-- Author :    Bryan Webber & Luca Stanco
C-----------------------------------------------------------------------
      SUBROUTINE HWEGAM(IHEP,ZMI,ZMA,WWA)
C-----------------------------------------------------------------------
C     GENERATES A PHOTON IN WEIZSACKER-WILLIAMS (WWA=.TRUE.) OR
C     ELSE EQUIVALENT PHOTON APPROX FROM INCOMING E+, E-, MU+ OR MU-
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION HWRGEN,HWRUNI,EGMIN,ZMIN,ZMAX,ZGAM,SS,ZMI,ZMA,
     & PPL,PMI,QT2,Q2,QQMIN,QQMAX,S0,A
      INTEGER IHEP,IHADIS
      LOGICAL WWA
      EXTERNAL HWRGEN,HWRUNI
      DATA EGMIN/5.D0/
      IF (IERROR.NE.0)  RETURN
      IF (IHEP.LT.1.OR.IHEP.GT.2) CALL HWWARN('HWEGAM',500,*999)
      SS=PHEP(5,3)
      IF (IHEP.EQ.1) THEN
        IHADIS=2
      ELSE
        IHADIS=1
        IF (JDAHEP(1,IHADIS).NE.0) IHADIS=JDAHEP(1,IHADIS)
      ENDIF
C---DEFINE LIMITS FOR GAMMA MOMENTUM FRACTION
      IF (ZMI.LE.ZERO .OR. ZMA.GT.ONE) THEN
        CALL HWEGAS(S0)
        IF (S0.GT.ZERO) THEN
          S0 = (SQRT(S0)+ABS(PHEP(5,IHADIS)))**2-PHEP(5,IHADIS)**2
          S0 = MAX(S0,WHMIN**2)
          ZMIN = S0 / (SS**2 - PHEP(5,IHEP)**2 - PHEP(5,IHADIS)**2)
          ZMAX = ONE
        ELSE
C---UNKNOWN PROCESS: USE ENERGY CUTOFF, AND WARN USER
          IF (FSTWGT) CALL HWWARN('HWEGAM',1,*999)
          ZMIN = EGMIN / PHEP(4,IHEP)
          ZMAX = ONE
        ENDIF
      ELSE
        ZMIN=ZMI
        ZMAX=ZMA
      ENDIF
C---APPLY USER DEFINED CUTS YWWMIN,YWWMAX AND INDIRECT LIMITS ON Z
      IF (.NOT.WWA) THEN
        ZMIN=MAX(ZMIN,YWWMIN,SQRT(Q2WWMN)/ABS(PHEP(3,IHEP)))
        ZMAX=MIN(ZMAX,YWWMAX)
      ELSE
        ZMAX=MIN(ZMAX,1-PHEP(5,IHEP)/PHEP(4,IHEP))
      ENDIF
      IF (ZMIN.GE.ZMAX) THEN
        GAMWT=ZERO
        RETURN
      ENDIF
C---GENERATE GAMMA MOMENTUM FRACTION
      A=HALF
 10   IF (HWRGEN(2).LT.A) THEN
        ZGAM=(ZMIN/ZMAX)**HWRGEN(1)*ZMAX
      ELSE
        ZGAM=(ZMAX-ZMIN)*HWRGEN(1)+ZMIN
      ENDIF
      GAMWT = GAMWT * .5*ALPHEM/PIFAC *
     +     (1+(1-ZGAM)**2)/(A/LOG(ZMAX/ZMIN)+(1-A)/(ZMAX-ZMIN)*ZGAM)
      IF (WWA) THEN
        GAMWT = GAMWT * LOG((ONE-ZGAM)/ZGAM*(SS/PHEP(5,IHEP))**2)
      ELSE
C---Q2WWMN AND Q2WWMX ARE USER-DEFINED LIMITS IN THE Q**2 INTEGRATION
        QQMAX=MIN(Q2WWMX,(ZGAM*PHEP(3,IHEP))**2)
        QQMIN=MAX(Q2WWMN,(PHEP(5,IHEP)*ZGAM)**2/(1.-ZGAM))
        IF (QQMIN.GT.QQMAX) CALL HWWARN('HWEGAM',50,*10)
        Q2=EXP(HWRUNI(0,LOG(QQMIN),LOG(QQMAX)))
        GAMWT = GAMWT * LOG(QQMAX/QQMIN)
      ENDIF
      IF (GAMWT.LT.ZERO) GAMWT=ZERO
C---FILL PHOTON
      NHEP=NHEP+1
      IDHW(NHEP)=59
      ISTHEP(NHEP)=3
      IDHEP(NHEP)=22
      JMOHEP(1,NHEP)=IHEP
      JMOHEP(2,NHEP)=0
      JDAHEP(1,NHEP)=0
      JDAHEP(2,NHEP)=0
      JDAHEP(1,IHEP)=NHEP
      IF (WWA) THEN
C---FOR COLLINEAR KINEMATICS, ZGAM IS THE ENERGY FRACTION
        PHEP(4,NHEP)=PHEP(4,IHEP)*ZGAM
        PHEP(3,NHEP)=PHEP(3,IHEP)-SIGN(SQRT(
     &     (PHEP(4,IHEP)-PHEP(4,NHEP))**2-PHEP(5,IHEP)**2),PHEP(3,IHEP))
        PHEP(2,NHEP)=0
        PHEP(1,NHEP)=0
        CALL HWUMAS(PHEP(1,NHEP))
      ELSE
C---FOR EXACT KINEMATICS, ZGAM IS TAKEN TO BE FRACTION OF (E+PZ)
        PPL=ZGAM*(ABS(PHEP(3,IHEP))+PHEP(4,IHEP))
        QT2=(ONE-ZGAM)*Q2-(ZGAM*PHEP(5,IHEP))**2
        PMI=(QT2-Q2)/PPL
        PHEP(5,NHEP)=-SQRT(Q2)
        PHEP(4,NHEP)=(PPL+PMI)/TWO
        PHEP(3,NHEP)=SIGN((PPL-PMI)/TWO,PHEP(3,IHEP))
        CALL HWRAZM(SQRT(QT2),PHEP(1,NHEP),PHEP(2,NHEP))
      ENDIF
C---UPDATE OVERALL CM FRAME
      JMOHEP(IHEP,3)=NHEP
      CALL HWVDIF(4,PHEP(1,3),PHEP(1,IHEP),PHEP(1,3))
      CALL HWVSUM(4,PHEP(1,NHEP),PHEP(1,3),PHEP(1,3))
      CALL HWUMAS(PHEP(1,3))
C---FILL OUTGOING LEPTON
      NHEP=NHEP+1
      IDHW(NHEP)=IDHW(IHEP)
      ISTHEP(NHEP)=1
      IDHEP(NHEP)=IDHEP(IHEP)
      JMOHEP(1,NHEP)=IHEP
      JMOHEP(2,NHEP)=0
      JDAHEP(1,NHEP)=0
      JDAHEP(2,NHEP)=0
      JDAHEP(2,IHEP)=NHEP
      CALL HWVDIF(4,PHEP(1,IHEP),PHEP(1,NHEP-1),PHEP(1,NHEP))
      PHEP(5,NHEP)=PHEP(5,IHEP)
 999  END
CDECK  ID>, HWEGAS.
*CMZ :-        -18/04/04  10.45.55  by  Mike Seymour
*-- Author :    Bryan Webber & Luca Stanco
C-----------------------------------------------------------------------
      SUBROUTINE HWEGAS(S0)
C-----------------------------------------------------------------------
C     FIND MINIMUM INVARIANT MASS SQUARED NEEDED FOR HARD PROCESS, S0
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION S0,RPM(2)
      INTEGER HQ,I
      IF (IPRO.EQ.13.OR.IPRO.EQ.14) THEN
        S0 = EMMIN**2
      ELSEIF(IPRO.EQ.15.OR.IPRO.EQ.18.OR.IPRO.EQ.22.OR.IPRO.EQ.24.OR.
     &       IPRO.EQ.50.OR.IPRO.EQ.53.OR.IPRO.EQ.55)THEN
        S0 = 4.D0*PTMIN**2
      ELSEIF (IPRO.EQ.17.OR.IPRO.EQ.51) THEN
        HQ = MOD(IPROC,100)
        S0 = 4.D0*(PTMIN**2+RMASS(HQ)**2)
      ELSEIF (IPRO.EQ.16.OR.IPRO.EQ.19.OR.
     &       IPRO.EQ.25.OR.IPRO.EQ.26.OR.IPRO.EQ.27.OR.
     &       IPRO.EQ.95) THEN
        S0 = MAX(2*RMASS(1),RMASS(201)-GAMMAX*GAMH)**2
      ELSEIF ((IPRO.EQ.31).OR.(IPRO.EQ.32)) THEN
        S0 = MAX(2*RMASS(1),RMASS(201+IHIGGS))**2
      ELSEIF (IPRO.EQ.33) THEN
        IF((MOD(IPROC,10000).EQ.3350).OR.
     &       (MOD(IPROC,10000).EQ.3355))THEN
          S0 = MAX(2*RMASS(1),RMASS(206))**2
        ELSEIF(MOD(IPROC,10000).EQ.3315)THEN
          S0 = MAX(2*RMASS(1),RMASS(206),RMASS(203))**2
        ELSEIF(MOD(IPROC,10000).EQ.3325)THEN
          S0 = MAX(2*RMASS(1),RMASS(206),RMASS(204))**2
        ELSEIF(MOD(IPROC,10000).EQ.3335)THEN
          S0 = MAX(2*RMASS(1),RMASS(206),RMASS(205))**2
        ELSEIF(MOD(IPROC,10000).EQ.3365)THEN
          S0 = MAX(2*RMASS(1),RMASS(205),RMASS(203))**2
        ELSEIF(MOD(IPROC,10000).EQ.3375)THEN
          S0 = MAX(2*RMASS(1),RMASS(205),RMASS(204))**2
        ELSE
          S0 = MAX(2*RMASS(1),RMASS(201+IHIGGS))**2
        END IF
      ELSEIF ((IPRO.EQ.34).OR.(IPRO.EQ.35)) THEN
        S0 = MAX(RMASS(5),RMASS(201+IHIGGS))**2
      ELSEIF (IPRO.EQ.36.OR.IPRO.EQ.37) THEN
        S0 = MAX(2*RMASS(1),RMASS(201+IHIGGS))**2
      ELSEIF (IPRO.EQ.38) THEN
        IF((MOD(IPROC,10000).EQ.3839).OR.
     &       (MOD(IPROC,10000).EQ.3869).OR.
     &       (MOD(IPROC,10000).EQ.3899))THEN
          S0 = MAX(RMASS(6),RMASS(206))**2
        ELSE
          S0 = RMASS(201+IHIGGS)**2
        END IF
      ELSEIF (IPRO.EQ.23) THEN
        S0 = MAX(2*RMASS(1),RMASS(201)-GAMMAX*GAMH)**2
        S0 = (PTMIN+SQRT(PTMIN**2+S0))**2
      ELSEIF (IPRO.EQ.20) THEN
        S0 = RMASS(6)**2
      ELSEIF (IPRO.EQ.21) THEN
        S0 = (PTMIN+SQRT(PTMIN**2+RMASS(198)**2))**2
C--PR MOD 7/7/99
      ELSEIF (IPRO.EQ.30) THEN
        S0 = 4.0D0*(PTMIN**2+RMMNSS**2)
      ELSEIF(IPRO.EQ.40.OR.IPRO.EQ.41) THEN
        HQ = MOD(IPROC,100)
        RPM(1) = RMMNSS
        RPM(2) = ZERO
        IF(HQ.GE.10.AND.HQ.LT.20) THEN
          RPM(1) = ABS(RMASS(450))
          IF(HQ.GT.10) RPM(1) = ABS(RMASS(449+MOD(HQ,10)))
        ELSEIF(HQ.GE.20.AND.HQ.LT.30) THEN
          RPM(1) = ABS(RMASS(454))
          IF(HQ.GT.20) RPM(1) = ABS(RMASS(453+MOD(HQ,20)))
        ELSEIF(HQ.EQ.30) THEN
          RPM(1) = RMASS(449)
        ELSEIF(HQ.EQ.40) THEN
          IF(IPRO.EQ.40) THEN
            RPM(1) = RMASS(425)
            DO I=1,5
              RPM(1) = MIN(RPM(1),RMASS(425+I))
            ENDDO
          ELSE
            RPM(1) = MIN(RMASS(405),RMASS(406))
          ENDIF
          RPM(2) = RMASS(198)
        ELSEIF(HQ.EQ.50) THEN
          IF(IPRO.EQ.40) THEN
            RPM(1) = RMASS(425)
            DO I=1,5
              RPM(1) = MIN(RPM(1),RMASS(425+I))
            ENDDO
            DO I=1,3
              RPM(2) = MIN(RPM(1),RMASS(433+2*I))
            ENDDO
            RPM(1) = MIN(RPM(1),RPM(2))
            RPM(2) = RMASS(203)
            DO I=1,2
              RPM(2) = MIN(RPM(2),RMASS(204+I))
            ENDDO
          ELSE
            RPM(1) = RMASS(401)
            RPM(2) = RMASS(413)
            DO I=1,5
              RPM(1) = MIN(RPM(1),RMASS(401+I))
              RPM(2) = MIN(RPM(2),RMASS(413+I))
            ENDDO
            RPM(1) = MIN(RPM(1),RPM(2))
            RPM(2) = RMASS(203)
            DO I=1,2
              RPM(2) = MIN(RPM(2),RMASS(204+I))
            ENDDO
          ENDIF
          RPM(2) = RMASS(203)
          DO I=1,2
            RPM(2) = MIN(RPM(2),RMASS(204+I))
          ENDDO
        ELSEIF(HQ.GE.60) THEN
          RPM(1) = ZERO
        ENDIF
        RPM(1) = RPM(1)**2
        RPM(2) = RPM(2)**2
        S0 = RPM(1)+RPM(2)+TWO*(PTMIN**2+
     &       SQRT(RPM(1)*RPM(2)+PTMIN**2*(RPM(1)+RPM(2)+PTMIN**2)))
C--end of mod
C--PR MOD 9/9/00
      ELSEIF (IPRO.EQ.42) THEN
        S0 = EMMIN**2
      ELSEIF (IPRO.EQ.52) THEN
        HQ = MOD(IPROC,100)
        S0 = (PTMIN+SQRT(PTMIN**2+RMASS(HQ)**2))**2
      ELSEIF (IPRO.EQ.60) THEN
        HQ = MOD(IPROC,100)
        IF (HQ.EQ.0) THEN
          S0 = 4.D0*PTMIN**2
        ELSE
          IF (HQ.GT.6) HQ=2*HQ+107
          IF (HQ.EQ.127) HQ=198
          S0 = 4.D0*(PTMIN**2+RMASS(HQ)**2)
        ENDIF
      ELSEIF (IPRO.EQ.80) THEN
        S0 = WHMIN**2
      ELSEIF (IPRO.EQ.90) THEN
        S0 = Q2MIN
      ELSEIF (IPRO.EQ.91.OR.IPRO.EQ.92) THEN
        S0 = Q2MIN+4.D0*PTMIN**2
        HQ = MOD(IPROC,100)
        IF (HQ.GT.0) S0 = S0+4.D0*RMASS(HQ)**2
        IF (IPRO.EQ.91) S0 = MAX(S0,EMMIN**2)
      ELSE
        S0 = 0
      ENDIF
      END
