CDECK  ID>, HWUEEC.
*CMZ :-        -26/04/91  14.22.30  by  Federico Carminati
*-- Author :    Bryan Webber and Ian Knowles
C-----------------------------------------------------------------------
      SUBROUTINE HWUEEC(IL)
C-----------------------------------------------------------------------
C     Loads cross-section coefficients, for kinematically open channels,
C     in llbar-->qqbar; lepton label IL=1-6: e,nu_e,mu,nu_mu,tau,nu_tau.
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      DOUBLE PRECISION Q2
      INTEGER IL,JL,IQ
      Q2=EMSCA**2
      JL=IL+10
      MAXFL=0
      TQWT=0.
      DO 10 IQ=1,NFLAV
      IF (EMSCA.GT.2.*RMASS(IQ)) THEN
         MAXFL=MAXFL+1
         MAPQ(MAXFL)=IQ
         CALL HWUCFF(JL,IQ,Q2,CLQ(1,MAXFL))
         TQWT=TQWT+CLQ(1,MAXFL)
      ENDIF
  10  CONTINUE
      IF (MAXFL.EQ.0) CALL HWWARN('HWUEEC',100,*999)
  999 END
CDECK  ID>, HWUEMV.
*CMZ :-        -30/06/94  19.31.08  by  Mike Seymour
*-- Author :    Mike Seymour
C-----------------------------------------------------------------------
      SUBROUTINE HWUEMV(N,IFROM,ITO)
C-----------------------------------------------------------------------
C     MOVE A BLOCK OF ENTRIES IN THE EVENT RECORD
C     N ENTRIES IN HEPEVT STARTING AT IFROM ARE MOVED TO AFTER ITO
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER N,IFROM,ITO,IMAP(0:NMXHEP),LFROM,LTO,I,IEDT(NMXHEP),IHEP,
     $ JHEP,KHEP
      COMMON /HWUMAP/IMAP
      LFROM=IFROM
      LTO=ITO
      DO 100 I=1,N
 100  IEDT(I)=LTO
      CALL HWUEDT(-N,IEDT)
      DO 300 I=1,N
        IHEP=LTO+I
        JHEP=IMAP(LFROM+I-1)
        ISTHEP(IHEP)=ISTHEP(JHEP)
        IDHW(IHEP)=IDHW(JHEP)
        IDHEP(IHEP)=IDHEP(JHEP)
        JMOHEP(1,IHEP)=JMOHEP(1,JHEP)
        JMOHEP(2,IHEP)=JMOHEP(2,JHEP)
        JDAHEP(1,IHEP)=JDAHEP(1,JHEP)
        JDAHEP(2,IHEP)=JDAHEP(2,JHEP)
        CALL HWVEQU(5,PHEP(1,JHEP),PHEP(1,IHEP))
        CALL HWVEQU(4,VHEP(1,JHEP),VHEP(1,IHEP))
        DO 200 KHEP=1,NHEP
          IF (JMOHEP(1,KHEP).EQ.JHEP) JMOHEP(1,KHEP)=IHEP
          IF (JMOHEP(2,KHEP).EQ.JHEP) JMOHEP(2,KHEP)=IHEP
          IF (JDAHEP(1,KHEP).EQ.JHEP) JDAHEP(1,KHEP)=IHEP
          IF (JDAHEP(2,KHEP).EQ.JHEP) JDAHEP(2,KHEP)=IHEP
 200    CONTINUE
        IEDT(I)=JHEP
 300  CONTINUE
      CALL HWUEDT(N,IEDT)
 999  END
CDECK  ID>, HWUEPR.
*CMZ :-        -27/07/99  13.33.03  by  Mike Seymour
*-- Author :    Ian Knowles, Bryan Webber & Kosuke Odagiri
C-----------------------------------------------------------------------
      SUBROUTINE HWUEPR
C-----------------------------------------------------------------------
C     Prints out event data in a number of possible formats:
C     If (PRNDEF) ASCII to stout
C     If (PRNTEX) LaTeX to the file HWEV_*******.tex
C                 Please check paper size and offsets given in mm
C                 Uses the package longtable.sty
C                 If (PRVTX>OR.NPRFMT.EQ.2) designed to be printed
C                 as landscape
C     If (PRNWEB) HTML  to the file HWEV_*******.html
C                 Call HWUDPR to create particle property files in
C                 the subdirectory HW_decays/
C     ******* gives the event number 0000001 etc.
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      INTEGER MMWIDE,MMLONG,MMHOFF,MMVOFF,I,IST,IS,ID,MS,J,K,IUNITW,
     & IUNITT
      CHARACTER*1 Z
      CHARACTER*2 ZZ
      CHARACTER*6 BGCOLS(5),TBCOLS(3),THEAD(17,3)
      CHARACTER*7 HWUNST,TMPNME
      CHARACTER*16 FNAMET
      CHARACTER*17 FNAMEW
      CHARACTER*27 FNAMEP
      CHARACTER*28 TITLE(11),SECTXT
      LOGICAL FIRST(11),NEWSEC
      COMMON/PAPER/MMWIDE,MMLONG,MMHOFF,MMVOFF
      EXTERNAL HWUNST
C
      DATA BGCOLS/'ffffff','0000aa','aa0000','00aa00','aa00ff'/
      DATA TBCOLS/'ccccff','9966ff','ffff00'/
      DATA THEAD/ 17*'9966ff',17*'ffff00',
     &            'IHEP  ','  ID  ',' IDPDG',' IST  ',' MO1  ',' MO2  ',
     &            ' DA1  ',' DA2  ',' P-X  ',' P-Y  ',' P-Z  ','ENERGY',
     &            ' MASS ',' V-X  ',' V-Y  ',' V-Z  ',' V-C*T'/
      DATA TITLE/'     ---INITIAL STATE---    ',
     &           '    ---HARD SUBPROCESS---   ',
     &           '    ---PARTON SHOWERS---    ',
     &           '    ---GLUON SPLITTING---   ',
     &           '   ---CLUSTER FORMATION---  ',
     &           '    ---CLUSTER DECAYS---    ',
     &           ' ---STRONG HADRON DECAYS--- ',
     &           ' ---HEAVY PARTICLE DECAYS---',
     &           '  ---H/W/Z BOSON DECAYS---  ',
     &           ' ---SOFT UNDERLYING EVENT---',
     &           '  ---MULTIPLE SCATTERING--- '/
      Z=CHAR(92)
      ZZ=Z//Z
C
      IUNITT=50
      IUNITW=51
C Write out any required file header information
      TMPNME=HWUNST(NEVHEP)
      IF (PRNTEX) THEN
        WRITE(FNAMET,'(A5,A7,A4)') 'HWEV_',TMPNME,'.tex'
        OPEN(IUNITT,STATUS='UNKNOWN',FILE=FNAMET)
        IF (PRVTX.OR.NPRFMT.EQ.2) THEN
          WRITE(IUNITT,10) Z,Z,Z,MMLONG,Z,MMWIDE,Z,MMVOFF,Z,MMHOFF,Z,Z,Z
        ELSE
          WRITE(IUNITT,10) Z,Z,Z,MMWIDE,Z,MMLONG,Z,MMHOFF,Z,MMVOFF,Z,Z,Z
        ENDIF
      ENDIF
      IF (PRNWEB) THEN
        WRITE(FNAMEW,'(A5,A7,A5)') 'HWEV_',TMPNME,'.html'
        OPEN(IUNITW,STATUS='UNKNOWN',FILE=FNAMEW)
        WRITE(IUNITW,20) BGCOLS
      ENDIF
   10 FORMAT(A1,'documentclass{article}'/A1,'usepackage{longtable}'/
     & A1,'textwidth ',I4,'mm ',A1,'textheight ',I4,'mm'/
     & A1,'hoffset   ',I4,'mm ',A1,'voffset    ',I4,'mm'/
     & A1,'pagestyle{empty}'/A1,'begin{document}'/A1,'begin{center}')
   20 FORMAT('<!-- No Less productions -->'/'<HTML>'/'<HEAD>'/
     & '<TITLE>HERWIG Event Record</TITLE>'/'</HEAD>'/
     & '<BODY BGCOLOR=#',A6,' TEXT=#',A6,' LINK=#',A6,
     & ' ALINK=#',A6,' VLINK=#',A6,'>')
C Write out event header details and set up tables
      IF (PRNDEF) THEN
        WRITE(6,30) NEVHEP,PBEAM1,PART1,PBEAM2,PART2,
     &   IPROC,NRN,ISTAT,IERROR,EVWGT
      ENDIF
      IF (PRNTEX) THEN
        WRITE(IUNITT,40) Z,Z,Z,ISTAT,ZZ,Z,
     &   IPROC,PBEAM1,PBEAM2,NRN(1),
     &   IERROR,ZZ,Z,Z,NEVHEP,TXNAME(1,IDHW(1)),TXNAME(1,IDHW(2)),
     &   NRN(2),EVWGT,ZZ,Z,Z,Z
        IF (PRVTX) THEN
          WRITE(IUNITT,50) Z,Z,Z,Z,Z
        ELSE
          WRITE(IUNITT,60) Z,Z,Z,Z,Z
        ENDIF
      ENDIF
      IF (PRNWEB) THEN
        WRITE(IUNITW,70) TBCOLS(1),TBCOLS(2),(TBCOLS(2),TBCOLS(3),
     &   I=1,4),ISTAT,TBCOLS(2),TBCOLS(3),
     &   IPROC,PBEAM1,PBEAM2,NRN(1),
     &   TBCOLS(2),TBCOLS(3),IERROR
        WRITE(IUNITW,71) TBCOLS(2),TBCOLS(3),NEVHEP,TXNAME(2,IDHW(1)),
     &   TXNAME(2,IDHW(2)),NRN(2),TBCOLS(2),TBCOLS(3),EVWGT,TBCOLS(1)
      ENDIF
   30 FORMAT(///1X,'EVENT ',I7,':',F8.2,' GEV/C ',A8,' ON ',F8.2,
     & ' GEV/C ',A8,' PROCESS:',I6/1X,'SEEDS: ',I11,' & ',I11,
     & '   STATUS: ',I4,' ERROR:',I4,'  WEIGHT: ',1P,E11.4/)
   40 FORMAT(A1,'begin{tabular}{|l|r|c|c|r|l|c|}'/A1,'hline'/
     & A1,'multicolumn{2}{|c|}{HERWIG 6.0} & Beam 1: & Beam 2: & ',
     & 'Seeds: & Status: & ',I4, ' ',A2/A1,'hline'/'Process: & ',I6,
     & ' & ',F8.2,'~GeV/c & ',F8.2,'~GeV/c',' & ',I11,' & Error: & ',
     & I4,' ',A2/A1,'cline{1-2} ',A1,'cline{6-7}'/'Event: & ',I7,' & ',
     & A37,' & ',A37,' & ',I11,' & Weight: & ',1P,E11.4,' ',A2/A1,
     & 'hline'/A1,'end{tabular}'/A1,'vskip 5mm')
   50 FORMAT(A1,'begin{longtable}{|r|c|r|r|r|r|r|r|r|r|r|r|r|r|r|r|r|}'/
     & A1,'hline'/A1,'endhead'/A1,'hline'/A1,'endfoot')
   60 FORMAT(A1,'begin{longtable}{|r|c|r|r|r|r|r|r|r|r|r|r|r|}'/
     & A1,'hline'/A1,'endhead'/A1,'hline'/A1,'endfoot')
   70 FORMAT(/'<CENTER>'/'<TABLE ALIGN="CENTER" BGCOLOR=#',A6,'>'/
     & '<TR>'/'<TH BGCOLOR=#',A6,' COLSPAN=2>',
     & '<A HREF="http://hepwww.rl.ac.uk/theory/seymour/herwig/">',
     & 'HERWIG 6.0</A></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Beam 1:</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Beam 2:</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,'><FONT COLOR=#',A6,'>Seeds:</FONT></TH>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="LEFTT"><FONT COLOR=#',A6,
     & '>Status:</FONT></TH>'/'<TD ALIGN="RIGHT">',I4,'</TD>'/'</TR>'/
     & '<TR>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="LEFTT"><FONT COLOR=#',A6,
     & '>Process:</Th>'/'<TD>',I6,'</TD>'/
     & '<TD>',F8.2,' GeV/c</TD>'/'<TD>',F8.2,' GeV/c</TD>'/
     & '<TD ALIGN="RIGHT">',I11,'</TD>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="LEFT"><FONT COLOR=#',A6,
     & '>Error:</FONT></TH>'/'<TD ALIGN="RIGHT">',I4,'</TD>'/'</TR>')
   71 FORMAT('<TR>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="LEFT"><FONT COLOR=#',A6,
     & '>Event:</Th>'/'<TD ALIGN="RIGHT">',I7,'</TD>'/
     & '<TD ALIGN="CENTER">',A37,'</TD>'/
     & '<TD ALIGN="CENTER">',A37,'</TD>'/
     & '<TD ALIGN="RIGHT">',I11,'</TD>'/
     & '<TH BGCOLOR=#',A6,' ALIGN="LEFT"><FONT COLOR=#',A6,
     & '>Weight:</FONT></TH>'/'<TD>',1P,E11.4,'</TD>'/'</TR>'/
     & '</TABLE>'//'<P>'/
     & '<TABLE ALIGN="CENTER" BGCOLOR=#',A6,'>')
C Initialize control flags
      DO 80 I=1,11
   80 FIRST(I)=.TRUE.
C Loop through event record
      DO 410 I=1,NHEP
      NEWSEC=.FALSE.
C First find start of new sections
      IST=ISTHEP(I)
      IS=IST/10
      ID=IDHW(I)
      IF (IST.EQ.101) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(1)
      ELSEIF (FIRST(2).AND.IS.EQ.12) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(2)
        FIRST(2)=.FALSE.
      ELSEIF (FIRST(3).AND.IS.EQ.14) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(3)
        FIRST(3)=.FALSE.
        FIRST(8)=.TRUE.
        FIRST(9)=.TRUE.
        FIRST(11)=.TRUE.
      ELSEIF (FIRST(4).AND.IST.GE.158.AND.IST.NE.160
     &                .AND.IST.LE.162) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(4)
        FIRST(4)=.FALSE.
      ELSEIF (FIRST(5).AND.(IS.EQ.16.OR.IS.EQ.18)
     &                .AND.IST.GT.162) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(5)
        FIRST(5)=.FALSE.
      ELSEIF (IS.EQ.19.OR.IST.EQ.1.OR.IST.EQ.200) THEN
        MS=ISTHEP(JMOHEP(1,I))/10
        IF (MS.EQ.15.OR.MS.EQ.16.OR.MS.EQ.18) THEN
          IF (FIRST(6)) THEN
            NEWSEC=.TRUE.
            SECTXT=TITLE(6)
            FIRST(6)=.FALSE.
          ENDIF
        ELSEIF (FIRST(7).AND.(.NOT.FIRST(6))) THEN
          NEWSEC=.TRUE.
          SECTXT=TITLE(7)
          FIRST(7)=.FALSE.
        ENDIF
      ELSEIF (FIRST(8).AND.(IST.EQ.125.OR.IST.EQ.155.OR.
     &        (IST.EQ.123.AND.ISTHEP(JMOHEP(1,I)).EQ.199))) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(8)
        FIRST(3)=.TRUE.
        FIRST(4)=.TRUE.
        FIRST(5)=.TRUE.
        FIRST(6)=.TRUE.
        FIRST(7)=.TRUE.
        FIRST(8)=.FALSE.
      ELSEIF (FIRST(9).AND.(IST.EQ.123.OR.IST.EQ.124)) THEN
        MS=ABS(IDHEP(JMOHEP(1,I)))
        IF (MS.EQ.23.OR.MS.EQ.24.OR.MS.EQ.25) THEN
          NEWSEC=.TRUE.
          SECTXT=TITLE(9)
          FIRST(3)=.TRUE.
          FIRST(4)=.TRUE.
          FIRST(5)=.TRUE.
          FIRST(6)=.TRUE.
          FIRST(7)=.TRUE.
          FIRST(8)=.TRUE.
          FIRST(9)=.FALSE.
        ENDIF
      ELSEIF (IST.EQ.170) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(10)
      ELSEIF (FIRST(11).AND.(ID.EQ.71.OR.ID.EQ.72)) THEN
        NEWSEC=.TRUE.
        SECTXT=TITLE(11)
        FIRST(3)=.TRUE.
        FIRST(11)=.FALSE.
      ENDIF
C Prit out section heading
      IF (NEWSEC) THEN
        IF (PRVTX) THEN
          IF (PRNDEF) THEN
            IF (NPRFMT.EQ.1) THEN
              WRITE(6, 90) SECTXT,(THEAD(J,3),J=1,17)
            ELSE
              WRITE(6,100) SECTXT,(THEAD(J,3),J=1,17)
            ENDIF
          ENDIF
          IF (PRNTEX) WRITE(IUNITT,110) Z,Z,SECTXT,ZZ,Z,
     &     (Z,THEAD(J,3),J=1,17),ZZ,Z
          IF (PRNWEB) WRITE(IUNITW,120) TBCOLS(2),TBCOLS(3),
     &     SECTXT,((THEAD(K,J),J=1,3),K=1,17)
   90     FORMAT(/46X,A28//1X,A4,2X,A6,3X,A6,5A4,3(2X,A6),A6,3X,A5,
     &     4(4X,A6))
  100     FORMAT(/58X,A28//1X,A4,2X,A6,3X,A6,5A4,3(6X,A6),5X,A6,8X,A5,
     &     4X,A6,2(5X,A6),6X,A6)
  110     FORMAT(A1,'hline'/A1,'multicolumn{17}{|c|}{',A28,'} ',A2/A1,
     &     'hline'/16(A1,'multicolumn{1}{|c|}{',A6,'} & '),
     &     A1,'multicolumn{1}{|c|}{',A6,'} ',A2/A1,'hline')
  120     FORMAT('<TR><TH COLSPAN=17 BGCOLOR=#',A6,'>',
     &     '<FONT COLOR=#',A6,'>',A28,'</FONT></TH></TR>'/
     &     '<TR>',17(/,1X,'<TH BGCOLOR=#',A6,'>
     &     <FONT COLOR=',A6,'>',A6,'</FONT></TH>'),'</TR>')
        ELSE
          IF (PRNDEF) THEN
            IF (NPRFMT.EQ.1) THEN
              WRITE(6,130) SECTXT,(THEAD(J,3),J=1,13)
            ELSE
              WRITE(6,140) SECTXT,(THEAD(J,3),J=1,13)
            ENDIF
          END IF
          IF (PRNTEX) WRITE(IUNITT,150) Z,Z,SECTXT,ZZ,Z,
     &     (Z,THEAD(J,3),J=1,13),ZZ,Z
          IF (PRNWEB) WRITE(IUNITW,160) TBCOLS(2),TBCOLS(3),
     &     SECTXT,((THEAD(K,J),J=1,3),K=1,13)
  130     FORMAT(/26X,A28//1X,A4,2X,A6,3X,A6,5A4,3(2X,A6),A6,3X,A5)
  140     FORMAT(/36X,A28//1X,A4,2X,A6,3X,A6,5A4,3(6X,A6),5X,A6,8X,A5)
  150     FORMAT(A1,'hline'/A1,'multicolumn{13}{|c|}{',A28,'} ',A2/A1,
     &     'hline'/12(A1,'multicolumn{1}{|c|}{',A6,'} & '),
     &     A1,'multicolumn{1}{|c|}{',A6,'} ',A2/A1,'hline')
  160     FORMAT('<TR><TH COLSPAN=13 BGCOLOR=#',A6,'>',
     &     '<FONT COLOR=#',A6,'>',A28,'</FONT></TH></TR>'/
     &     '<TR>',13(/'<TH BGCOLOR=#',A6,'>',
     &     '<FONT COLOR=#',A6,'>',A6,'</FONT></TH>'),'</TR>')
        ENDIF
      ENDIF
C Now print out the data line
      IF (PRVTX) THEN
C     Include vertex information
        IF (PRNDEF) THEN
          IF (PRNDEC) THEN
            IF (NPRFMT.EQ.1) THEN
              WRITE(6,190) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4)
            ELSE
              WRITE(6,200) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4)
            ENDIF
          ELSE
            IF (NPRFMT.EQ.1) THEN
              WRITE(6,210) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4)
            ELSE
              WRITE(6,220) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4)
            ENDIF
          ENDIF
        ENDIF
        IF (PRNTEX) WRITE(IUNITT,230) I,TXNAME(1,IDHW(I)),IDHEP(I),
     &   IST,JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &   (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4),ZZ
        IF (PRNWEB) THEN
          WRITE(IUNITW,240) TBCOLS(2),TBCOLS(3),I,I
          IF (IDHEP(I).EQ.0.OR.IDHEP(I).EQ.91) THEN
            WRITE(IUNITW,250) TXNAME(2,IDHW(I)),IDHEP(I),IST
          ELSE
            TMPNME=HWUNST(IDHW(I))
            WRITE(FNAMEP,'(A15,A7,A5)')
     &       'HW_decays/PART_',TMPNME,'.html'
            WRITE(IUNITW,260) FNAMEP,TXNAME(2,IDHW(I)),IDHEP(I),IST
          ENDIF
          DO 170 J=1,2
            IF (JMOHEP(J,I).NE.0) THEN
              WRITE(IUNITW,270) JMOHEP(J,I),JMOHEP(J,I)
            ELSE
              WRITE(IUNITW,280) JMOHEP(J,I)
            ENDIF
  170     CONTINUE
          DO 180 J=1,2
            IF (JDAHEP(J,I).NE.0) THEN
              WRITE(IUNITW,270) JDAHEP(J,I),JDAHEP(J,I)
            ELSE
              WRITE(IUNITW,280) JDAHEP(J,I)
            ENDIF
  180     CONTINUE
          IF (NPRFMT.EQ.1) THEN
            WRITE(IUNITW,290) (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4)
          ELSE
            WRITE(IUNITW,300) (PHEP(J,I),J=1,5),(VHEP(J,I),J=1,4)
          ENDIF
        ENDIF
  190   FORMAT(1X,I4,1X,A8,I8,5I4,   2F8.2,2F7.1,F8.2,1P,4E10.3)
  200   FORMAT(1X,I4,1X,A8,I8,5I4,   5F12.5,1P,4E11.4)
  210   FORMAT(1X,Z4,1X,A8,I8,I4,4Z4,2F8.2,2F7.1,F8.2,1P,4E10.3)
  220   FORMAT(1X,Z4,1X,A8,I8,I4,4Z4,5F12.5,1P,4E11.4)
  230   FORMAT(I4,' & ',A37,' & $',I8,'$',5(' & ',I4),
     &   5(' & $',F8.2,'$'),4(' & $',1P,E11.3,'$'),' ',A2)
  240   FORMAT('<TR>'/'<TD BGCOLOR=#',A6,' ALIGN="RIGHT">',
     &   '<FONT COLOR=#',A6,'><A NAME="',I4,'">',I4,'</A></FONT></TD>'/)
  250   FORMAT('<TD ALIGN="CENTER">',A37,'</TD>'/'<TD ALIGN="RIGHT">',
     &   I8,'</TD>'/'<TD ALIGN="RIGHT">',I4,'</TD>')
  260   FORMAT('<TD ALIGN="CENTER"><A HREF="',A27,'">',A37,'</A></TD>'/
     &   '<TD ALIGN="RIGHT">',I8,'</TD>'/
     &   '<TD ALIGN="RIGHT">',I4,'</TD>')
  270   FORMAT(/'<TD ALIGN="RIGHT"><A HREF="#',I4,'">',I4,'</A></TD>')
  280   FORMAT(/'<TD ALIGN="RIGHT">',I4,'</TD>')
  290   FORMAT(5(/'<TD ALIGN="RIGHT">',F8.2,'</TD>'),1P,
     &   4(/'<TD ALIGN="RIGHT">',E10.3,'</TD>')/'</TR>')
  300   FORMAT(5(/'<TD ALIGN="RIGHT">',F12.5,'</TD>'),1P,
     &   4(/'<TD ALIGN="RIGHT">',E11.4,'</TD>')/'</TR>')
      ELSE
C     Do not include vertex information
        IF (PRNDEF) THEN
          IF (PRNDEC) THEN
            IF (NPRFMT.EQ.1) THEN
              WRITE(6,330) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5)
            ELSE
              WRITE(6,340) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5)
            ENDIF
          ELSE
            IF (NPRFMT.EQ.1) THEN
              WRITE(6,350) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &          JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &          (PHEP(J,I),J=1,5)
            ELSE
              WRITE(6,360) I,RNAME(IDHW(I)),IDHEP(I),IST,
     &         JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &         (PHEP(J,I),J=1,5)
            ENDIF
          ENDIF
        ENDIF
        IF (PRNTEX) THEN
          IF (NPRFMT.EQ.1) THEN
            WRITE(IUNITT,370) I,TXNAME(1,IDHW(I)),IDHEP(I),
     &       IST,JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &       (PHEP(J,I),J=1,5),ZZ
          ELSE
            WRITE(IUNITT,380) I,TXNAME(1,IDHW(I)),IDHEP(I),
     &       IST,JMOHEP(1,I),JMOHEP(2,I),JDAHEP(1,I),JDAHEP(2,I),
     &       (PHEP(J,I),J=1,5),ZZ
          ENDIF
        ENDIF
        IF (PRNWEB) THEN
          WRITE(IUNITW,240) TBCOLS(2),TBCOLS(3),I,I
          IF (IDHEP(I).EQ.0.OR.IDHEP(I).EQ.91) THEN
            WRITE(IUNITW,250) TXNAME(2,IDHW(I)),IDHEP(I),IST
          ELSE
            TMPNME = HWUNST(IDHW(I))
            WRITE(FNAMEP,'(A15,A7,A5)')
     &       'HW_decays/PART_',TMPNME,'.html'
            WRITE(IUNITW,260) FNAMEP,TXNAME(2,IDHW(I)),IDHEP(I),IST
          ENDIF
          DO 310 J=1,2
            IF (JMOHEP(J,I).NE.0) THEN
              WRITE(IUNITW,270) JMOHEP(J,I),JMOHEP(J,I)
            ELSE
              WRITE(IUNITW,280) JMOHEP(J,I)
            ENDIF
  310     CONTINUE
          DO 320 J=1,2
            IF (JDAHEP(J,I).NE.0) THEN
              WRITE(IUNITW,270) JDAHEP(J,I),JDAHEP(J,I)
            ELSE
              WRITE(IUNITW,280) JDAHEP(J,I)
            ENDIF
  320     CONTINUE
          IF (NPRFMT.EQ.1) THEN
            WRITE(IUNITW,390) (PHEP(J,I),J=1,5)
          ELSE
            WRITE(IUNITW,400) (PHEP(J,I),J=1,5)
          ENDIF
        ENDIF
  330   FORMAT(1X,I4,1X,A8,I8,5I4   ,2F8.2,2F7.1,F8.2)
  340   FORMAT(1X,I4,1X,A8,I8,5I4   ,5F12.5)
  350   FORMAT(1X,Z4,1X,A8,I8,I4,4Z4,2F8.2,2F7.1,F8.2)
  360   FORMAT(1X,Z4,1X,A8,I8,I4,4Z4,5F12.5)
  370   FORMAT(I4,' & ',A37,' & $',I8,'$',5(' & ',I4),
     &   5(' & $',F8.2,'$'),' ',A2)
  380   FORMAT(I4,' & ',A37,' & $',I8,'$',5(' & ',I4),
     &   5(' & $',F12.5,'$'),' ',A2)
  390   FORMAT(5(/'<TD ALIGN="RIGHT">',F8.2,'</TD>')/'</TR>')
  400   FORMAT(5(/'<TD ALIGN="RIGHT">',F12.5,'</TD>')/'</TR>')
      ENDIF
  410 CONTINUE
C Close the files
      IF (PRNTEX) THEN
        WRITE(IUNITT,420) Z,Z,Z
  420   FORMAT(A1,'end{longtable}'/A1,'end{center}'/A1,'end{document}')
        CLOSE(IUNITT)
      ENDIF
      IF (PRNWEB) THEN
        WRITE(IUNITW,430)
  430   FORMAT('</TABLE>'/'</CENTER>'/'</BODY>'/'</HTML>')
        CLOSE(IUNITW)
      ENDIF
      RETURN
      END
