C
C
      SUBROUTINE FILHIS(X,Y,IHIS)
C**********************************************************************
C
C     fill value Y at position X into histogramm no IHIS
C
C     output: COMMON HISTOS
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (NHIS=200, NDIM=51)
      COMMON /HISTOS/ XLIMIT(3,NHIS),ISWI(NHIS),ENTRY(NHIS),
     &                HIST(4,NHIS,NDIM),EVENT(NHIS),OVERF(NHIS),
     &                UNDERF(NHIS),IBINS(NHIS),
     &                IHMIN(NHIS),IHMAX(NHIS),IHISL
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
C
      IF((IHIS.LT.1).OR.(IHIS.GT.IHISL)) THEN
        IDUMMY = 0
        WRITE(6,'(/1X,A,I6)')
     &    'FILHIS:ERROR: HISTOGRAM OUT OF RANGE ',IHIS
C  simulation of division by zero (to get the call of FILHIS)
        IHIS = IHIS/IDUMMY
        RETURN
      ENDIF
C
C  find relevant bin position
      IF(X.LT.HIST(1,IHIS,1)) THEN
        I1 = 0
        GOTO 100
      ELSE IF(X.GT.HIST(1,IHIS,IBINS(IHIS)+1)) THEN
        I1 = IBINS(IHIS)+1
        GOTO 100
      ENDIF
      IF(ISWI(IHIS).EQ.1) THEN
C  bin size not given explicitly
        I1 = (X-XLIMIT(1,IHIS))/XLIMIT(3,IHIS)+1
      ELSE IF(ISWI(IHIS).EQ.2) THEN
C  different bin sizes possible
C  binary sort algorithm
        KMIN=0
        KMAX=IBINS(IHIS)+1
 300    CONTINUE
          IF((KMAX-KMIN).EQ.1) GOTO 400
          KK=(KMAX+KMIN)/2
          IF(X.LE.HIST(1,IHIS,KK)) THEN
            KMAX=KK
          ELSE
            KMIN=KK
          ENDIF
        GOTO 300
 400    CONTINUE
        I1 = KMIN
      ELSE
        WRITE(6,'(/1X,A,I6)')
     &    'FILHIS:ERROR:HISTOGRAM NOT INITIALIZED',IHIS
        RETURN
      ENDIF
C
C  histogramming
 100  CONTINUE
      IF(I1.LE.0) THEN
        UNDERF(IHIS) = UNDERF(IHIS) + ONE
      ELSE IF(I1.LE.IBINS(IHIS)) THEN
        HIST(4,IHIS,I1) = HIST(4,IHIS,I1) + Y
        HIST(3,IHIS,I1) = HIST(3,IHIS,I1) + ONE
        ENTRY(IHIS) = ENTRY(IHIS) + ONE
        IF(I1.LT.IHMIN(IHIS)) IHMIN(IHIS) = I1
        IF(I1.GT.IHMAX(IHIS)) IHMAX(IHIS) = I1
      ELSE
        OVERF(IHIS) = OVERF(IHIS) + ONE
      ENDIF
      END
