C
C
      SUBROUTINE NEWHIS(XLIM1,XLIM2,XLIM3,XLIMB,IBIN,IREFN)
C**********************************************************************
C
C     create new histogram
C
C     input:  XLIM1        lower limit
C             XLIM2        upper limit
C             XLIM3        bin size
C             XLIMB(*)     field to handle different bin sizes
C             IBIN         number of bins
C                          neg. number to delete all histograms
C
C     output: IREFN        reference number of histogram
C                          (failure: neg. number)
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION XLIMB(*)
C
      PARAMETER (NHIS=200, NDIM=51)
      COMMON /HISTOS/ XLIMIT(3,NHIS),ISWI(NHIS),ENTRY(NHIS),
     &                HIST(4,NHIS,NDIM),EVENT(NHIS),OVERF(NHIS),
     &                UNDERF(NHIS),IBINS(NHIS),
     &                IHMIN(NHIS),IHMAX(NHIS),IHISL
C
      PARAMETER (ZERO   =  0.D0,
     &           IZERO  =  0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           TINY   =  1.D-10)
C
C  delete all histograms
      IF(IBIN.LE.0) THEN
        IHISL = 0
        RETURN
      ENDIF
C
      IHIS = IHISL+1
      IF(IHIS.LE.NHIS) THEN
C  general initialization
        DO 75 I=1,NDIM
          HIST(2,IHIS,I) = ZERO
          HIST(3,IHIS,I) = ZERO
          HIST(4,IHIS,I) = ZERO
 75     CONTINUE
        ENTRY(IHIS) = ZERO
        EVENT(IHIS) = ZERO
        OVERF(IHIS) = ZERO
        UNDERF(IHIS) = ZERO
C  field dimension check
        IF(IBIN.GE.NDIM) THEN
          WRITE(6,'(/1X,A,3I6)')
     &      'INIHIS:ERROR: TOO MANY BINS (BINS,LIMIT,HISTGRAM ID)',
     &             IBIN,NDIM,IHIS
          STOP
        ENDIF
        IBINS(IHIS) = IBIN
        IHMIN(IHIS) = IBIN
        IHMAX(IHIS) = 0
        IREFN = IHIS
C  bin size and lower limit given by user
        IF(XLIM3.GT.ZERO) THEN
          XLIMIT(1,IHIS) = XLIM1
          XLIMIT(2,IHIS) = XLIM1+IBINS(IHIS)*XLIM3
          XLIMIT(3,IHIS) = XLIM3
          TMP = XLIM1-XLIM3
          DO 100 K=1,IBINS(IHIS)+1
            TMP = TMP + XLIM3
            HIST(1,IHIS,K) = TMP
 100      CONTINUE
          ISWI(IHIS) = 1
C  limits given by user
        ELSE IF(XLIM3.EQ.ZERO) THEN
          XLIMIT(1,IHIS) = XLIM1
          XLIMIT(2,IHIS) = XLIM2
          XLIMIT(3,IHIS) = (XLIM2-XLIM1)/DBLE(IBINS(IHIS))
          TMP = XLIM1-XLIMIT(3,IHIS)
          DO 200 K=1,IBINS(IHIS)+1
            TMP = TMP + XLIMIT(3,IHIS)
            HIST(1,IHIS,K) = TMP
 200      CONTINUE
          ISWI(IHIS) = 1
        ELSE
C  each bin given by user
          DO 300 K=1,IBIN+1
            HIST(1,IHIS,K) = XLIMB(K)
 300      CONTINUE
          ISWI(IHIS) = 2
        ENDIF
        IHISL = IHIS
      ELSE
        WRITE(6,'(/1X,A,I4)') 'NEWHIS:ERROR: TOO MANY HISTOGRAMS',IHIS
        IREFN = -1
        STOP
      ENDIF
      END
