C
C
      CHARACTER*8 FUNCTION PANAME(I,MODE)
C**********************************************************************
C
C     output of particel name
C
C     input:  MODE    0:   I treated as compress particle code
C                     1:   I treated as PDG number
C                     2:   I location in /HEPEVS/
C
C     index:  particle index (location) in common HEPEVS
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           OTHREE =  ONE/THREE,
     &           TWOTHR =  TWO/THREE,
     &           OHALF  =  0.5D0,
     &           DEPS   =  1.D-05)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
C
      CHARACTER*8 PNAME
      CHARACTER*1 QUANAM(6)
      DATA        QUANAM / 'd','u','s','c','b','t' /
C
      IF(MODE.EQ.0) THEN
        PANAME = ANAME(I)
      ELSE IF(MODE.EQ.1) THEN
        IDBAM = MCIHAD(I)
        IF(IDBAM.EQ.99999) THEN
          WRITE(6,'(1X,A,I7)') 'PANAME:WARNING:INVALID PARTICLE',I
          PANAME = '????????'
        ELSE
          PANAME = ANAME(IDBAM)
        ENDIF
      ELSE IF(MODE.EQ.2) THEN
        ID = IDHEP(I)
C  comment line?
        IF(ISTHEP(I).GE.11) GOTO 300
C  code in BAMJET?
        IF((IMPART(I).GT.0).AND.(IMPART(I).LE.187)) THEN
          PANAME = ANAME(IMPART(I))
        ELSE
          IF((ID.GE.-6).AND.(ID.LE.6).AND.(ID.NE.0)) THEN
            PNAME = QUANAM(ABS(ID))
          ELSE IF(ID.EQ.6666) THEN
            PNAME = 'resonan.'
          ELSE IF(ID.EQ.7777) THEN
            PNAME = 'mo.chain'
          ELSE IF(ID.EQ.8888) THEN
            PNAME = 'chain'
          ELSE IF((ID.EQ.9).OR.(ID.EQ.21)) THEN
            PNAME = 'gluon'
          ELSE IF(ABS(ID).EQ.1103) THEN
            PNAME = 'dd(1)'
          ELSE IF(ABS(ID).EQ.2101) THEN
            PNAME = 'ud(0)'
          ELSE IF(ABS(ID).EQ.2103) THEN
            PNAME = 'ud(1)'
          ELSE IF(ABS(ID).EQ.2203) THEN
            PNAME = 'uu(1)'
          ELSE IF(ABS(ID).EQ.3101) THEN
            PNAME = 'ds(0)'
          ELSE IF(ABS(ID).EQ.3103) THEN
            PNAME = 'ds(1)'
          ELSE IF(ABS(ID).EQ.3201) THEN
            PNAME = 'us(0)'
          ELSE IF(ABS(ID).EQ.3203) THEN
            PNAME = 'us(1)'
          ELSE IF(ABS(ID).EQ.3303) THEN
            PNAME = 'ss(1)'
          ELSE
            PNAME = '????'
          ENDIF
          IF(ID.LT.0) THEN
            PANAME = 'a-'//PNAME
          ELSE
            PANAME = PNAME
          ENDIF
        ENDIF
        RETURN
C  comment lines
 300    CONTINUE
        IF(ISTHEP(I).EQ.20) THEN
          PANAME = 'ini part'
        ELSE IF(ISTHEP(I).EQ.25) THEN
          PANAME = 'hard sca'
        ELSE IF(ISTHEP(I).EQ.30) THEN
          PANAME = 'diffract'
        ELSE IF(ISTHEP(I).EQ.35) THEN
          PANAME = 'qua-elas'
        ELSE IF(ISTHEP(I).EQ.40) THEN
          PANAME = 'cen.diff'
        ELSE
          PANAME = 'comment'
        ENDIF
      ELSE
        WRITE(6,'(1X,A,2I7)') 'PANAME:WARNING:INVALID MODE',I,MODE
        PANAME = '????????'
      ENDIF
      END
