C
C
      SUBROUTINE POHEPI(IMODE,P1,P2,IP1,IP2)
C********************************************************************
C
C     prepare COMMON HEPEVS for new event
C
C     first subroutine called for each event
C
C     input:   P1(4)  particle 1
C              P2(4)  particle 2
C              IMODE  0    general initialization
C                     1    initialization after internal rejection
C
C     output:  IP1,IP2  index of interacting particles
C
C********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      DIMENSION P1(4),P2(4)
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           THREE  =  3.D0,
     &           OHALF  =  0.5D0,
     &           EPS    =  1.D-5,
     &           DEPS   =  1.D-40)
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      COMMON /PROCES/ IPROCE,IDNODF,IDIFR1,IDIFR2,IDDPOM,IPRON(15)
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C  lepton/hadron-photon kinematics
      COMMON /PHOSRC/ PINI(5,2),PFIN(5,2),PGAM(5,2),
     &                GYY(2),GQ2(2),GGECM,GAIMP(2),PFTHE(2),PFPHI(2),
     &                IDPSRC(2),IDBSRC(2),RADSRC(2),AMSRC(2),GAMSRC(2)
C  global energy
      COMMON /GLOCMS/ ECM,PCM,PMASS(2),PVIRT(2),IFPAP(2),IFPAB(2)
C
      PARAMETER (IEETAB=20)
      COMMON /XSETAB/ SIGTAB(4,70,IEETAB),SIGECM(4,IEETAB),ISIMAX
      COMMON /XSECTP/ SIGTOT,SIGELA,SIGVM(0:4,0:4),SIGINE,SIGDIR,
     &                SIGLSD(2),SIGHSD(2),SIGLDD,SIGHDD,SIGCDF,
     &                SIGPOM,SIGREG,SIGHAR,SIGTR1,SIGTR2,SIGLOO,SIGDPO,
     &                SIG1SO,SIG1HA,SLOEL,SLOVM(4,4),SIGGEN(4),
     &                FSUP(2)
C
      PARAMETER (MSTR=100)
      COMMON /STRING/ GAMBET(4,MSTR),NPOS(3,MSTR),NCODE(MSTR),
     &     IPAR1(MSTR),IPAR2(MSTR),IPAR3(MSTR),IPAR4(MSTR),
     &     NNCH(MSTR),IBHAD(MSTR),ISTR
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      COMMON/POMRES/IPOPOS(2,100),IPORES(100),IPOIX1,IPOIX2
C
      DIMENSION IM(2)
C
C  counter reset
      KSPOM  = 0
      KHPOM  = 0
      KSREG  = 0
      KHDIR  = 0
      KSTRG  = 0
      KHTRG  = 0
      KSLOO  = 0
      KHLOO  = 0
      KSDPO  = 0
      KSOFT  = 0
      KHARD  = 0
C
      IDNODF = 0
      IDIFR1 = 0
      IDIFR2 = 0
      IDDPOM = 0
      ISTR   = 0
      IPOIX1 = 0
      IF(ISWMDL(14).GT.0) IPOIX1 = 1
      IPOIX2 = 0
      CALL REGPAR(0,0,0,0,0,ZERO,ZERO,ZERO,ZERO,
     &            0,0,0,0,IPOS,0)
      CALL SELCOL(0,0,0,0,0,0,0)
C
C  lepton-photon/hadron-photon vertex and initial particles
      IM(1) = 0
      IM(2) = 0
      IF((IPAMDL(11).GT.0).AND.(IDPSRC(1).NE.0)) THEN
        CALL REGPAR(1,IDPSRC(1),IDBSRC(1),0,0,PINI(1,1),PINI(2,1),
     &    PINI(3,1),PINI(4,1),0,0,0,0,IM(1),1)
      ELSE
        CALL REGPAR(1,IFPAP(1),IFPAB(1),IM(1),0,P1(1),P1(2),P1(3),
     &    P1(4),0,0,0,0,IP1,1)
      ENDIF
      IF((IPAMDL(12).GT.0).AND.(IDPSRC(2).NE.0)) THEN
        CALL REGPAR(1,IDPSRC(2),IDBSRC(2),0,0,PINI(1,2),PINI(2,2),
     &    PINI(3,2),PINI(4,2),0,0,0,0,IM(2),1)
      ELSE
        CALL REGPAR(1,IFPAP(2),IFPAB(2),IM(2),0,P2(1),P2(2),P2(3),
     &    P2(4),0,0,0,0,IP2,1)
      ENDIF
      IF((IPAMDL(11).GT.0).AND.(IDPSRC(1).NE.0)) THEN
        CALL REGPAR(1,IDPSRC(1),IDBSRC(1),IM(1),0,PFIN(1,1),
     &    PFIN(2,1),PFIN(3,1),PFIN(4,1),0,0,0,0,IPOS,1)
        CALL REGPAR(1,IFPAP(1),IFPAB(1),IM(1),0,P1(1),P1(2),P1(3),
     &    P1(4),0,0,0,0,IP1,1)
      ENDIF
      IF((IPAMDL(12).GT.0).AND.(IDPSRC(2).NE.0)) THEN
        CALL REGPAR(1,IDPSRC(2),IDBSRC(2),IM(2),0,PFIN(1,2),
     &    PFIN(2,2),PFIN(3,2),PFIN(4,2),0,0,0,0,IPOS,1)
        CALL REGPAR(1,IFPAP(2),IFPAB(2),IM(2),0,P2(1),P2(2),P2(3),
     &    P2(4),0,0,0,0,IP2,1)
      ENDIF
      PMASS(1) = PHEP(5,IP1)
      PVIRT(1) = ZERO
      IF(IFPAP(1).EQ.22) PVIRT(1) = PMASS(1)**2
      PMASS(2) = PHEP(5,IP2)
      PVIRT(2) = ZERO
      IF(IFPAP(2).EQ.22) PVIRT(2) = PMASS(2)**2
C
C  full initialization
C  CMS energy
      ECM = SQRT((P1(4)+P2(4))**2-(P1(1)+P2(1))**2-(P1(2)+P2(2))**2
     &           -(P1(3)+P2(3))**2)
      CALL PECMS(1,PMASS(1),PMASS(2),ECM,PCM,EE)
      NEVHEP = KEVENT
C
C  reset of particle record only?
      IF(IMODE.EQ.0) THEN
C  load cross sections from interpolation table
        IP = 1
        IF(ECM.LE.SIGECM(IP,1)) THEN
          I1 = 1
          I2 = 1
        ELSE IF(ECM.LT.SIGECM(IP,ISIMAX)) THEN
          DO 50 I=2,ISIMAX
            IF(ECM.LE.SIGECM(IP,I)) GOTO 200
 50       CONTINUE
 200      CONTINUE
          I1 = I-1
          I2 = I
        ELSE
          WRITE(6,'(/1X,A,2E12.3)')
     &      'POHEPI:WARNING:TOO HIGH ENERGY',ECM,SIGECM(IP,ISIMAX)
          CALL POPREV(-1)
          I1 = ISIMAX
          I2 = ISIMAX
        ENDIF
        FAC2=0.D0
        IF(I1.NE.I2) FAC2=LOG(ECM/SIGECM(IP,I1))
     &                    /LOG(SIGECM(IP,I2)/SIGECM(IP,I1))
        FAC1=1.D0-FAC2
C  cross section dependence on photon virtualities
        DO 140 K=1,2
          FSUP(K) = 1.D0
          IF((IFPAP(K).EQ.22).AND.(ISWMDL(10).EQ.1)) THEN
            FSUP(K) = 0.D0
            DO  150 I=1,3
              FSUP(K) = FSUP(K)
     &               +PARMDL(26+I)*(1.D0+PVIRT(K)/(4.D0*PARMDL(30+I)))
     &               /(1.D0+PVIRT(K)/PARMDL(30+I))**2
 150        CONTINUE
            FSUP(K) = FSUP(K)+PARMDL(30)/(1.D0+PVIRT(K)/PARMDL(34))
            FAC1 = FAC1*FSUP(K)
            FAC2 = FAC2*FSUP(K)
          ENDIF
 140    CONTINUE
C
        SIGTOT =  FAC2*SIGTAB(IP,1,I2)+FAC1*SIGTAB(IP,1,I1)
        SIGELA =  FAC2*SIGTAB(IP,2,I2)+FAC1*SIGTAB(IP,2,I1)
        J = 2
        DO 5 I=0,4
          DO 6 K=0,4
            J = J+1
            SIGVM(I,K) = FAC2*SIGTAB(IP,J,I2)+FAC1*SIGTAB(IP,J,I1)
 6        CONTINUE
 5      CONTINUE
        SIGINE = FAC2*SIGTAB(IP,28,I2)+FAC1*SIGTAB(IP,28,I1)
        SIGDIR = FAC2*SIGTAB(IP,29,I2)+FAC1*SIGTAB(IP,29,I1)
        SIGHAR = FAC2*SIGTAB(IP,58,I2)+FAC1*SIGTAB(IP,58,I1)
        SIGLSD(1) = FAC2*SIGTAB(IP,30,I2)+FAC1*SIGTAB(IP,30,I1)
        SIGLSD(2) = FAC2*SIGTAB(IP,31,I2)+FAC1*SIGTAB(IP,31,I1)
        SIGHSD(1) = FAC2*SIGTAB(IP,32,I2)+FAC1*SIGTAB(IP,32,I1)
        SIGHSD(2) = FAC2*SIGTAB(IP,33,I2)+FAC1*SIGTAB(IP,33,I1)
        SIGLDD = FAC2*SIGTAB(IP,34,I2)+FAC1*SIGTAB(IP,34,I1)
        SIGHDD = FAC2*SIGTAB(IP,35,I2)+FAC1*SIGTAB(IP,35,I1)
        SIGCDF = FAC2*SIGTAB(IP,36,I2)+FAC1*SIGTAB(IP,36,I1)
C  corrections due to photon virtuality dependence of PDFS
        IF(IPAMDL(115).GT.0) THEN
          SIGHIN = FAC2*SIGTAB(IP,70,I2)+FAC1*SIGTAB(IP,70,I1)
          SIGTMP = SIGDIR+SIGHIN
        ELSE
          SIGTMP = SIGDIR
        ENDIF
        SIGTMP = (1.D0/(FSUP(1)*FSUP(2))-1.D0)*SIGTMP
        SIGINE = SIGINE+SIGTMP
        SIGTOT = SIGTOT+SIGTMP
        SIGDIR = SIGDIR/(FSUP(1)*FSUP(2))
        SIGHAR = SIGHAR/(FSUP(1)*FSUP(2))
C  additional suppression for multi-pomeron graphs
        SIGLSD(1) = SIGLSD(1)*FSUP(2)
        SIGLSD(2) = SIGLSD(2)*FSUP(1)
        SIGHSD(1) = SIGHSD(1)*FSUP(2)
        SIGHSD(2) = SIGHSD(2)*FSUP(1)
        SIGLDD    = SIGLDD*FSUP(1)*FSUP(2)
        SIGCDF    = SIGCDF*FSUP(1)*FSUP(2)
        DO 7 I=0,4
          DO 8 K=0,4
            SIGVM(I,K) = SIGVM(I,K)*FSUP(1)*FSUP(2)
 8        CONTINUE
 7      CONTINUE
C
        SIG1SO = FAC2*SIGTAB(IP,37,I2)+FAC1*SIGTAB(IP,37,I1)
        SIG1HA = FAC2*SIGTAB(IP,38,I2)+FAC1*SIGTAB(IP,38,I1)
        SLOEL = FAC2*SIGTAB(IP,39,I2)+FAC1*SIGTAB(IP,39,I1)
        J = 39
        DO 9 I=1,4
          DO 10 K=1,4
            J = J+1
            SLOVM(I,K) = FAC2*SIGTAB(IP,J,I2)+FAC1*SIGTAB(IP,J,I1)
 10       CONTINUE
 9      CONTINUE
        SIGPOM = FAC2*SIGTAB(IP,56,I2)+FAC1*SIGTAB(IP,56,I1)
        SIGREG = FAC2*SIGTAB(IP,57,I2)+FAC1*SIGTAB(IP,57,I1)
C  effective cross section
        SIGGEN(3) = 0.D0
        IF(ISWMDL(2).NE.0) THEN
          IF(IPRON(1).EQ.1) SIGGEN(3) = SIGTOT-SIGELA-SIGVM(0,0)
     &      -SIGCDF-SIGLSD(1)-SIGHSD(1)-SIGLSD(2)-SIGHSD(2)-SIGLDD
     &      -SIGHDD-SIGDIR
          IF(IPRON(2).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGELA
          IF(IPRON(3).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGVM(0,0)
          IF(IPRON(4).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGCDF
          IF(IPRON(5).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGLSD(1)+SIGHSD(1)
          IF(IPRON(6).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGLSD(2)+SIGHSD(2)
          IF(IPRON(7).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGLDD+SIGHDD
          IF(IPRON(8).EQ.1) SIGGEN(3) = SIGGEN(3)+SIGDIR
C  simulate only hard scatterings
        ELSE
          IF(IPRON(8).EQ.1) THEN
            SIGGEN(3) = FAC2*SIGTAB(IP,59,I2)+FAC1*SIGTAB(IP,59,I1)
            SIGGEN(3) = SIGGEN(3)/(FSUP(1)*FSUP(2))
          ENDIF
          IF(IPRON(1).EQ.1) SIGGEN(3) = SIGGEN(3)
     &      +(FAC2*SIGTAB(IP,58,I2)+FAC1*SIGTAB(IP,58,I1))
     &      /(FSUP(1)*FSUP(2))
        ENDIF
      ENDIF
C  debug output
      IF(IDEB(63).GE.15) THEN
        WRITE(6,'(1X,A,2I5)') 'POHEPI:DEBUG:HEPEVS INITIALIZED:'
        ONEM = -1.D0
        CALL POXSEC(1,ONEM)
        CALL POPREV(0)
      ENDIF
      END
