C
C
      SUBROUTINE POHZSP(IFLA,IFLB,NFSH,ZMIN,ZMAX,ZZ)
C*********************************************************************
C
C     sampling of z values from DGLAP kernels
C
C     input:  IFLA,IFLB      parton flavours
C             NFSH           flavours involved in hard processes
C             ZMIN           minimal ZZ allowed
C             ZMAX           maximal ZZ allowed
C
C     output: ZZ             z value
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0,
     &           DEPS   =  1.D-10)
C
      IF(ZMAX.LE.ZMIN) THEN
        WRITE(6,'(1X,A,2E12.3)')
     &    'POHZSP:WARNING:ZMAX<ZMIN (ZMAX,ZMIN)',ZMAX,ZMIN
        CALL POPREV(-1)
        ZZ = ZERO
        RETURN
      ENDIF
C
      IF(IFLB.EQ.0) THEN
        IF(IFLA.EQ.0) THEN
C  g --> g g
          C1 = ZMAX/ZMIN*(ONE-ZMIN)/(ONE-ZMAX)
          C2 = (ONE-ZMIN)/ZMIN
 100      CONTINUE
            ZZ = ONE/(ONE+C2/C1**RNDM(ZMIN))
          IF((ONE-ZZ*(ONE-ZZ))**2.LT.RNDM(ZMAX)) GOTO 100
        ELSE IF(ABS(IFLA).LE.NFSH) THEN
C  q --> q g
          C1 = ZMAX/ZMIN
 200      CONTINUE
            ZZ = ZMIN*C1**RNDM(ZMIN)
          IF(OHALF*(ONE+(ONE-ZZ)**2).LT.RNDM(ZMAX)) GOTO 200
        ELSE
          GOTO 900
        ENDIF
      ELSE IF(ABS(IFLB).LE.NFSH) THEN
        IF(IFLA.EQ.0) THEN
C  g --> q qb
          C1 = ZMAX-ZMIN
 300      CONTINUE
            ZZ = ZMIN+C1*RNDM(ZMIN)
          IF((TWO*ZZ*(ZZ-ONE)+ONE).LT.RNDM(ZMAX)) GOTO 300
        ELSE IF(ABS(IFLA).LE.NFSH) THEN
C  q --> g q
          C1 = (ONE-ZMAX)/(ONE-ZMIN)
          C2 = ONE-ZMIN
 400      CONTINUE
            ZZ = ONE-C2*C1**RNDM(ZMIN)
          IF(OHALF*(ONE+ZZ**2).LT.RNDM(ZMAX)) GOTO 400
        ELSE
          GOTO 900
        ENDIF
      ELSE
        GOTO 900
      ENDIF
C  debug output
      IF(IDEB(80).GE.20) WRITE(6,'(1X,A,2I3,3E11.3)')
     &  'POHZSP:DEBUG:IFLA,IFLB,ZZ,ZMIN,ZMAX',
     &  IFLA,IFLB,ZZ,ZMIN,ZMAX
      RETURN
C
 900  CONTINUE
      WRITE(6,'(/1X,A,2I7)') 'POHZSP:ERROR:INVALID FLAVORS A,B',
     &  IFLA,IFLB
      CALL POABRT
      END
