C
C
      SUBROUTINE SOFTXX(JM1,JM2,MSPAR1,MSPAR2,IVAL1,IVAL2,MSM1,MSM2,
     &                  XSUM1,XSUM2,XMAX1,XMAX2,XS1,XS2,IREJ)
C***********************************************************************
C
C    select soft x values
C
C    input:   JM1,JM2    mother particle index in HEPEVS
C                        (0  flavour not known before)
C             MSPAR1,2   number of x values to select
C             IVAL1,2    number valence quarks involved (0,1,2)
C             MSM1,2     minimum number of soft x to get sampled
C             XSUM1,2    sum of all x values samples up this call
C             XMAX1,2    max. x value
C
C    output   XSUM1,2    new sum of x-values sampled
C             XS1,2      filed containing sampled x values
C
C    x values of valence partons are first given
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER (ZERO   =  0.D0,
     &           ONE    =  1.D0,
     &           TWO    =  2.D0,
     &           OHALF  =  0.5D0)
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
      PARAMETER (NMXJ=40)
      CHARACTER*10 REJTIT
      COMMON /REJSTA/ IFAIL(NMXJ),REJTIT(NMXJ)
C
      CHARACTER*8 MDLNA
      COMMON /MODELS/ MDLNA(50),ISWMDL(50),PARMDL(200),IPAMDL(200)
C
      PARAMETER (NMXHEP=2000)
      COMMON/HEPEVS/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      COMMON/HEPEVE/IMPART(NMXHEP),IPHIST(2,NMXHEP),ICOLOR(2,NMXHEP)
C
      COMMON /HADVAL/ ECMN,PCMN,SECM,SPCM,XPSUB,XTSUB,
     &                IDEQP(2),IDEQB(2),IHFLD(2,2),IHFLS(2)
      CHARACTER*8 ANAME
      COMMON/POPART/ANAME(187),AM(187),GA(187),TAU(187),ICH(187),
     &              IBAR(187),K1(187),K2(187)
C
      DIMENSION XS1(50),XS2(50),XPOT1(50),XPOT2(50)
C
      IREJ = 0
      MSMAX = MAX(MSPAR1,MSPAR2)
      MSMIN = MAX(MSM1,MSM2)
C  determine exponents
      IBAR1 = ABS(IBAR(IMPART(JM1)))
      IBAR2 = ABS(IBAR(IMPART(JM2)))
C  meson-baryon scattering (asymmetric sea)
      IF((IBAR1+IBAR2).EQ.1) THEN
        PSBAR = PARMDL(53)
        PSMES = PARMDL(57)
      ELSE
        PSBAR = PARMDL(52)
        PSMES = PARMDL(56)
      ENDIF
C  particle 1
C  mesonic particle
      IF(IBAR1.EQ.0) THEN
        IF(IHFLS(1).EQ.0) THEN
          XPOT1(1) = PARMDL(62)
          XPOT1(2) = PARMDL(63)
        ELSE
          XPOT1(1) = PARMDL(54)
          XPOT1(2) = PARMDL(55)
        ENDIF
        DO 100 I=3-IVAL1,MSMAX
          XPOT1(I) = PSMES
 100    CONTINUE
C  baryonic particle
      ELSE
        IF(IHFLS(1).EQ.0) THEN
          XPOT1(1) = PARMDL(62)
          XPOT1(2) = PARMDL(63)
        ELSE
          XPOT1(1) = PARMDL(50)
          XPOT1(2) = PARMDL(51)
        ENDIF
        DO 200 I=3-IVAL1,MSMAX
          XPOT1(I) = PSBAR
 200    CONTINUE
      ENDIF
C  particle 2
C  mesonic particle
      IF(IBAR2.EQ.0) THEN
        IF(IHFLS(2).EQ.0) THEN
          XPOT2(1) = PARMDL(62)
          XPOT2(2) = PARMDL(63)
        ELSE
          XPOT2(1) = PARMDL(54)
          XPOT2(2) = PARMDL(55)
        ENDIF
        DO 300 I=3-IVAL2,MSMAX
          XPOT2(I) = PSMES
 300    CONTINUE
C  baryonic particle
      ELSE
        IF(IHFLS(2).EQ.0) THEN
          XPOT2(1) = PARMDL(62)
          XPOT2(2) = PARMDL(63)
        ELSE
          XPOT2(1) = PARMDL(50)
          XPOT2(2) = PARMDL(51)
        ENDIF
        DO 400 I=3-IVAL2,MSMAX
          XPOT2(I) = PSBAR
 400    CONTINUE
      ENDIF
C
      XSS1 = XSUM1
      XSS2 = XSUM2
      MSOFT = MSMAX
C  sample distribution
      IF(IPAMDL(14).EQ.0) THEN
        IF(MSOFT.EQ.2) THEN
          CALL SELSX2(XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ELSE IF(MSOFT.LT.5) THEN
          CALL SELSXR(MSOFT,MSMIN,XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ELSE
          CALL SELSXS(MSOFT,MSMIN,XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ENDIF
      ELSE IF(IPAMDL(14).EQ.1) THEN
        IF(MSOFT.EQ.2) THEN
          CALL SELSX2(XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ELSE
          CALL SELSXS(MSOFT,MSMIN,XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ENDIF
      ELSE IF(IPAMDL(14).EQ.2) THEN
        CALL SELSXS(MSOFT,MSMIN,XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &              XS1,XS2,IREJ)
      ELSE IF(IPAMDL(14).EQ.3) THEN
        IF(MSOFT.EQ.2) THEN
          CALL SELSX2(XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ELSE IF(IVAL1+IVAL2.EQ.4) THEN
          CALL SELSXI(MSOFT,MSMIN,XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ELSE
          CALL SELSXS(MSOFT,MSMIN,XPOT1,XPOT2,XSS1,XSS2,XMAX1,XMAX2,
     &                XS1,XS2,IREJ)
        ENDIF
      ELSE IF(IPAMDL(14).EQ.2) THEN
      ELSE
        WRITE(6,'(/,1X,A,I3)')
     &    'SOFTXX:ERROR:UNSUPPORTED IPAMDL(14)',IPAMDL(14)
        STOP
      ENDIF
      IF(IREJ.NE.0) THEN
        IFAIL(38) = IFAIL(38)+1
        IF(IDEB(48).GE.2) WRITE(6,'(1X,A,I3)')
     &    'SOFTXX:REJECTION:IREJ',IREJ
        RETURN
      ENDIF
      IF(MSOFT.NE.MSMAX) THEN
        MSDIFF = MSMAX-MSOFT
        MSPAR1 = MSPAR1-MSDIFF
        MSPAR2 = MSPAR2-MSDIFF
      ENDIF
C  correct for different MSPAR numbers
      IF(MSOFT.NE.MSPAR1) THEN
        IF(MSPAR1.GT.1) THEN
          XDEL = ZERO
          DO 500 I=MSPAR1+1,MSOFT
            XDEL = XDEL+XS1(I)
 500      CONTINUE
          XFAC = (ONE-XSUM1)/(ONE-XDEL-XSUM1)
          DO 550 I=2,MSPAR1
            XS1(I) = XS1(I)*XFAC
 550      CONTINUE
          XSS1 = (XSS1-XDEL-XSUM1)*XFAC+XSUM1
        ELSE
          XSS1 = XSUM1
        ENDIF
      ENDIF
      IF(MSOFT.NE.MSPAR2) THEN
        IF(MSPAR2.GT.1) THEN
          XDEL = ZERO
          DO 600 I=MSPAR2+1,MSOFT
            XDEL = XDEL+XS2(I)
 600      CONTINUE
          XFAC = (ONE-XSUM2)/(ONE-XDEL-XSUM2)
          DO 650 I=2,MSPAR2
            XS2(I) = XS2(I)*XFAC
 650      CONTINUE
          XSS2 = (XSS2-XDEL-XSUM2)*XFAC+XSUM2
        ELSE
          XSS2 = XSUM2
        ENDIF
      ENDIF
C  first x entry
      XS1(1) = ONE - XSS1
      XS2(1) = ONE - XSS2
      XSUM1 = XSS1
      XSUM2 = XSS2
      END
