
       SUBROUTINE runmcarlo(IRUN, ierr)

C from C++ interface 
C      IRUN=1 - initialize
C      IRUN=2 - run
C      IRUN=3 - terminate
C      ierr- no errors, event accepted 
C      written by S.Chekanov, May, 2003


      include "../inc/pythia62.inc"
      include "../inc/hepevt_pythia62.inc"
      include "../inc/getevkin.inc"
      include "../inc/getseeds.inc"

      DOUBLE PRECISION  PI,proton 
      Parameter (PI=3.141592654, proton=0.938272)
      character*10 Pname1,Pname2

      Integer I, J, N, nev, iEP, IPOSI
      DOUBLE PRECISION  ECM, pbeam(4), sinv,ebeam(4)
      Integer IRUN, ierr,IPAR
      DOUBLE PRECISION  xQ2,xX,xY,xW
      Save nev,sinv 


      goto (1000, 2000, 3000) IRUN
      return


 1000   CONTINUE 

C -take positron (default) 
       IPOSI=-11
       nev=0
       ierr=1

C assume particle 1 is proton 
       CKIN(61)=rXbj(2)  ! min X
       CKIN(62)=rXbj(3)  ! max X
       CKIN(73)=rYbj(2)  ! min Y 
       CKIN(74)=rYbj(3)  ! max Y 
       CKIN(65)=rQ2(2)  ! min Q2
       CKIN(66)=rQ2(3)  ! max Q2
C photoproduction
       if (rQ2(2).le.1) then  
       CKIN(77)=rW(2)   ! min W
       CKIN(78)=rW(3)   ! max W
       endif  
C this is DIS
       if (rQ2(2).gt.1) then
       CKIN(39)=rW(2)*rW(2)   ! min W2
       CKIN(40)=rW(3)*rW(3)   ! max W2
       endif




C  find out - is this DIS mode ?
        iEP=0
        if( (abs(PID1).le.17) .and. (abs(PID2).gt.2000) ) iEP=1
        if( (abs(PID2).le.17) .and. (abs(PID1).gt.2000) ) iEP=1

C E+E-
        if( (abs(PID1).le.17) .and. (abs(PID2).lt.17) ) iEP=2

C ppbar
        if( (abs(PID1).ge.2000) .and. (abs(PID2).gt.2000) ) iEP=3


C...Use minimal W to set minimum photon energy fractions.
      write(6,*) 
     +  "PYTHIA: Minimal W to set minimum photon energy fractions!"
      ECM=SQRT(4D0*ENER1*ENER2 + proton**2)
      CKIN(61)=(CKIN(77)/ECM)**2
      CKIN(73)=CKIN(61)

C... To increase efficiency for high PT events, this may be increased.
       CKIN(3)=2.0

* set PDF for first particle
      IF (abs(PID1).ge.2000) THEN
      PDFGUP(1)=4
      PDFSUP(1)=46
      MSTP(52)=2
         IF (PDF1.eq.2) THEN 
         PDFGUP(1)=3
         PDFSUP(1)=72
         MSTP(52)=2
         ELSEIF (PDF1.eq.3) THEN
         PDFGUP(1)=5
         PDFSUP(1)=12
         MSTP(52)=2     
         ENDIF
         MSTP(51)=1000*PDFGUP(1)+PDFSUP(1) 
      ENDIF

* set PDF for second particle
      IF (abs(PID2).ge.2000) THEN
      PDFGUP(2)=4
      PDFSUP(2)=46
      MSTP(52)=2
         IF (PDF2.eq.2) THEN 
         PDFGUP(2)=3
         PDFSUP(2)=72
         MSTP(52)=2
         ELSEIF (PDF2.eq.3) THEN
         PDFGUP(2)=5
         PDFSUP(2)=12
         MSTP(52)=2
         ENDIF
         MSTP(51)=1000*PDFGUP(1)+PDFSUP(1)
      ENDIF

          pbeam(1)=0.
          pbeam(2)=0.
          pbeam(3)=ENER1
          pbeam(4)=ENER1
          ebeam(1)=0.
          ebeam(2)=0.
          ebeam(3)=-ENER2
          ebeam(4)=ENER2

                    
* redefine initial lepton  
        IF (abs(PID1).le.14) THEN
             IPOSI=PID1
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=ENER1
             ebeam(4)=ENER1
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=-ENER2
           pbeam(4)=ENER2
         ENDIF
 
       IF (abs(PID2).le.14) THEN
             IPOSI=PID2
             ebeam(1)=0.
             ebeam(2)=0.
             ebeam(3)=-ENER2
             ebeam(4)=ENER2
           pbeam(1)=0.
           pbeam(2)=0.
           pbeam(3)=ENER1
           pbeam(4)=ENER1
         ENDIF


C...Initialize.
      P(1,1)=pbeam(1)
      P(1,2)=pbeam(2)
      P(1,3)=pbeam(3)
      P(2,1)=ebeam(1)
      P(2,2)=ebeam(2)
      P(2,3)=ebeam(3)
C this is for DIS
      sinv = 4.*ebeam(4)*pbeam(4) + proton**2

       Call GeTName(PID1,Pname1,0)
       Call GeTName(PID2,Pname2,0)

       write(6,*) "PYTHIA 6: Beam 1", PID1, " ", Pname1
       write(6,*) "PYTHIA 6: Beam 2", PID2, " ", Pname2



       CALL PYGIVE('PARJ(72)=1000') ! mm maximum distance from the origin at
                     ! a decay is allowed to take place
       CALL PYGIVE('MSTJ(22)=3')  ! particle is decayed only if the decay vertex is
                     ! within a distance PARJ(72) of the origin
       write(6,*)PARJ(72),'mm maximum distance a decay is allowed'

C set seed number
      MRPY(1)=RUNMCseed1+RUNMCseed2 
      write(6,*) "PYTHIA 6: new seed for this run = ",MRPY(1)

C this is defaut
      MSEL=1 ! all processes

********all GeTNamePHP(PID1,Pname1,0)
      IF ( ((abs(PID1).le.14.and.abs(PID2).ge.2000) .or. 
     +      (abs(PID2).le.14.and.abs(PID1).ge.2000)) ) then
            Call GeTName(PID1,Pname1,1)
            Call GeTName(PID2,Pname2,1)
      ELSE
           ! for e+e- 
           IF ( abs(PID1).le.14.and.abs(PID2).le.14 ) then
           MSEL=0 ! Choice of Z/gamma  process.
           MSUB(1)=1
           ENDIF 

       ENDIF 

C set parameters via cards
      Call RunMC_Steer("pythia6.cards")
      Call RUNMCpythia6steer ! modify parameters   

C set user initialisation
      Call setPYTHIA62



       CALL PYINIT('3MOM',Pname1,Pname2,0D0)
 
*- initialize PYTHIA
       write(6,*) '  Generate events with ------'
       write(6,*) '  at centere-of-mass energy ' , EECM
       write(6,*) '  MSEL ',  MSEL
       write(6,*) '  MSUB(1) ',  MSUB(1)
       write(6,*) ' '
       CALL PYGIVE('MSTP(11)=0')
       write(6,*) '  ISR photon radiation is off'
********************* end of e+e- etc mode ********************************

       write(6,*) ' FINISH INITIALIZATION'

      RETURN

 2000  CONTINUE  ! RUN 


************* Physics study *************** 

C...Call generate an event
        CALL PYEVNT

        nev=nev+1


C copy kinematic varaibles
        ierr=0        
          
C.. convert from JETSET common
       CALL PYHEPC(1)


      IF (iEP.ne.2) THEN ! not E+E-
        CALL GETKIN(xQ2,xX,xY,xW) ! get kinematics
C copy kinematic varaibles
        rQ2(1)=real(xQ2) 
        rXbj(1)=real(xX)
        rYbj(1)=real(xY)
        rW(1)=real(xW)
       ENDIF


C get some user-defined variables to rUSER matrix from   
C  getevkin.inc / getevkin.h 

C get Q2, x1, x2
         rUSER(1)=PARI(22)
         rUSER(2)=PARI(33) 
         rUSER(3)=PARI(34)

C        Q2=PARI(105)
C        W=PARI(11)
C        PT=PARI(17)
C        PQ=P(2,4)*P(4,4)-P(2,1)*P(4,1)-P(2,2)*P(4,2)-P(2,3)*P(4,3)
C        XBJ=Q2/(2D0*PQ)
C        Ybj=Q2/(s_inv*XBJ)





CC       write(6,*) rQ2(1), PARI(105)

C...Call a user supplied analysis routine
        if (nev.le.5)  CALL PYLIST(1) 


 9999  Continue
* end of loop >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      RETURN


 3000 CONTINUE

C...Final statistics
      CALL PYSTAT(1)


      xCross=1E09*XSEC(0,3)
      eCross=0.
      write(6,*) "RUNMC-PYTHIA6: total cross section is (pb): ", xCross 
      write(6,*) 'RUNMC-PYTHIA6: ALL done!'

      RETURN      
      END  



**************************************************

       Subroutine GeTName(ID, NameP, imod)

      INTEGER imod,ID
      Character* 10 NameP 

      NameP="undefined" 

      IF (ID.eq.11)   NameP="e-"
      IF (ID.eq.-11)  NameP="e+" 
      IF (ID.eq.13)   NameP="mu-"
      IF (ID.eq.-13)  NameP="mu+"
      IF (ID.eq.15)   NameP="tau-"
      IF (ID.eq.-15)  NameP="tau+"
      IF (ID.eq.22)   NameP="gamma"
      IF (ID.eq.2112) NameP="n0"
      IF (ID.eq.-2112) NameP="nbar0" 
      IF (ID.eq.2212)  NameP="p+"
      IF (ID.eq.-2212) NameP="pbar-"
 
 
      IF (imod.eq.1) THEN ! for PHP
       IF (ID.eq.11)   NameP="gamma/e-"
       IF (ID.eq.-11)  NameP="gamma/e+"
       IF (ID.eq.13)   NameP="gamma/mu-"
       IF (ID.eq.-13)  NameP="gamma/mu+"
       IF (ID.eq.15)   NameP="gamma/tau-"
       IF (ID.eq.-15)  NameP="gamma/tau+"
       IF (ID.eq.22)   NameP="gamma"
       IF (ID.eq.2112) NameP="n0"
       IF (ID.eq.-2112) NameP="nbar0"
       IF (ID.eq.2212)  NameP="p+"
       IF (ID.eq.-2212) NameP="pbar-"
      ENDIF
 
      END


************************************************
* get kinematics

        SUBROUTINE GETKIN(Q2,XBJ,YBJ,W)

        include "../inc/hepevt_pythia62.inc"
        DOUBLE PRECISION Q2,PQ,PK,XBJ,YBJ,W
        DOUBLE PRECISION PP(4),QQ(4)
        DOUBLE PRECISION sinv,MPROTON
        PARAMETER (MPROTON=0.938272)
        Integer M, I
        Save   PP


         XBJ=0.
         YBJ=0.
         Q2 =0.
         W  =0.

* get proton beam
        DO I=1,2
        IF (abs(IDHEP(I)).ge.2000) THEN
            DO M=1,4
            PP(M)=PHEP(M,I)
           ENDDO
        ENDIF
        ENDDO
        sinv = 4.*PHEP(4,1)*PHEP(4,2) + MPROTON**2
        Q2=0.

* get gamma/Z boson
        DO M=3,NHEP
        IF (abs(IDHEP(M)).le.24.and.abs(IDHEP(M)).ge.22) THEN
        DO I=1,4
          QQ(I)=PHEP(I,M)
          Q2=PHEP(5,M)**2
        ENDDO
        GOTO 8282
        ENDIF
        ENDDO

 8282    CONTINUE
* Other kinematical variables
         Pq=PP(4)*QQ(4) - PP(3)*QQ(3)
         XBJ=Q2/2./Pq
         YBJ=Q2/(XBJ*sinv)
         W=2.*Pq-Q2+MPROTON**2
         IF (W.GT.0.) THEN
           W=DSQRT(W)
         ELSE
           W=MPROTON
         ENDIF

      RETURN
      END








 
