/* ktclusdble.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal etot, rsq, p[4608]	/* was [9][512] */, ktp[262144]	/* 
	    was [512][512] */, kts[512], kt[512], ktlast[512];
    integer hist[512], num;
} ktcomm_;

#define ktcomm_1 ktcomm_

/* Table of constant values */

static integer c__100 = 100;
static integer c__101 = 101;
static integer c__1 = 1;
static integer c__102 = 102;
static integer c__512 = 512;
static integer c__0 = 0;
static integer c__200 = 200;
static integer c__201 = 201;
static integer c__202 = 202;
static doublereal c_b257 = 6.28318530717958648;

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*     KTCLUS: written by Mike Seymour, July 1992. */
/*     Last modified November 2000. */
/*     Please send comments or suggestions to Mike.Seymour@rl.ac.uk */

/*     This is a general-purpose kt clustering package. */
/*     It can handle ee, ep and pp collisions. */
/*     It is loosely based on the program of Siggi Bethke. */

/*     The time taken (on a 10MIP machine) is (0.2microsec)*N**3 */
/*     where N is the number of particles. */
/*     Over 90 percent of this time is used in subroutine KTPMIN, which */
/*     simply finds the minimum member of a one-dimensional array. */
/*     It is well worth thinking about optimization: on the SPARCstation */
/*     a factor of two increase was obtained simply by increasing the */
/*     optimization level from its default value. */

/*     The approach is to separate the different stages of analysis. */
/*     KTCLUS does all the clustering and records a merging history. */
/*     It returns a simple list of the y values at which each merging */
/*     occured. Then the following routines can be called to give extra */
/*     information on the most recently analysed event. */
/*     KTCLUR is identical but includes an R parameter, see below. */
/*     KTYCUT gives the number of jets at each given YCUT value. */
/*     KTYSUB gives the number of sub-jets at each given YCUT value. */
/*     KTBEAM gives same info as KTCLUS but only for merges with the beam */
/*     KTJOIN gives same info as KTCLUS but for merges of sub-jets. */
/*     KTRECO reconstructs the jet momenta at a given value of YCUT. */
/*     It also gives information on which jets at scale YCUT belong to */
/*     which macro-jets at scale YMAC, for studying sub-jet properties. */
/*     KTINCL reconstructs the jet momenta according to the inclusive jet */
/*     definition of Ellis and Soper. */
/*     KTISUB, KTIJOI and KTIREC are like KTYSUB, KTJOIN and KTRECO, */
/*     except that they only apply to one inclusive jet at a time, */
/*     with the pt of that jet automatically used for ECUT. */
/*     KTWICH gives a list of which particles ended up in which jets. */
/*     KTWCHS gives the same thing, but only for subjets. */
/*     Note that the numbering of jets used by these two routines is */
/*     guaranteed to be the same as that used by KTRECO. */

/*     The collision type and analysis type are indicated by the first */
/*     argument of KTCLUS. IMODE=<TYPE><ANGLE><MONO><RECOM> where */
/*     TYPE:  1=>ee, 2=>ep with p in -z direction, 3=>pe, 4=>pp */
/*     ANGLE: 1=>angular kt def., 2=>DeltaR, 3=>f(DeltaEta,DeltaPhi) */
/*            where f()=2(cosh(eta)-cos(phi)) is the QCD emission metric */
/*     MONO:  1=>derive relative pseudoparticle angles from jets */
/*            2=>monotonic definitions of relative angles */
/*     RECOM: 1=>E recombination scheme, 2=>pt scheme, 3=>pt**2 scheme */

/*     There are also abbreviated forms for the most common combinations: */
/*     IMODE=1 => E scheme in e+e-                              (=1111) */
/*           2 => E scheme in ep                                (=2111) */
/*           3 => E scheme in pe                                (=3111) */
/*           4 => E scheme in pp                                (=4111) */
/*           5 => covariant E scheme in pp                      (=4211) */
/*           6 => covariant pt-scheme in pp                     (=4212) */
/*           7 => covariant monotonic pt**2-scheme in pp        (=4223) */

/*     KTRECO no longer needs to reconstruct the momenta according to the */
/*     same recombination scheme in which they were clustered. Its first */
/*     argument gives the scheme, taking the same values as RECOM above. */

/*     Note that unlike previous versions, all variables which hold y */
/*     values have been named in a consistent way: */
/*     Y()  is the output scale at which jets were merged, */
/*     YCUT is the input scale at which jets should be counted, and */
/*          jet-momenta reconstructed etc, */
/*     YMAC is the input macro-jet scale, used in determining whether */
/*          or not each jet is a sub-jet. */
/*     The original scheme defined in our papers is equivalent to always */
/*     setting YMAC=1. */
/*     Whenever a YCUT or YMAC variable is used, it is rounded down */
/*     infinitesimally, so that for example, setting YCUT=Y(2) refers */
/*     to the scale where the event is 2-jet, even if rounding errors */
/*     have shifted its value slightly. */

/*     An R parameter can be used in hadron-hadron collisions by */
/*     calling KTCLUR instead of KTCLUS.  This is as suggested by */
/*     Ellis and Soper, but implemented slightly differently, */
/*     as in M.H. Seymour, LU TP 94/2 (submitted to Nucl. Phys. B.). */
/*     R**2 multiplies the single Kt everywhere it is used. */
/*     Calling KTCLUR with R=1 is identical to calling KTCLUS. */
/*     R plays a similar role to the jet radius in a cone-type algorithm, */
/*     but is scaled up by about 40% (ie R=0.7 in a cone algorithm is */
/*     similar to this algorithm with R=1). */
/*     Note that R.EQ.1 must be used for the e+e- and ep versions, */
/*     and is strongly recommended for the hadron-hadron version. */
/*     However, R values smaller than 1 have been found to be useful for */
/*     certain applications, particularly the mass reconstruction of */
/*     highly-boosted colour-singlets such as high-pt hadronic Ws, */
/*     as in M.H. Seymour, LU TP 93/8 (to appear in Z. Phys. C.). */
/*     Situations in which R<1 is useful are likely to also be those in */
/*     which the inclusive reconstruction method is more useful. */

/*     Also included is a set of routines for doing Lorentz boosts: */
/*     KTLBST finds the boost matrix to/from the cm frame of a 4-vector */
/*     KTRROT finds the rotation matrix from one vector to another */
/*     KTMMUL multiplies together two matrices */
/*     KTVMUL multiplies a vector by a matrix */
/*     KTINVT inverts a transformation matrix (nb NOT a general 4 by 4) */
/*     KTFRAM boosts a list of vectors between two arbitrary frames */
/*     KTBREI boosts a list of vectors between the lab and Breit frames */
/*     KTHADR boosts a list of vectors between the lab and hadronic cmf */
/*       The last two need the momenta in the +z direction of the lepton */
/*       and hadron beams, and the 4-momentum of the outgoing lepton. */

/*     The main reference is: */
/*       S. Catani, Yu.L. Dokshitzer, M.H. Seymour and B.R. Webber, */
/*         Nucl.Phys.B406(1993)187. */
/*     The ep version was proposed in: */
/*       S. Catani, Yu.L. Dokshitzer and B.R. Webber, */
/*         Phys.Lett.285B(1992)291. */
/*     The inclusive reconstruction method was proposed in: */
/*       S.D. Ellis and D.E. Soper, */
/*         Phys.Rev.D48(1993)3160. */

/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktclus_(integer *imode, doublereal *pp, integer *nn, 
	doublereal *ecut, doublereal *y)
{
    extern /* Subroutine */ int ktclur_(integer *, doublereal *, integer *, 
	    doublereal *, doublereal *, doublereal *);
    static doublereal one;

/* ---DO CLUSTER ANALYSIS OF PARTICLES IN PP */

/*   IMODE   = INPUT  : DESCRIBED ABOVE */
/*   PP(I,J) = INPUT  : 4-MOMENTUM OF Jth PARTICLE: I=1,4 => PX,PY,PZ,E */
/*   NN      = INPUT  : NUMBER OF PARTICLES */
/*   ECUT    = INPUT  : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   Y(J)    = OUTPUT : VALUE OF Y FOR WHICH EVENT CHANGES FROM BEING */
/*                        J JET TO J-1 JET */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED (MOST LIKELY DUE TO TOO MANY PARTICLES) */

/*   NOTE THAT THE MOMENTA ARE DECLARED DOUBLE PRECISION, */
/*   AND ALL OTHER FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --y;
    pp -= 5;

    /* Function Body */
    one = 1.;
    switch (ktclur_(imode, &pp[5], nn, &one, ecut, &y[1])) {
	case 1:  goto L999;
    }
    return 0;
L999:
    return 1;
} /* ktclus_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktclur_(integer *imode, doublereal *pp, integer *nn, 
	doublereal *r__, doublereal *ecut, doublereal *y)
{
    /* Initialized data */

    static logical first = TRUE_;
    static char title[10*4*4+1] = "e+e-      ep        pe        pp        a\
ngle     DeltaR    f(DeltaR) **********no        yes       *****************\
***E         Pt        Pt**2     **********";
    static integer iabbr[7] = { 1111,2111,3111,4111,4211,4212,4223 };

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;
    logical L__1;

    /* Builtin functions */
    integer s_wsfe(cilist *), do_fio(integer *, char *, ftnlen), e_wsfe();

    /* Local variables */
    static integer angl, reco, imin, jmin, kmin, mono;
    static doublereal etsq;
    static integer type__, i__, j, n, injet[512];
    static doublereal ktmin, ktmax, kttmp;
    static integer im;
    extern /* Subroutine */ int ktmerg_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *, integer *, integer *);
    extern doublereal ktpair_(integer *, doublereal *, doublereal *, 
	    doublereal *), ktsing_(integer *, integer *, doublereal *);
    extern /* Subroutine */ int ktpmin_(doublereal *, integer *, integer *, 
	    integer *, integer *), ktsmin_(doublereal *, integer *, integer *,
	     integer *), ktwarn_(char *, integer *, ftnlen), ktmove_(
	    doublereal *, doublereal *, doublereal *, integer *, integer *, 
	    integer *, integer *), ktcopy_(doublereal *, integer *, 
	    doublereal *, logical *);

    /* Fortran I/O blocks */
    static cilist io___10 = { 0, 6, 0, "(/,1X,54('*')/A)", 0 };
    static cilist io___11 = { 0, 6, 0, "(A)", 0 };
    static cilist io___12 = { 0, 6, 0, "(A)", 0 };
    static cilist io___13 = { 0, 6, 0, "(/A,I2,2A)", 0 };
    static cilist io___14 = { 0, 6, 0, "(A,I2,2A)", 0 };
    static cilist io___15 = { 0, 6, 0, "(A,I2,2A)", 0 };
    static cilist io___16 = { 0, 6, 0, "(A,I2,2A)", 0 };
    static cilist io___17 = { 0, 6, 0, "(A,F5.2)", 0 };
    static cilist io___18 = { 0, 6, 0, "(A)", 0 };
    static cilist io___19 = { 0, 6, 0, "(1X,54('*')/)", 0 };


/* ---DO CLUSTER ANALYSIS OF PARTICLES IN PP */

/*   IMODE   = INPUT  : DESCRIBED ABOVE */
/*   PP(I,J) = INPUT  : 4-MOMENTUM OF Jth PARTICLE: I=1,4 => PX,PY,PZ,E */
/*   NN      = INPUT  : NUMBER OF PARTICLES */
/*   R       = INPUT  : ELLIS AND SOPER'S R PARAMETER, SEE ABOVE. */
/*   ECUT    = INPUT  : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   Y(J)    = OUTPUT : VALUE OF Y FOR WHICH EVENT CHANGES FROM BEING */
/*                        J JET TO J-1 JET */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED (MOST LIKELY DUE TO TOO MANY PARTICLES) */

/*   NOTE THAT THE MOMENTA ARE DECLARED DOUBLE PRECISION, */
/*   AND ALL OTHER FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

/* ---KT RECORDS THE KT**2 OF EACH MERGING. */
/* ---KTLAST RECORDS FOR EACH MERGING, THE HIGHEST ECUT**2 FOR WHICH THE */
/*   RESULT IS NOT MERGED WITH THE BEAM (COULD BE LARGER THAN THE */
/*   KT**2 AT WHICH IT WAS MERGED IF THE KT VALUES ARE NOT MONOTONIC). */
/*   THIS MAY SOUND POINTLESS, BUT ITS USEFUL FOR DETERMINING WHETHER */
/*   SUB-JETS SURVIVED TO SCALE Y=YMAC OR NOT. */
/* ---HIST RECORDS MERGING HISTORY: */
/*   N=>DELETED TRACK N, M*NMAX+N=>MERGED TRACKS M AND N (M<N). */
    /* Parameter adjustments */
    --y;
    pp -= 5;

    /* Function Body */
/* ---CHECK INPUT */
    im = *imode;
    if (im >= 1 && im <= 7) {
	im = iabbr[im - 1];
    }
    type__ = im / 1000 % 10;
    angl = im / 100 % 10;
    mono = im / 10 % 10;
    reco = im % 10;
    if (*nn > 512 || *nn < 1 || *nn < 2 && type__ == 1) {
	switch (ktwarn_("KTCLUS", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (type__ < 1 || type__ > 4 || angl < 1 || angl > 3 || mono < 1 || mono 
	    > 2 || reco < 1 || reco > 3) {
	switch (ktwarn_("KTCLUS", &c__101, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (first) {
	s_wsfe(&io___10);
	do_fio(&c__1, " KTCLUS: written by Mike Seymour, July 1992.", (ftnlen)
		44);
	e_wsfe();
	s_wsfe(&io___11);
	do_fio(&c__1, " Last modified November 2000.", (ftnlen)29);
	e_wsfe();
	s_wsfe(&io___12);
	do_fio(&c__1, " Please send comments or suggestions to Mike.Seymour@\
rl.ac.uk", (ftnlen)61);
	e_wsfe();
	s_wsfe(&io___13);
	do_fio(&c__1, "       Collision type =", (ftnlen)23);
	do_fio(&c__1, (char *)&type__, (ftnlen)sizeof(integer));
	do_fio(&c__1, " = ", (ftnlen)3);
	do_fio(&c__1, title + (type__ - 1) * 10, (ftnlen)10);
	e_wsfe();
	s_wsfe(&io___14);
	do_fio(&c__1, "     Angular variable =", (ftnlen)23);
	do_fio(&c__1, (char *)&angl, (ftnlen)sizeof(integer));
	do_fio(&c__1, " = ", (ftnlen)3);
	do_fio(&c__1, title + (angl + 3) * 10, (ftnlen)10);
	e_wsfe();
	s_wsfe(&io___15);
	do_fio(&c__1, " Monotonic definition =", (ftnlen)23);
	do_fio(&c__1, (char *)&mono, (ftnlen)sizeof(integer));
	do_fio(&c__1, " = ", (ftnlen)3);
	do_fio(&c__1, title + (mono + 7) * 10, (ftnlen)10);
	e_wsfe();
	s_wsfe(&io___16);
	do_fio(&c__1, " Recombination scheme =", (ftnlen)23);
	do_fio(&c__1, (char *)&reco, (ftnlen)sizeof(integer));
	do_fio(&c__1, " = ", (ftnlen)3);
	do_fio(&c__1, title + (reco + 11) * 10, (ftnlen)10);
	e_wsfe();
	if (*r__ != 1.) {
	    s_wsfe(&io___17);
	    do_fio(&c__1, "     Radius parameter =", (ftnlen)23);
	    do_fio(&c__1, (char *)&(*r__), (ftnlen)sizeof(doublereal));
	    e_wsfe();
	    if (type__ != 4) {
		s_wsfe(&io___18);
		do_fio(&c__1, " R.NE.1 is strongly discouraged for this coll\
ision type!", (ftnlen)56);
		e_wsfe();
	    }
	}
	s_wsfe(&io___19);
	e_wsfe();
	first = FALSE_;
    }
/* ---COPY PP TO P */
    n = *nn;
    ktcomm_1.num = *nn;
    L__1 = reco != 1;
    ktcopy_(&pp[5], &n, ktcomm_1.p, &L__1);
    ktcomm_1.etot = 0.;
    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ktcomm_1.etot += ktcomm_1.p[i__ * 9 - 6];
/* L100: */
    }
    if (ktcomm_1.etot == 0.) {
	switch (ktwarn_("KTCLUS", &c__102, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (*ecut == 0.) {
/* Computing 2nd power */
	d__1 = ktcomm_1.etot;
	etsq = 1 / (d__1 * d__1);
    } else {
/* Computing 2nd power */
	d__1 = *ecut;
	etsq = 1 / (d__1 * d__1);
    }
/* Computing 2nd power */
    d__1 = *r__;
    ktcomm_1.rsq = d__1 * d__1;
/* ---CALCULATE ALL PAIR KT's */
    i__1 = n - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = n;
	for (j = i__ + 1; j <= i__2; ++j) {
	    ktcomm_1.ktp[j + (i__ << 9) - 513] = -1.;
	    ktcomm_1.ktp[i__ + (j << 9) - 513] = ktpair_(&angl, &ktcomm_1.p[
		    i__ * 9 - 9], &ktcomm_1.p[j * 9 - 9], &ktcomm_1.ktp[j + (
		    i__ << 9) - 513]);
/* L200: */
	}
/* L210: */
    }
/* ---CALCULATE ALL SINGLE KT's */
    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ktcomm_1.kts[i__ - 1] = ktsing_(&angl, &type__, &ktcomm_1.p[i__ * 9 - 
		9]);
/* L230: */
    }
    ktmax = 0.;
/* ---MAIN LOOP */
L300:
/* ---FIND MINIMUM MEMBER OF KTP */
    ktpmin_(ktcomm_1.ktp, &c__512, &n, &imin, &jmin);
/* ---FIND MINIMUM MEMBER OF KTS */
    ktsmin_(ktcomm_1.kts, &c__512, &n, &kmin);
/* ---STORE Y VALUE OF TRANSITION FROM N TO N-1 JETS */
    ktmin = ktcomm_1.ktp[imin + (jmin << 9) - 513];
    kttmp = ktcomm_1.rsq * ktcomm_1.kts[kmin - 1];
    if (type__ >= 2 && type__ <= 4 && (kttmp <= ktmin || n == 1)) {
	ktmin = kttmp;
    }
    ktcomm_1.kt[n - 1] = ktmin;
    y[n] = ktcomm_1.kt[n - 1] * etsq;
/* ---IF MONO.GT.1, SEQUENCE IS SUPPOSED TO BE MONOTONIC, IF NOT, WARN */
    if (ktmin < ktmax && mono > 1) {
	switch (ktwarn_("KTCLUS", &c__1, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (ktmin >= ktmax) {
	ktmax = ktmin;
    }
/* ---IF LOWEST KT IS TO A BEAM, THROW IT AWAY AND MOVE LAST ENTRY UP */
    if (ktmin == kttmp) {
	ktmove_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &n, &kmin, &
		c__1);
/* ---UPDATE HISTORY AND CROSS-REFERENCES */
	ktcomm_1.hist[n - 1] = kmin;
	injet[n - 1] = kmin;
	i__1 = *nn;
	for (i__ = n; i__ <= i__1; ++i__) {
	    if (injet[i__ - 1] == kmin) {
		ktcomm_1.ktlast[i__ - 1] = ktmax;
		injet[i__ - 1] = 0;
	    } else if (injet[i__ - 1] == n) {
		injet[i__ - 1] = kmin;
	    }
/* L400: */
	}
/* ---OTHERWISE MERGE JETS IMIN AND JMIN AND MOVE LAST ENTRY UP */
    } else {
	ktmerg_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &imin, &jmin,
		 &n, &type__, &angl, &mono, &reco);
	ktmove_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &n, &jmin, &
		c__1);
/* ---UPDATE HISTORY AND CROSS-REFERENCES */
	ktcomm_1.hist[n - 1] = (imin << 9) + jmin;
	injet[n - 1] = imin;
	i__1 = *nn;
	for (i__ = n; i__ <= i__1; ++i__) {
	    if (injet[i__ - 1] == jmin) {
		injet[i__ - 1] = imin;
	    } else if (injet[i__ - 1] == n) {
		injet[i__ - 1] = jmin;
	    }
/* L600: */
	}
    }
/* ---THATS ALL THERE IS TO IT */
    --n;
    if (n > 1 || n > 0 && (type__ >= 2 && type__ <= 4)) {
	goto L300;
    }
    if (n == 1) {
	ktcomm_1.kt[n - 1] = 1e20;
	y[n] = ktcomm_1.kt[n - 1] * etsq;
    }
    return 0;
L999:
    return 1;
} /* ktclur_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktycut_(doublereal *ecut, integer *ny, doublereal *ycut, 
	integer *njet)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static doublereal etsq;
    static integer i__, j;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---COUNT THE NUMBER OF JETS AT EACH VALUE OF YCUT, FOR EVENT WHICH HAS */
/*   ALREADY BEEN ANALYSED BY KTCLUS. */

/*   ECUT    = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   NY      = INPUT : NUMBER OF YCUT VALUES */
/*   YCUT(J) = INPUT : Y VALUES AT WHICH NUMBERS OF JETS ARE COUNTED */
/*   NJET(J) =OUTPUT : NUMBER OF JETS AT YCUT(J) */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --njet;
    --ycut;

    /* Function Body */
    if (ktcomm_1.etot == 0.) {
	switch (ktwarn_("KTYCUT", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (*ecut == 0.) {
/* Computing 2nd power */
	d__1 = ktcomm_1.etot;
	etsq = 1 / (d__1 * d__1);
    } else {
/* Computing 2nd power */
	d__1 = *ecut;
	etsq = 1 / (d__1 * d__1);
    }
    i__1 = *ny;
    for (i__ = 1; i__ <= i__1; ++i__) {
	njet[i__] = 0;
/* L100: */
    }
    for (i__ = ktcomm_1.num; i__ >= 1; --i__) {
	i__1 = *ny;
	for (j = 1; j <= i__1; ++j) {
	    if (njet[j] == 0 && ktcomm_1.kt[i__ - 1] * etsq >= ycut[j] * 
		    .99999) {
		njet[j] = i__;
	    }
/* L200: */
	}
/* L210: */
    }
    return 0;
L999:
    return 1;
} /* ktycut_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktysub_(doublereal *ecut, integer *ny, doublereal *ycut, 
	doublereal *ymac, integer *nsub)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static doublereal etsq;
    static integer i__, j;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---COUNT THE NUMBER OF SUB-JETS AT EACH VALUE OF YCUT, FOR EVENT WHICH */
/*   HAS ALREADY BEEN ANALYSED BY KTCLUS. */
/*   REMEMBER THAT A SUB-JET IS DEFINED AS A JET AT Y=YCUT WHICH HAS NOT */
/*   YET BEEN MERGED WITH THE BEAM AT Y=YMAC. */

/*   ECUT    = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   NY      = INPUT : NUMBER OF YCUT VALUES */
/*   YCUT(J) = INPUT : Y VALUES AT WHICH NUMBERS OF SUB-JETS ARE COUNTED */
/*   YMAC    = INPUT : Y VALUE USED TO DEFINE MACRO-JETS, TO DETERMINE */
/*                       WHICH JETS ARE SUB-JETS */
/*   NSUB(J) =OUTPUT : NUMBER OF SUB-JETS AT YCUT(J) */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --nsub;
    --ycut;

    /* Function Body */
    if (ktcomm_1.etot == 0.) {
	switch (ktwarn_("KTYSUB", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (*ecut == 0.) {
/* Computing 2nd power */
	d__1 = ktcomm_1.etot;
	etsq = 1 / (d__1 * d__1);
    } else {
/* Computing 2nd power */
	d__1 = *ecut;
	etsq = 1 / (d__1 * d__1);
    }
    i__1 = *ny;
    for (i__ = 1; i__ <= i__1; ++i__) {
	nsub[i__] = 0;
/* L100: */
    }
    for (i__ = ktcomm_1.num; i__ >= 1; --i__) {
	i__1 = *ny;
	for (j = 1; j <= i__1; ++j) {
	    if (nsub[j] == 0 && ktcomm_1.kt[i__ - 1] * etsq >= ycut[j] * 
		    .99999) {
		nsub[j] = i__;
	    }
	    if (nsub[j] != 0 && ktcomm_1.ktlast[i__ - 1] * etsq < *ymac * 
		    .99999) {
		--nsub[j];
	    }
/* L200: */
	}
/* L210: */
    }
    return 0;
L999:
    return 1;
} /* ktysub_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktbeam_(doublereal *ecut, doublereal *y)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static doublereal etsq;
    static integer i__, j;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---GIVE SAME INFORMATION AS LAST CALL TO KTCLUS EXCEPT THAT ONLY */
/*   TRANSITIONS WHERE A JET WAS MERGED WITH THE BEAM JET ARE RECORDED */

/*   ECUT    = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   Y(J)    =OUTPUT : Y VALUE WHERE Jth HARDEST JET WAS MERGED WITH BEAM */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --y;

    /* Function Body */
    if (ktcomm_1.etot == 0.) {
	switch (ktwarn_("KTBEAM", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (*ecut == 0.) {
/* Computing 2nd power */
	d__1 = ktcomm_1.etot;
	etsq = 1 / (d__1 * d__1);
    } else {
/* Computing 2nd power */
	d__1 = *ecut;
	etsq = 1 / (d__1 * d__1);
    }
    j = 1;
    i__1 = ktcomm_1.num;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (ktcomm_1.hist[i__ - 1] <= 512) {
	    y[j] = etsq * ktcomm_1.kt[i__ - 1];
	    ++j;
	}
/* L100: */
    }
    i__1 = ktcomm_1.num;
    for (i__ = j; i__ <= i__1; ++i__) {
	y[i__] = 0.;
/* L200: */
    }
    return 0;
L999:
    return 1;
} /* ktbeam_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktjoin_(doublereal *ecut, doublereal *ymac, doublereal *
	y)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static doublereal etsq;
    static integer i__, j;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---GIVE SAME INFORMATION AS LAST CALL TO KTCLUS EXCEPT THAT ONLY */
/*   TRANSITIONS WHERE TWO SUB-JETS WERE JOINED ARE RECORDED */
/*   REMEMBER THAT A SUB-JET IS DEFINED AS A JET AT Y=YCUT WHICH HAS NOT */
/*   YET BEEN MERGED WITH THE BEAM AT Y=YMAC. */

/*   ECUT    = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   YMAC    = INPUT : VALUE OF Y USED TO DEFINE MACRO-JETS */
/*   Y(J)    =OUTPUT : Y VALUE WHERE EVENT CHANGED FROM HAVING */
/*                         N+J SUB-JETS TO HAVING N+J-1, WHERE N IS */
/*                         THE NUMBER OF MACRO-JETS AT SCALE YMAC */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --y;

    /* Function Body */
    if (ktcomm_1.etot == 0.) {
	switch (ktwarn_("KTJOIN", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    if (*ecut == 0.) {
/* Computing 2nd power */
	d__1 = ktcomm_1.etot;
	etsq = 1 / (d__1 * d__1);
    } else {
/* Computing 2nd power */
	d__1 = *ecut;
	etsq = 1 / (d__1 * d__1);
    }
    j = 1;
    i__1 = ktcomm_1.num;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (ktcomm_1.hist[i__ - 1] > 512 && etsq * ktcomm_1.ktlast[i__ - 1] >=
		 *ymac * .99999) {
	    y[j] = etsq * ktcomm_1.kt[i__ - 1];
	    ++j;
	}
/* L100: */
    }
    i__1 = ktcomm_1.num;
    for (i__ = j; i__ <= i__1; ++i__) {
	y[i__] = 0.;
/* L200: */
    }
    return 0;
L999:
    return 1;
} /* ktjoin_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktreco_(integer *reco, doublereal *pp, integer *nn, 
	doublereal *ecut, doublereal *ycut, doublereal *ymac, doublereal *
	pjet, integer *jet, integer *njet, integer *nsub)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1;
    logical L__1;

    /* Builtin functions */
    double cos(doublereal), sin(doublereal), sinh(doublereal), cosh(
	    doublereal);

    /* Local variables */
    static integer imin, jmin;
    static doublereal etsq;
    static integer i__, j, n;
    extern /* Subroutine */ int ktmerg_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *, integer *, integer *), ktmove_(doublereal *, 
	    doublereal *, doublereal *, integer *, integer *, integer *, 
	    integer *), ktwarn_(char *, integer *, ftnlen), ktcopy_(
	    doublereal *, integer *, doublereal *, logical *);

/* ---RECONSTRUCT KINEMATICS OF JET SYSTEM, WHICH HAS ALREADY BEEN */
/*   ANALYSED BY KTCLUS. NOTE THAT NO CONSISTENCY CHECK IS MADE: USER */
/*   IS TRUSTED TO USE THE SAME PP VALUES AS FOR KTCLUS */

/*   RECO     = INPUT : RECOMBINATION SCHEME (NEED NOT BE SAME AS KTCLUS) */
/*   PP(I,J)  = INPUT : 4-MOMENTUM OF Jth PARTICLE: I=1,4 => PX,PY,PZ,E */
/*   NN       = INPUT : NUMBER OF PARTICLES */
/*   ECUT     = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   YCUT     = INPUT : Y VALUE AT WHICH TO RECONSTRUCT JET MOMENTA */
/*   YMAC     = INPUT : Y VALUE USED TO DEFINE MACRO-JETS, TO DETERMINE */
/*                        WHICH JETS ARE SUB-JETS */
/*   PJET(I,J)=OUTPUT : 4-MOMENTUM OF Jth JET AT SCALE YCUT */
/*   JET(J)   =OUTPUT : THE MACRO-JET WHICH CONTAINS THE Jth JET, */
/*                        SET TO ZERO IF JET IS NOT A SUB-JET */
/*   NJET     =OUTPUT : THE NUMBER OF JETS */
/*   NSUB     =OUTPUT : THE NUMBER OF SUB-JETS (EQUAL TO THE NUMBER OF */
/*                        NON-ZERO ENTRIES IN JET()) */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT THE MOMENTA ARE DECLARED DOUBLE PRECISION, */
/*   AND ALL OTHER FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

/* ---CHECK INPUT */
    /* Parameter adjustments */
    --jet;
    pjet -= 5;
    pp -= 5;

    /* Function Body */
    if (*reco < 1 || *reco > 3) {
	switch (ktwarn_("KTRECO", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---COPY PP TO P */
    n = *nn;
    if (ktcomm_1.num != *nn) {
	switch (ktwarn_("KTRECO", &c__101, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    L__1 = *reco != 1;
    ktcopy_(&pp[5], &n, ktcomm_1.p, &L__1);
    if (*ecut == 0.) {
/* Computing 2nd power */
	d__1 = ktcomm_1.etot;
	etsq = 1 / (d__1 * d__1);
    } else {
/* Computing 2nd power */
	d__1 = *ecut;
	etsq = 1 / (d__1 * d__1);
    }
/* ---KEEP MERGING UNTIL YCUT */
L100:
    if (etsq * ktcomm_1.kt[n - 1] < *ycut * .99999) {
	if (ktcomm_1.hist[n - 1] <= 512) {
	    ktmove_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &n, &
		    ktcomm_1.hist[n - 1], &c__0);
	} else {
	    imin = ktcomm_1.hist[n - 1] / 512;
	    jmin = ktcomm_1.hist[n - 1] - (imin << 9);
	    ktmerg_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &imin, &
		    jmin, &n, &c__0, &c__0, &c__0, reco);
	    ktmove_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &n, &
		    jmin, &c__0);
	}
	--n;
	if (n > 0) {
	    goto L100;
	}
    }
/* ---IF YCUT IS TOO LARGE THERE ARE NO JETS */
    *njet = n;
    *nsub = n;
    if (n == 0) {
	return 0;
    }
/* ---SET UP OUTPUT MOMENTA */
    i__1 = *njet;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (*reco == 1) {
	    for (j = 1; j <= 4; ++j) {
		pjet[j + (i__ << 2)] = ktcomm_1.p[j + i__ * 9 - 10];
/* L200: */
	    }
	} else {
	    pjet[(i__ << 2) + 1] = ktcomm_1.p[i__ * 9 - 4] * cos(ktcomm_1.p[
		    i__ * 9 - 2]);
	    pjet[(i__ << 2) + 2] = ktcomm_1.p[i__ * 9 - 4] * sin(ktcomm_1.p[
		    i__ * 9 - 2]);
	    pjet[(i__ << 2) + 3] = ktcomm_1.p[i__ * 9 - 4] * sinh(ktcomm_1.p[
		    i__ * 9 - 3]);
	    pjet[(i__ << 2) + 4] = ktcomm_1.p[i__ * 9 - 4] * cosh(ktcomm_1.p[
		    i__ * 9 - 3]);
	}
	jet[i__] = i__;
/* L210: */
    }
/* ---KEEP MERGING UNTIL YMAC TO FIND THE FATE OF EACH JET */
L300:
    if (etsq * ktcomm_1.kt[n - 1] < *ymac * .99999) {
	if (ktcomm_1.hist[n - 1] <= 512) {
	    imin = 0;
	    jmin = ktcomm_1.hist[n - 1];
	    --(*nsub);
	} else {
	    imin = ktcomm_1.hist[n - 1] / 512;
	    jmin = ktcomm_1.hist[n - 1] - (imin << 9);
	    if (etsq * ktcomm_1.ktlast[n - 1] < *ymac * .99999) {
		--(*nsub);
	    }
	}
	i__1 = *njet;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    if (jet[i__] == jmin) {
		jet[i__] = imin;
	    }
	    if (jet[i__] == n) {
		jet[i__] = jmin;
	    }
/* L310: */
	}
	--n;
	if (n > 0) {
	    goto L300;
	}
    }
    return 0;
L999:
    return 1;
} /* ktreco_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktincl_(integer *reco, doublereal *pp, integer *nn, 
	doublereal *pjet, integer *jet, integer *njet)
{
    /* System generated locals */
    integer i__1;
    logical L__1;

    /* Builtin functions */
    double cos(doublereal), sin(doublereal), sinh(doublereal), cosh(
	    doublereal);

    /* Local variables */
    static integer imin, jmin, i__, j, n;
    extern /* Subroutine */ int ktmerg_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *, integer *, integer 
	    *, integer *, integer *, integer *), ktmove_(doublereal *, 
	    doublereal *, doublereal *, integer *, integer *, integer *, 
	    integer *), ktwarn_(char *, integer *, ftnlen), ktcopy_(
	    doublereal *, integer *, doublereal *, logical *);

/* ---RECONSTRUCT KINEMATICS OF JET SYSTEM, WHICH HAS ALREADY BEEN */
/*   ANALYSED BY KTCLUS ACCORDING TO THE INCLUSIVE JET DEFINITION. NOTE */
/*   THAT NO CONSISTENCY CHECK IS MADE: USER IS TRUSTED TO USE THE SAME */
/*   PP VALUES AS FOR KTCLUS */

/*   RECO     = INPUT : RECOMBINATION SCHEME (NEED NOT BE SAME AS KTCLUS) */
/*   PP(I,J)  = INPUT : 4-MOMENTUM OF Jth PARTICLE: I=1,4 => PX,PY,PZ,E */
/*   NN       = INPUT : NUMBER OF PARTICLES */
/*   PJET(I,J)=OUTPUT : 4-MOMENTUM OF Jth JET AT SCALE YCUT */
/*   JET(J)   =OUTPUT : THE JET WHICH CONTAINS THE Jth PARTICLE */
/*   NJET     =OUTPUT : THE NUMBER OF JETS */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT THE MOMENTA ARE DECLARED DOUBLE PRECISION, */
/*   AND ALL OTHER FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

/* ---CHECK INPUT */
    /* Parameter adjustments */
    --jet;
    pjet -= 5;
    pp -= 5;

    /* Function Body */
    if (*reco < 1 || *reco > 3) {
	switch (ktwarn_("KTINCL", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---COPY PP TO P */
    n = *nn;
    if (ktcomm_1.num != *nn) {
	switch (ktwarn_("KTINCL", &c__101, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    L__1 = *reco != 1;
    ktcopy_(&pp[5], &n, ktcomm_1.p, &L__1);
/* ---INITIALLY EVERY PARTICLE IS IN ITS OWN JET */
    i__1 = *nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
	jet[i__] = i__;
/* L100: */
    }
/* ---KEEP MERGING TO THE BITTER END */
    *njet = 0;
L200:
    if (n > 0) {
	if (ktcomm_1.hist[n - 1] <= 512) {
	    imin = 0;
	    jmin = ktcomm_1.hist[n - 1];
	    ++(*njet);
	    if (*reco == 1) {
		for (j = 1; j <= 4; ++j) {
		    pjet[j + (*njet << 2)] = ktcomm_1.p[j + jmin * 9 - 10];
/* L300: */
		}
	    } else {
		pjet[(*njet << 2) + 1] = ktcomm_1.p[jmin * 9 - 4] * cos(
			ktcomm_1.p[jmin * 9 - 2]);
		pjet[(*njet << 2) + 2] = ktcomm_1.p[jmin * 9 - 4] * sin(
			ktcomm_1.p[jmin * 9 - 2]);
		pjet[(*njet << 2) + 3] = ktcomm_1.p[jmin * 9 - 4] * sinh(
			ktcomm_1.p[jmin * 9 - 3]);
		pjet[(*njet << 2) + 4] = ktcomm_1.p[jmin * 9 - 4] * cosh(
			ktcomm_1.p[jmin * 9 - 3]);
	    }
	    ktmove_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &n, &
		    jmin, &c__0);
	} else {
	    imin = ktcomm_1.hist[n - 1] / 512;
	    jmin = ktcomm_1.hist[n - 1] - (imin << 9);
	    ktmerg_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &imin, &
		    jmin, &n, &c__0, &c__0, &c__0, reco);
	    ktmove_(ktcomm_1.p, ktcomm_1.ktp, ktcomm_1.kts, &c__512, &n, &
		    jmin, &c__0);
	}
	i__1 = *nn;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    if (jet[i__] == jmin) {
		jet[i__] = imin;
	    }
	    if (jet[i__] == n) {
		jet[i__] = jmin;
	    }
	    if (jet[i__] == 0) {
		jet[i__] = -(*njet);
	    }
/* L400: */
	}
	--n;
	goto L200;
    }
/* ---FINALLY EVERY PARTICLE MUST BE IN AN INCLUSIVE JET */
    i__1 = *nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* ---IF THERE ARE ANY UNASSIGNED PARTICLES SOMETHING MUST HAVE GONE WRONG */
	if (jet[i__] >= 0) {
	    switch (ktwarn_("KTINCL", &c__102, (ftnlen)6)) {
		case 1:  goto L999;
	    }
	}
	jet[i__] = -jet[i__];
/* L500: */
    }
    return 0;
L999:
    return 1;
} /* ktincl_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktisub_(integer *n, integer *ny, doublereal *ycut, 
	integer *nsub)
{
    /* Initialized data */

    static doublereal eps = 1e-6;

    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static integer i__, j, nm;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---COUNT THE NUMBER OF SUB-JETS IN THE Nth INCLUSIVE JET OF AN EVENT */
/*   THAT HAS ALREADY BEEN ANALYSED BY KTCLUS. */

/*   N       = INPUT : WHICH INCLUSIVE JET TO USE */
/*   NY      = INPUT : NUMBER OF YCUT VALUES */
/*   YCUT(J) = INPUT : Y VALUES AT WHICH NUMBERS OF SUB-JETS ARE COUNTED */
/*   NSUB(J) =OUTPUT : NUMBER OF SUB-JETS AT YCUT(J) */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --nsub;
    --ycut;

    /* Function Body */
    i__1 = *ny;
    for (i__ = 1; i__ <= i__1; ++i__) {
	nsub[i__] = 0;
/* L100: */
    }
/* ---FIND WHICH MERGING CORRESPONDS TO THE NTH INCLUSIVE JET */
    nm = 0;
    j = 0;
    for (i__ = ktcomm_1.num; i__ >= 1; --i__) {
	if (ktcomm_1.hist[i__ - 1] <= 512) {
	    ++j;
	}
	if (j == *n) {
	    nm = i__;
	    goto L120;
	}
/* L110: */
    }
L120:
/* ---GIVE UP IF THERE ARE LESS THAN N INCLUSIVE JETS */
    if (nm == 0) {
	switch (ktwarn_("KTISUB", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    for (i__ = ktcomm_1.num; i__ >= 1; --i__) {
	i__1 = *ny;
	for (j = 1; j <= i__1; ++j) {
	    if (nsub[j] == 0 && ktcomm_1.rsq * ktcomm_1.kt[i__ - 1] >= ycut[j]
		     * .99999 * ktcomm_1.kt[nm - 1]) {
		nsub[j] = i__;
	    }
	    if (nsub[j] != 0 && (d__1 = ktcomm_1.ktlast[i__ - 1] - 
		    ktcomm_1.ktlast[nm - 1], abs(d__1)) > eps) {
		--nsub[j];
	    }
/* L200: */
	}
/* L210: */
    }
    return 0;
L999:
    return 1;
} /* ktisub_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktijoi_(integer *n, doublereal *y)
{
    /* Initialized data */

    static doublereal eps = 1e-6;

    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Local variables */
    static integer i__, j, nm;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---GIVE SAME INFORMATION AS LAST CALL TO KTCLUS EXCEPT THAT ONLY */
/*   MERGES OF TWO SUB-JETS INSIDE THE Nth INCLUSIVE JET ARE RECORDED */

/*   N       = INPUT : WHICH INCLUSIVE JET TO USE */
/*   Y(J)    =OUTPUT : Y VALUE WHERE JET CHANGED FROM HAVING */
/*                         J+1 SUB-JETS TO HAVING J */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --y;

    /* Function Body */
/* ---FIND WHICH MERGING CORRESPONDS TO THE NTH INCLUSIVE JET */
    nm = 0;
    j = 0;
    for (i__ = ktcomm_1.num; i__ >= 1; --i__) {
	if (ktcomm_1.hist[i__ - 1] <= 512) {
	    ++j;
	}
	if (j == *n) {
	    nm = i__;
	    goto L105;
	}
/* L100: */
    }
L105:
/* ---GIVE UP IF THERE ARE LESS THAN N INCLUSIVE JETS */
    if (nm == 0) {
	switch (ktwarn_("KTIJOI", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    j = 1;
    i__1 = ktcomm_1.num;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (ktcomm_1.hist[i__ - 1] > 512 && (d__1 = ktcomm_1.ktlast[i__ - 1] 
		- ktcomm_1.ktlast[nm - 1], abs(d__1)) < eps) {
	    y[j] = ktcomm_1.rsq * ktcomm_1.kt[i__ - 1] / ktcomm_1.kt[nm - 1];
	    ++j;
	}
/* L110: */
    }
    i__1 = ktcomm_1.num;
    for (i__ = j; i__ <= i__1; ++i__) {
	y[i__] = 0.;
/* L200: */
    }
    return 0;
L999:
    return 1;
} /* ktijoi_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktirec_(integer *reco, doublereal *pp, integer *nn, 
	integer *n, doublereal *ycut, doublereal *psub, integer *nsub)
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static doublereal ymac;
    static integer njet;
    static doublereal ecut;
    static integer i__, j, nm;
    extern /* Subroutine */ int ktreco_(integer *, doublereal *, integer *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, integer *,
	     integer *, integer *), ktwarn_(char *, integer *, ftnlen);
    static integer jet[512];

/* ---RECONSTRUCT KINEMATICS OF SUB-JET SYSTEM IN THE Nth INCLUSIVE JET */
/*   OF AN EVENT THAT HAS ALREADY BEEN ANALYSED BY KTCLUS */

/*   RECO     = INPUT : RECOMBINATION SCHEME (NEED NOT BE SAME AS KTCLUS) */
/*   PP(I,J)  = INPUT : 4-MOMENTUM OF Jth PARTICLE: I=1,4 => PX,PY,PZ,E */
/*   NN       = INPUT : NUMBER OF PARTICLES */
/*   N        = INPUT : WHICH INCLUSIVE JET TO USE */
/*   YCUT     = INPUT : Y VALUE AT WHICH TO RECONSTRUCT JET MOMENTA */
/*   PSUB(I,J)=OUTPUT : 4-MOMENTUM OF Jth SUB-JET AT SCALE YCUT */
/*   NSUB     =OUTPUT : THE NUMBER OF SUB-JETS */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT THE MOMENTA ARE DECLARED DOUBLE PRECISION, */
/*   AND ALL OTHER FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

/* ---FIND WHICH MERGING CORRESPONDS TO THE NTH INCLUSIVE JET */
    /* Parameter adjustments */
    psub -= 5;
    pp -= 5;

    /* Function Body */
    nm = 0;
    j = 0;
    for (i__ = ktcomm_1.num; i__ >= 1; --i__) {
	if (ktcomm_1.hist[i__ - 1] <= 512) {
	    ++j;
	}
	if (j == *n) {
	    nm = i__;
	    goto L110;
	}
/* L100: */
    }
L110:
/* ---GIVE UP IF THERE ARE LESS THAN N INCLUSIVE JETS */
    if (nm == 0) {
	switch (ktwarn_("KTIREC", &c__102, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---RECONSTRUCT THE JETS AT THE APPROPRIATE SCALE */
    ecut = sqrt(ktcomm_1.kt[nm - 1] / ktcomm_1.rsq);
    ymac = ktcomm_1.rsq;
    switch (ktreco_(reco, &pp[5], nn, &ecut, ycut, &ymac, &psub[5], jet, &
	    njet, nsub)) {
	case 1:  goto L999;
    }
/* ---GET RID OF THE ONES THAT DO NOT END UP IN THE JET WE WANT */
    *nsub = 0;
    i__1 = njet;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (jet[i__ - 1] == ktcomm_1.hist[nm - 1]) {
	    ++(*nsub);
	    for (j = 1; j <= 4; ++j) {
		psub[j + (*nsub << 2)] = psub[j + (i__ << 2)];
/* L200: */
	    }
	}
/* L210: */
    }
    return 0;
L999:
    return 1;
} /* ktirec_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktwich_(doublereal *ecut, doublereal *ycut, integer *jet,
	 integer *njet)
{
    static integer ntemp;
    extern /* Subroutine */ int ktwchs_(doublereal *, doublereal *, 
	    doublereal *, integer *, integer *, integer *);

/* ---GIVE A LIST OF WHICH JET EACH ORIGINAL PARTICLE ENDED UP IN AT SCALE */
/*   YCUT, TOGETHER WITH THE NUMBER OF JETS AT THAT SCALE. */

/*   ECUT     = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   YCUT     = INPUT : Y VALUE AT WHICH TO DEFINE JETS */
/*   JET(J)   =OUTPUT : THE JET WHICH CONTAINS THE Jth PARTICLE, */
/*                        SET TO ZERO IF IT WAS PUT INTO THE BEAM JETS */
/*   NJET     =OUTPUT : THE NUMBER OF JETS AT SCALE YCUT (SO JET() */
/*                        ENTRIES WILL BE IN THE RANGE 0 -> NJET) */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

    /* Parameter adjustments */
    --jet;

    /* Function Body */
    switch (ktwchs_(ecut, ycut, ycut, &jet[1], njet, &ntemp)) {
	case 1:  goto L999;
    }
    return 0;
L999:
    return 1;
} /* ktwich_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktwchs_(doublereal *ecut, doublereal *ycut, doublereal *
	ymac, integer *jet, integer *njet, integer *nsub)
{
    /* Initialized data */

    static doublereal p1[2048]	/* was [4][512] */ = { 1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,
	    0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,
	    1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1.,1.,0.,0.,1. };
    static doublereal zero = 0.;

    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer jsub[512], i__;
    static doublereal p2[2048]	/* was [4][512] */;
    extern /* Subroutine */ int ktreco_(integer *, doublereal *, integer *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, integer *,
	     integer *, integer *);

/* ---GIVE A LIST OF WHICH SUB-JET EACH ORIGINAL PARTICLE ENDED UP IN AT */
/*   SCALE YCUT, WITH MACRO-JET SCALE YMAC, TOGETHER WITH THE NUMBER OF */
/*   JETS AT SCALE YCUT AND THE NUMBER OF THEM WHICH ARE SUB-JETS. */

/*   ECUT     = INPUT : DENOMINATOR OF KT MEASURE. IF ZERO, ETOT IS USED */
/*   YCUT     = INPUT : Y VALUE AT WHICH TO DEFINE JETS */
/*   YMAC     = INPUT : Y VALUE AT WHICH TO DEFINE MACRO-JETS */
/*   JET(J)   =OUTPUT : THE JET WHICH CONTAINS THE Jth PARTICLE, */
/*                        SET TO ZERO IF IT WAS PUT INTO THE BEAM JETS */
/*   NJET     =OUTPUT : THE NUMBER OF JETS AT SCALE YCUT (SO JET() */
/*                        ENTRIES WILL BE IN THE RANGE 0 -> NJET) */
/*   NSUB     =OUTPUT : THE NUMBER OF SUB-JETS AT SCALE YCUT, WITH */
/*                        MACRO-JETS DEFINED AT SCALE YMAC (SO ONLY NSUB */
/*                        OF THE JETS 1 -> NJET WILL APPEAR IN JET()) */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL FLOATING POINT VARIABLES ARE DECLARED DOUBLE PRECISION */

/* ---THE MOMENTA HAVE TO BEEN GIVEN LEGAL VALUES, */
/*   EVEN THOUGH THEY WILL NEVER BE USED */
    /* Parameter adjustments */
    --jet;

    /* Function Body */
/* ---FIRST GET A LIST OF WHICH PARTICLE IS IN WHICH JET AT YCUT */
    switch (ktreco_(&c__1, p1, &ktcomm_1.num, ecut, &zero, ycut, p2, &jet[1], 
	    njet, nsub)) {
	case 1:  goto L999;
    }
/* ---THEN FIND OUT WHICH JETS ARE SUBJETS */
    switch (ktreco_(&c__1, p1, &ktcomm_1.num, ecut, ycut, ymac, p2, jsub, 
	    njet, nsub)) {
	case 1:  goto L999;
    }
/* ---AND MODIFY JET() ACCORDINGLY */
    i__1 = ktcomm_1.num;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (jet[i__] != 0) {
	    if (jsub[jet[i__] - 1] == 0) {
		jet[i__] = 0;
	    }
	}
/* L10: */
    }
    return 0;
L999:
    return 1;
} /* ktwchs_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktfram_(integer *iopt, doublereal *cmf, doublereal *sign,
	 doublereal *z__, doublereal *xz, integer *n, doublereal *p, 
	doublereal *q)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__;
    static doublereal r__[16]	/* was [4][4] */;
    extern /* Subroutine */ int ktlbst_(integer *, doublereal *, doublereal *)
	    , ktwarn_(char *, integer *, ftnlen), ktunit_(doublereal *), 
	    ktinvt_(doublereal *, doublereal *), ktvmul_(doublereal *, 
	    doublereal *, doublereal *), ktrrot_(doublereal *, doublereal *, 
	    doublereal *);
    static doublereal old[4], new__[4];

/* ---BOOST PARTICLES IN P TO/FROM FRAME GIVEN BY CMF, Z, XZ. */
/* ---IN THIS FRAME CMZ IS STATIONARY, */
/*                   Z IS ALONG THE (SIGN)Z-AXIS (SIGN=+ OR -) */
/*                  XZ IS IN THE X-Z PLANE (WITH POSITIVE X COMPONENT) */
/* ---IF Z HAS LENGTH ZERO, OR SIGN=0, NO ROTATION IS PERFORMED */
/* ---IF XZ HAS ZERO COMPONENT PERPENDICULAR TO Z IN THAT FRAME, */
/*   NO AZIMUTHAL ROTATION IS PERFORMED */

/*   IOPT    = INPUT  : 0=TO FRAME, 1=FROM FRAME */
/*   CMF(I)  = INPUT  : 4-MOMENTUM WHICH IS STATIONARY IN THE FRAME */
/*   SIGN    = INPUT  : DIRECTION OF Z IN THE FRAME, NOTE THAT */
/*                        ONLY ITS SIGN IS USED, NOT ITS MAGNITUDE */
/*   Z(I)    = INPUT  : 4-MOMENTUM WHICH LIES ON THE (SIGN)Z-AXIS */
/*   XZ(I)   = INPUT  : 4-MOMENTUM WHICH LIES IN THE X-Z PLANE */
/*   N       = INPUT  : NUMBER OF PARTICLES IN P */
/*   P(I,J)  = INPUT  : 4-MOMENTUM OF JTH PARTICLE BEFORE */
/*   Q(I,J)  = OUTPUT : 4-MOMENTUM OF JTH PARTICLE AFTER */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED */

/*   NOTE THAT ALL MOMENTA ARE DOUBLE PRECISION */

/*   NOTE THAT IT IS SAFE TO CALL WITH P=Q */

    /* Parameter adjustments */
    --cmf;
    --z__;
    --xz;
    q -= 5;
    p -= 5;

    /* Function Body */
    if (*iopt < 0 || *iopt > 1) {
	switch (ktwarn_("KTFRAM", &c__200, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---FIND BOOST TO GET THERE FROM LAB */
    ktunit_(r__);
    switch (ktlbst_(&c__0, r__, &cmf[1])) {
	case 1:  goto L999;
    }
/* ---FIND ROTATION TO PUT BOOSTED Z ON THE (SIGN)Z AXIS */
    if (*sign != 0.) {
	ktvmul_(r__, &z__[1], old);
	if (old[0] != 0. || old[1] != 0. || old[2] != 0.) {
	    new__[0] = 0.;
	    new__[1] = 0.;
	    new__[2] = *sign;
	    new__[3] = abs(*sign);
	    switch (ktrrot_(r__, old, new__)) {
		case 1:  goto L999;
	    }
/* ---FIND ROTATION TO PUT BOOSTED AND ROTATED XZ INTO X-Z PLANE */
	    ktvmul_(r__, &xz[1], old);
	    if (old[0] != 0. || old[1] != 0.) {
		new__[0] = 1.;
		new__[1] = 0.;
		new__[2] = 0.;
		new__[3] = 1.;
		old[2] = 0.;
/* ---NOTE THAT A POTENTIALLY AWKWARD SPECIAL CASE IS AVERTED, BECAUSE IF */
/*   OLD AND NEW ARE EXACTLY BACK-TO-BACK, THE ROTATION AXIS IS UNDEFINED */
/*   BUT IN THAT CASE KTRROT WILL USE THE Z AXIS, AS REQUIRED */
		switch (ktrrot_(r__, old, new__)) {
		    case 1:  goto L999;
		}
	    }
	}
    }
/* ---INVERT THE TRANSFORMATION IF NECESSARY */
    if (*iopt == 1) {
	ktinvt_(r__, r__);
    }
/* ---APPLY THE RESULT TO ALL THE VECTORS */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ktvmul_(r__, &p[(i__ << 2) + 1], &q[(i__ << 2) + 1]);
/* L30: */
    }
    return 0;
L999:
    return 1;
} /* ktfram_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktbrei_(integer *iopt, doublereal *plep, doublereal *
	phad, doublereal *pout, integer *n, doublereal *p, doublereal *q)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2, d__3, d__4;

    /* Local variables */
    static doublereal z__[4], xz[4];
    extern /* Subroutine */ int ktfram_(integer *, doublereal *, doublereal *,
	     doublereal *, doublereal *, integer *, doublereal *, doublereal *
	    ), ktwarn_(char *, integer *, ftnlen);
    static doublereal cmf[4], qdq, dot;

/* ---BOOST PARTICLES IN P TO/FROM BREIT FRAME */

/*   IOPT    = INPUT  : 0/2=TO BREIT FRAME, 1/3=FROM BREIT FRAME */
/*                      0/1=NO AZIMUTHAL ROTATION AFTERWARDS */
/*                      2/3=LEPTON PLANE ROTATED INTO THE X-Z PLANE */
/*   PLEP    = INPUT  : MOMENTUM OF INCOMING LEPTON IN +Z DIRECTION */
/*   PHAD    = INPUT  : MOMENTUM OF INCOMING HADRON IN +Z DIRECTION */
/*   POUT(I) = INPUT  : 4-MOMENTUM OF OUTGOING LEPTON */
/*   N       = INPUT  : NUMBER OF PARTICLES IN P */
/*   P(I,J)  = INPUT  : 4-MOMENTUM OF JTH PARTICLE BEFORE */
/*   Q(I,J)  = OUTPUT : 4-MOMENTUM OF JTH PARTICLE AFTER */
/*   LAST ARGUMENT IS LABEL TO JUMP TO IF FOR ANY REASON THE EVENT */
/*   COULD NOT BE PROCESSED (MOST LIKELY DUE TO PARTICLES HAVING SMALLER */
/*   ENERGY THAN MOMENTUM) */

/*   NOTE THAT ALL MOMENTA ARE DOUBLE PRECISION */

/*   NOTE THAT IT IS SAFE TO CALL WITH P=Q */

/* ---CHECK INPUT */
    /* Parameter adjustments */
    --pout;
    q -= 5;
    p -= 5;

    /* Function Body */
    if (*iopt < 0 || *iopt > 3) {
	switch (ktwarn_("KTBREI", &c__200, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---FIND 4-MOMENTUM OF BREIT FRAME (TIMES AN ARBITRARY FACTOR) */
    dot = abs(*phad) * (abs(*plep) - pout[4]) - *phad * (*plep - pout[3]);
/* Computing 2nd power */
    d__1 = abs(*plep) - pout[4];
/* Computing 2nd power */
    d__2 = *plep - pout[3];
/* Computing 2nd power */
    d__3 = pout[2];
/* Computing 2nd power */
    d__4 = pout[1];
    qdq = d__1 * d__1 - d__2 * d__2 - d__3 * d__3 - d__4 * d__4;
    cmf[0] = dot * (-pout[1]);
    cmf[1] = dot * (-pout[2]);
    cmf[2] = dot * (*plep - pout[3]) - qdq * *phad;
    cmf[3] = dot * (abs(*plep) - pout[4]) - qdq * abs(*phad);
/* ---FIND ROTATION TO PUT INCOMING HADRON BACK ON Z-AXIS */
    z__[0] = 0.;
    z__[1] = 0.;
    z__[2] = *phad;
    z__[3] = abs(*phad);
    xz[0] = 0.;
    xz[1] = 0.;
    xz[2] = 0.;
    xz[3] = 0.;
/* ---DO THE BOOST */
    if (*iopt <= 1) {
	switch (ktfram_(iopt, cmf, phad, z__, xz, n, &p[5], &q[5])) {
	    case 1:  goto L999;
	}
    } else {
	i__1 = *iopt - 2;
	switch (ktfram_(&i__1, cmf, phad, z__, &pout[1], n, &p[5], &q[5])) {
	    case 1:  goto L999;
	}
    }
    return 0;
L999:
    return 1;
} /* ktbrei_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int kthadr_(integer *iopt, doublereal *plep, doublereal *
	phad, doublereal *pout, integer *n, doublereal *p, doublereal *q)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static doublereal z__[4], xz[4];
    extern /* Subroutine */ int ktfram_(integer *, doublereal *, doublereal *,
	     doublereal *, doublereal *, integer *, doublereal *, doublereal *
	    ), ktwarn_(char *, integer *, ftnlen);
    static doublereal cmf[4];

/* ---BOOST PARTICLES IN P TO/FROM HADRONIC CMF */

/*   ARGUMENTS ARE EXACTLY AS FOR KTBREI */

/*   NOTE THAT ALL MOMENTA ARE DOUBLE PRECISION */

/*   NOTE THAT IT IS SAFE TO CALL WITH P=Q */

/* ---CHECK INPUT */
    /* Parameter adjustments */
    --pout;
    q -= 5;
    p -= 5;

    /* Function Body */
    if (*iopt < 0 || *iopt > 3) {
	switch (ktwarn_("KTHADR", &c__200, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---FIND 4-MOMENTUM OF HADRONIC CMF */
    cmf[0] = -pout[1];
    cmf[1] = -pout[2];
    cmf[2] = *plep - pout[3] + *phad;
    cmf[3] = abs(*plep) - pout[4] + abs(*phad);
/* ---FIND ROTATION TO PUT INCOMING HADRON BACK ON Z-AXIS */
    z__[0] = 0.;
    z__[1] = 0.;
    z__[2] = *phad;
    z__[3] = abs(*phad);
    xz[0] = 0.;
    xz[1] = 0.;
    xz[2] = 0.;
    xz[3] = 0.;
/* ---DO THE BOOST */
    if (*iopt <= 1) {
	switch (ktfram_(iopt, cmf, phad, z__, xz, n, &p[5], &q[5])) {
	    case 1:  goto L999;
	}
    } else {
	i__1 = *iopt - 2;
	switch (ktfram_(&i__1, cmf, phad, z__, &pout[1], n, &p[5], &q[5])) {
	    case 1:  goto L999;
	}
    }
    return 0;
L999:
    return 1;
} /* kthadr_ */

/* ----------------------------------------------------------------------- */
doublereal ktpair_(integer *angl, doublereal *p, doublereal *q, doublereal *
	angle)
{
    /* System generated locals */
    doublereal ret_val, d__1, d__2;

    /* Builtin functions */
    double cosh(doublereal), cos(doublereal);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static doublereal r__;
    extern doublereal ktmdpi_(doublereal *);
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);
    static doublereal eta, phi, esq;

/* ---CALCULATE LOCAL KT OF PAIR, USING ANGULAR SCHEME: */
/*   1=>ANGULAR, 2=>DeltaR, 3=>f(DeltaEta,DeltaPhi) */
/*   WHERE f(eta,phi)=2(COSH(eta)-COS(phi)) IS THE QCD EMISSION METRIC */
/* ---IF ANGLE<0, IT IS SET TO THE ANGULAR PART OF THE LOCAL KT ON RETURN */
/*   IF ANGLE>0, IT IS USED INSTEAD OF THE ANGULAR PART OF THE LOCAL KT */
/* ---COMPONENTS OF MOMENTA ARE PX,PY,PZ,E,1/P,PT,ETA,PHI,PT**2 */
    /* Parameter adjustments */
    --q;
    --p;

    /* Function Body */
    r__ = *angle;
    if (*angl == 1) {
	if (r__ <= 0.) {
	    r__ = (1 - (p[1] * q[1] + p[2] * q[2] + p[3] * q[3]) * (p[5] * q[
		    5])) * 2;
	}
/* Computing 2nd power */
	d__1 = min(p[4],q[4]);
	esq = d__1 * d__1;
    } else if (*angl == 2 || *angl == 3) {
	if (r__ <= 0.) {
	    eta = p[7] - q[7];
	    d__1 = p[8] - q[8];
	    phi = ktmdpi_(&d__1);
	    if (*angl == 2) {
/* Computing 2nd power */
		d__1 = eta;
/* Computing 2nd power */
		d__2 = phi;
		r__ = d__1 * d__1 + d__2 * d__2;
	    } else {
		r__ = (cosh(eta) - cos(phi)) * 2;
	    }
	}
	esq = min(p[9],q[9]);
    } else {
	switch (ktwarn_("KTPAIR", &c__200, (ftnlen)6)) {
	    case 1:  goto L999;
	}
	s_stop("", (ftnlen)0);
    }
    ret_val = esq * r__;
    if (*angle < 0.) {
	*angle = r__;
    }
L999:
    return ret_val;
} /* ktpair_ */

/* ----------------------------------------------------------------------- */
doublereal ktsing_(integer *angl, integer *type__, doublereal *p)
{
    /* Initialized data */

    static doublereal small = 1e-4;

    /* System generated locals */
    doublereal ret_val, d__1, d__2, d__3;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static doublereal r__, costh;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);

/* ---CALCULATE KT OF PARTICLE, USING ANGULAR SCHEME: */
/*   1=>ANGULAR, 2=>DeltaR, 3=>f(DeltaEta,DeltaPhi) */
/* ---TYPE=1 FOR E+E-, 2 FOR EP, 3 FOR PE, 4 FOR PP */
/*   FOR EP, PROTON DIRECTION IS DEFINED AS -Z */
/*   FOR PE, PROTON DIRECTION IS DEFINED AS +Z */
    /* Parameter adjustments */
    --p;

    /* Function Body */
    if (*angl == 1) {
	costh = p[3] * p[5];
	if (*type__ == 2) {
	    costh = -costh;
	} else if (*type__ == 4) {
	    costh = abs(costh);
	} else if (*type__ != 1 && *type__ != 3) {
	    switch (ktwarn_("KTSING", &c__200, (ftnlen)6)) {
		case 1:  goto L999;
	    }
	    s_stop("", (ftnlen)0);
	}
	r__ = (1 - costh) * 2;
/* ---IF CLOSE TO BEAM, USE APPROX 2*(1-COS(THETA))=SIN**2(THETA) */
	if (r__ < small) {
/* Computing 2nd power */
	    d__1 = p[1];
/* Computing 2nd power */
	    d__2 = p[2];
/* Computing 2nd power */
	    d__3 = p[5];
	    r__ = (d__1 * d__1 + d__2 * d__2) * (d__3 * d__3);
	}
/* Computing 2nd power */
	d__1 = p[4];
	ret_val = d__1 * d__1 * r__;
    } else if (*angl == 2 || *angl == 3) {
	ret_val = p[9];
    } else {
	switch (ktwarn_("KTSING", &c__201, (ftnlen)6)) {
	    case 1:  goto L999;
	}
	s_stop("", (ftnlen)0);
    }
L999:
    return ret_val;
} /* ktsing_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktpmin_(doublereal *a, integer *nmax, integer *n, 
	integer *imin, integer *jmin)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static doublereal amin;
    static integer kmin, i__, j, k;

/* ---FIND THE MINIMUM MEMBER OF A(NMAX,NMAX) WITH IMIN < JMIN <= N */
/* ---REMEMBER THAT A(X+(Y-1)*NMAX)=A(X,Y) */
/*   THESE LOOPING VARIABLES ARE J=Y-2, I=X+(Y-1)*NMAX */
    /* Parameter adjustments */
    --a;

    /* Function Body */
    k = *nmax + 1;
    kmin = k;
    amin = a[kmin];
    i__1 = *n - 2;
    for (j = 0; j <= i__1; ++j) {
	i__2 = k + j;
	for (i__ = k; i__ <= i__2; ++i__) {
	    if (a[i__] < amin) {
		kmin = i__;
		amin = a[kmin];
	    }
/* L100: */
	}
	k += *nmax;
/* L110: */
    }
    *jmin = kmin / *nmax + 1;
    *imin = kmin - (*jmin - 1) * *nmax;
    return 0;
} /* ktpmin_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktsmin_(doublereal *a, integer *nmax, integer *n, 
	integer *imin)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__;

/* ---FIND THE MINIMUM MEMBER OF A */
    /* Parameter adjustments */
    --a;

    /* Function Body */
    *imin = 1;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (a[i__] < a[*imin]) {
	    *imin = i__;
	}
/* L100: */
    }
    return 0;
} /* ktsmin_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktcopy_(doublereal *a, integer *n, doublereal *b, 
	logical *onshll)
{
    /* Initialized data */

    static doublereal etamax = 10.;
    static doublereal sinmin = 0.;
    static doublereal eps = 1e-6;

    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    double cosh(doublereal), sqrt(doublereal), log(doublereal), d_sign(
	    doublereal *, doublereal *), atan2(doublereal, doublereal);

    /* Local variables */
    static integer i__;

/* ---COPY FROM A TO B. 5TH=1/(3-MTM), 6TH=PT, 7TH=ETA, 8TH=PHI, 9TH=PT**2 */
/*   IF ONSHLL IS .TRUE. PARTICLE ENTRIES ARE PUT ON-SHELL BY SETTING E=P */
    /* Parameter adjustments */
    b -= 10;
    a -= 5;

    /* Function Body */
/* ---SINMIN GETS CALCULATED ON FIRST CALL */
    if (sinmin == 0.) {
	sinmin = 1 / cosh(etamax);
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	b[i__ * 9 + 1] = a[(i__ << 2) + 1];
	b[i__ * 9 + 2] = a[(i__ << 2) + 2];
	b[i__ * 9 + 3] = a[(i__ << 2) + 3];
	b[i__ * 9 + 4] = a[(i__ << 2) + 4];
/* Computing 2nd power */
	d__1 = a[(i__ << 2) + 1];
/* Computing 2nd power */
	d__2 = a[(i__ << 2) + 2];
/* Computing 2nd power */
	d__3 = a[(i__ << 2) + 3];
	b[i__ * 9 + 5] = sqrt(d__1 * d__1 + d__2 * d__2 + d__3 * d__3);
	if (*onshll) {
	    b[i__ * 9 + 4] = b[i__ * 9 + 5];
	}
	if (b[i__ * 9 + 5] == 0.) {
	    b[i__ * 9 + 5] = 1e-10;
	}
	b[i__ * 9 + 5] = 1 / b[i__ * 9 + 5];
/* Computing 2nd power */
	d__1 = a[(i__ << 2) + 1];
/* Computing 2nd power */
	d__2 = a[(i__ << 2) + 2];
	b[i__ * 9 + 9] = d__1 * d__1 + d__2 * d__2;
	b[i__ * 9 + 6] = sqrt(b[i__ * 9 + 9]);
	b[i__ * 9 + 7] = b[i__ * 9 + 6] * b[i__ * 9 + 5];
	if (b[i__ * 9 + 7] > sinmin) {
/* Computing 2nd power */
	    d__1 = a[(i__ << 2) + 4];
/* Computing 2nd power */
	    d__2 = a[(i__ << 2) + 3];
	    b[i__ * 9 + 7] = d__1 * d__1 - d__2 * d__2;
/* Computing 2nd power */
	    d__1 = b[i__ * 9 + 4];
	    if (b[i__ * 9 + 7] <= eps * (d__1 * d__1) || *onshll) {
		b[i__ * 9 + 7] = b[i__ * 9 + 9];
	    }
/* Computing 2nd power */
	    d__2 = b[i__ * 9 + 4] + (d__1 = b[i__ * 9 + 3], abs(d__1));
	    b[i__ * 9 + 7] = log(d__2 * d__2 / b[i__ * 9 + 7]) / 2;
	} else {
	    b[i__ * 9 + 7] = etamax + 2;
	}
	b[i__ * 9 + 7] = d_sign(&b[i__ * 9 + 7], &b[i__ * 9 + 3]);
	if (a[(i__ << 2) + 1] == 0. && a[(i__ << 2) + 2] == 0.) {
	    b[i__ * 9 + 8] = 0.;
	} else {
	    b[i__ * 9 + 8] = atan2(a[(i__ << 2) + 2], a[(i__ << 2) + 1]);
	}
/* L100: */
    }
    return 0;
} /* ktcopy_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktmerg_(doublereal *p, doublereal *ktp, doublereal *kts, 
	integer *nmax, integer *i__, integer *j, integer *n, integer *type__, 
	integer *angl, integer *mono, integer *reco)
{
    /* Initialized data */

    static doublereal etamax = 10.;
    static doublereal eps = 1e-6;

    /* System generated locals */
    integer ktp_dim1, ktp_offset, i__1;
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);
    double sqrt(doublereal), log(doublereal), d_sign(doublereal *, doublereal 
	    *), atan2(doublereal, doublereal), cos(doublereal), sin(
	    doublereal), sinh(doublereal), cosh(doublereal);

    /* Local variables */
    static integer k;
    static doublereal pi, pj, pt;
    extern doublereal ktmdpi_(doublereal *), ktpair_(integer *, doublereal *, 
	    doublereal *, doublereal *), ktsing_(integer *, integer *, 
	    doublereal *);
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen);
    static doublereal ang, ptt;

/* ---MERGE THE Jth PARTICLE IN P INTO THE Ith PARTICLE */
/*   J IS ASSUMED GREATER THAN I. P CONTAINS N PARTICLES BEFORE MERGING. */
/* ---ALSO RECALCULATING THE CORRESPONDING KTP AND KTS VALUES IF MONO.GT.0 */
/*   FROM THE RECOMBINED ANGULAR MEASURES IF MONO.GT.1 */
/* ---NOTE THAT IF MONO.LE.0, TYPE AND ANGL ARE NOT USED */
    /* Parameter adjustments */
    --kts;
    ktp_dim1 = *nmax;
    ktp_offset = 1 + ktp_dim1 * 1;
    ktp -= ktp_offset;
    p -= 10;

    /* Function Body */
    if (*j <= *i__) {
	switch (ktwarn_("KTMERG", &c__200, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
/* ---COMBINE ANGULAR MEASURES IF NECESSARY */
    if (*mono > 1) {
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
	    if (k != *i__ && k != *j) {
		if (*reco == 1) {
		    pi = p[*i__ * 9 + 4];
		    pj = p[*j * 9 + 4];
		} else if (*reco == 2) {
		    pi = p[*i__ * 9 + 6];
		    pj = p[*j * 9 + 6];
		} else if (*reco == 3) {
		    pi = p[*i__ * 9 + 9];
		    pj = p[*j * 9 + 9];
		} else {
		    switch (ktwarn_("KTMERG", &c__201, (ftnlen)6)) {
			case 1:  goto L999;
		    }
		    s_stop("", (ftnlen)0);
		}
		if (pi == 0. && pj == 0.) {
		    pi = 1.;
		    pj = 1.;
		}
		ktp[max(*i__,k) + min(*i__,k) * ktp_dim1] = (pi * ktp[max(*
			i__,k) + min(*i__,k) * ktp_dim1] + pj * ktp[max(*j,k) 
			+ min(*j,k) * ktp_dim1]) / (pi + pj);
	    }
/* L100: */
	}
    }
    if (*reco == 1) {
/* ---VECTOR ADDITION */
	p[*i__ * 9 + 1] += p[*j * 9 + 1];
	p[*i__ * 9 + 2] += p[*j * 9 + 2];
	p[*i__ * 9 + 3] += p[*j * 9 + 3];
	p[*i__ * 9 + 4] += p[*j * 9 + 4];
/* Computing 2nd power */
	d__1 = p[*i__ * 9 + 1];
/* Computing 2nd power */
	d__2 = p[*i__ * 9 + 2];
/* Computing 2nd power */
	d__3 = p[*i__ * 9 + 3];
	p[*i__ * 9 + 5] = sqrt(d__1 * d__1 + d__2 * d__2 + d__3 * d__3);
	if (p[*i__ * 9 + 5] == 0.) {
	    p[*i__ * 9 + 5] = 1.;
	} else {
	    p[*i__ * 9 + 5] = 1 / p[*i__ * 9 + 5];
	}
    } else if (*reco == 2) {
/* ---PT WEIGHTED ETA-PHI ADDITION */
	pt = p[*i__ * 9 + 6] + p[*j * 9 + 6];
	if (pt == 0.) {
	    ptt = 1.;
	} else {
	    ptt = 1 / pt;
	}
	p[*i__ * 9 + 7] = (p[*i__ * 9 + 6] * p[*i__ * 9 + 7] + p[*j * 9 + 6] *
		 p[*j * 9 + 7]) * ptt;
	d__2 = p[*j * 9 + 8] - p[*i__ * 9 + 8];
	d__1 = p[*i__ * 9 + 8] + p[*j * 9 + 6] * ptt * ktmdpi_(&d__2);
	p[*i__ * 9 + 8] = ktmdpi_(&d__1);
	p[*i__ * 9 + 6] = pt;
/* Computing 2nd power */
	d__1 = pt;
	p[*i__ * 9 + 9] = d__1 * d__1;
    } else if (*reco == 3) {
/* ---PT**2 WEIGHTED ETA-PHI ADDITION */
	pt = p[*i__ * 9 + 9] + p[*j * 9 + 9];
	if (pt == 0.) {
	    ptt = 1.;
	} else {
	    ptt = 1 / pt;
	}
	p[*i__ * 9 + 7] = (p[*i__ * 9 + 9] * p[*i__ * 9 + 7] + p[*j * 9 + 9] *
		 p[*j * 9 + 7]) * ptt;
	d__2 = p[*j * 9 + 8] - p[*i__ * 9 + 8];
	d__1 = p[*i__ * 9 + 8] + p[*j * 9 + 9] * ptt * ktmdpi_(&d__2);
	p[*i__ * 9 + 8] = ktmdpi_(&d__1);
	p[*i__ * 9 + 6] += p[*j * 9 + 6];
/* Computing 2nd power */
	d__1 = p[*i__ * 9 + 6];
	p[*i__ * 9 + 9] = d__1 * d__1;
    } else {
	switch (ktwarn_("KTMERG", &c__202, (ftnlen)6)) {
	    case 1:  goto L999;
	}
	s_stop("", (ftnlen)0);
    }
/* ---IF MONO.GT.0 CALCULATE NEW KT MEASURES. IF MONO.GT.1 USE ANGULAR ONES. */
    if (*mono <= 0) {
	return 0;
    }
/* ---CONVERTING BETWEEN 4-MTM AND PT,ETA,PHI IF NECESSARY */
    if (*angl != 1 && *reco == 1) {
/* Computing 2nd power */
	d__1 = p[*i__ * 9 + 1];
/* Computing 2nd power */
	d__2 = p[*i__ * 9 + 2];
	p[*i__ * 9 + 9] = d__1 * d__1 + d__2 * d__2;
/* Computing 2nd power */
	d__1 = p[*i__ * 9 + 4];
/* Computing 2nd power */
	d__2 = p[*i__ * 9 + 3];
	p[*i__ * 9 + 7] = d__1 * d__1 - d__2 * d__2;
/* Computing 2nd power */
	d__1 = p[*i__ * 9 + 4];
	if (p[*i__ * 9 + 7] <= eps * (d__1 * d__1)) {
	    p[*i__ * 9 + 7] = p[*i__ * 9 + 9];
	}
	if (p[*i__ * 9 + 7] > 0.) {
/* Computing 2nd power */
	    d__2 = p[*i__ * 9 + 4] + (d__1 = p[*i__ * 9 + 3], abs(d__1));
	    p[*i__ * 9 + 7] = log(d__2 * d__2 / p[*i__ * 9 + 7]) / 2;
	    if (p[*i__ * 9 + 7] > etamax) {
		p[*i__ * 9 + 7] = etamax + 2;
	    }
	} else {
	    p[*i__ * 9 + 7] = etamax + 2;
	}
	p[*i__ * 9 + 7] = d_sign(&p[*i__ * 9 + 7], &p[*i__ * 9 + 3]);
	if (p[*i__ * 9 + 1] != 0. && p[*i__ * 9 + 2] != 0.) {
	    p[*i__ * 9 + 8] = atan2(p[*i__ * 9 + 2], p[*i__ * 9 + 1]);
	} else {
	    p[*i__ * 9 + 8] = 0.;
	}
    } else if (*angl == 1 && *reco != 1) {
	p[*i__ * 9 + 1] = p[*i__ * 9 + 6] * cos(p[*i__ * 9 + 8]);
	p[*i__ * 9 + 2] = p[*i__ * 9 + 6] * sin(p[*i__ * 9 + 8]);
	p[*i__ * 9 + 3] = p[*i__ * 9 + 6] * sinh(p[*i__ * 9 + 7]);
	p[*i__ * 9 + 4] = p[*i__ * 9 + 6] * cosh(p[*i__ * 9 + 7]);
	if (p[*i__ * 9 + 4] != 0.) {
	    p[*i__ * 9 + 5] = 1 / p[*i__ * 9 + 4];
	} else {
	    p[*i__ * 9 + 5] = 1.;
	}
    }
    ang = 0.;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	if (k != *i__ && k != *j) {
	    if (*mono > 1) {
		ang = ktp[max(*i__,k) + min(*i__,k) * ktp_dim1];
	    }
	    ktp[min(*i__,k) + max(*i__,k) * ktp_dim1] = ktpair_(angl, &p[*i__ 
		    * 9 + 1], &p[k * 9 + 1], &ang);
	}
/* L200: */
    }
    kts[*i__] = ktsing_(angl, type__, &p[*i__ * 9 + 1]);
L999:
    return 0;
} /* ktmerg_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktmove_(doublereal *p, doublereal *ktp, doublereal *kts, 
	integer *nmax, integer *n, integer *j, integer *iopt)
{
    /* System generated locals */
    integer ktp_dim1, ktp_offset, i__1;

    /* Local variables */
    static integer i__;

/* ---MOVE THE Nth PARTICLE IN P TO THE Jth POSITION */
/* ---ALSO MOVING KTP AND KTS IF IOPT.GT.0 */
    /* Parameter adjustments */
    --kts;
    ktp_dim1 = *nmax;
    ktp_offset = 1 + ktp_dim1 * 1;
    ktp -= ktp_offset;
    p -= 10;

    /* Function Body */
    for (i__ = 1; i__ <= 9; ++i__) {
	p[i__ + *j * 9] = p[i__ + *n * 9];
/* L100: */
    }
    if (*iopt <= 0) {
	return 0;
    }
    i__1 = *j - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ktp[i__ + *j * ktp_dim1] = ktp[i__ + *n * ktp_dim1];
	ktp[*j + i__ * ktp_dim1] = ktp[*n + i__ * ktp_dim1];
/* L110: */
    }
    i__1 = *n - 1;
    for (i__ = *j + 1; i__ <= i__1; ++i__) {
	ktp[*j + i__ * ktp_dim1] = ktp[i__ + *n * ktp_dim1];
	ktp[i__ + *j * ktp_dim1] = ktp[*n + i__ * ktp_dim1];
/* L120: */
    }
    kts[*j] = kts[*n];
    return 0;
} /* ktmove_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktunit_(doublereal *r__)
{
    static integer i__, j;

/*   SET R EQUAL TO THE 4 BY 4 IDENTITY MATRIX */
    /* Parameter adjustments */
    r__ -= 5;

    /* Function Body */
    for (i__ = 1; i__ <= 4; ++i__) {
	for (j = 1; j <= 4; ++j) {
	    r__[i__ + (j << 2)] = 0.;
	    if (i__ == j) {
		r__[i__ + (j << 2)] = 1.;
	    }
/* L10: */
	}
/* L20: */
    }
    return 0;
} /* ktunit_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktlbst_(integer *iopt, doublereal *r__, doublereal *a)
{
    /* System generated locals */
    doublereal d__1, d__2, d__3, d__4;

    /* Builtin functions */
    double sqrt(doublereal);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static doublereal b[4], c__[16]	/* was [4][4] */;
    static integer i__, j;
    static doublereal m;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen), ktmmul_(
	    doublereal *, doublereal *, doublereal *);

/*   PREMULTIPLY R BY THE 4 BY 4 MATRIX TO */
/*   LORENTZ BOOST TO/FROM THE CM FRAME OF A */
/*   IOPT=0 => TO */
/*   IOPT=1 => FROM */

/*   LAST ARGUMENT IS LABEL TO JUMP TO IF A IS NOT TIME-LIKE */

    /* Parameter adjustments */
    --a;
    r__ -= 5;

    /* Function Body */
    for (i__ = 1; i__ <= 4; ++i__) {
	b[i__ - 1] = a[i__];
/* L10: */
    }
/* Computing 2nd power */
    d__1 = b[3];
/* Computing 2nd power */
    d__2 = b[0];
/* Computing 2nd power */
    d__3 = b[1];
/* Computing 2nd power */
    d__4 = b[2];
    m = d__1 * d__1 - d__2 * d__2 - d__3 * d__3 - d__4 * d__4;
    if (m <= 0.) {
	switch (ktwarn_("KTLBST", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    m = sqrt(m);
    b[3] += m;
    m = 1 / (m * b[3]);
    if (*iopt == 0) {
	b[3] = -b[3];
    } else if (*iopt != 1) {
	switch (ktwarn_("KTLBST", &c__200, (ftnlen)6)) {
	    case 1:  goto L999;
	}
	s_stop("", (ftnlen)0);
    }
    for (i__ = 1; i__ <= 4; ++i__) {
	for (j = 1; j <= 4; ++j) {
	    c__[i__ + (j << 2) - 5] = b[i__ - 1] * b[j - 1] * m;
	    if (i__ == j) {
		c__[i__ + (j << 2) - 5] += 1;
	    }
/* L20: */
	}
/* L30: */
    }
    c__[15] += -2;
    ktmmul_(c__, &r__[5], &r__[5]);
    return 0;
L999:
    return 1;
} /* ktlbst_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktrrot_(doublereal *r__, doublereal *a, doublereal *b)
{
    /* System generated locals */
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static doublereal c__[4], d__[4], m[16]	/* was [4][4] */, al, bl, cl, 
	    dl;
    extern /* Subroutine */ int ktwarn_(char *, integer *, ftnlen), ktmmul_(
	    doublereal *, doublereal *, doublereal *);

/*   PREMULTIPLY R BY THE 4 BY 4 MATRIX TO */
/*   ROTATE FROM VECTOR A TO VECTOR B BY THE SHORTEST ROUTE */
/*   IF THEY ARE EXACTLY BACK-TO-BACK, THE ROTATION AXIS IS THE VECTOR */
/*   WHICH IS PERPENDICULAR TO THEM AND THE X AXIS, UNLESS THEY ARE */
/*   PERPENDICULAR TO THE Y AXIS, WHEN IT IS THE VECTOR WHICH IS */
/*   PERPENDICULAR TO THEM AND THE Y AXIS. */
/*   NOTE THAT THESE CONDITIONS GUARANTEE THAT IF BOTH ARE PERPENDICULAR */
/*   TO THE Z AXIS, IT WILL BE USED AS THE ROTATION AXIS. */

/*   LAST ARGUMENT IS LABEL TO JUMP TO IF EITHER HAS LENGTH ZERO */

/* ---SQRT(2*EPS) IS THE ANGLE IN RADIANS OF THE SMALLEST ALLOWED ROTATION */
/*   NOTE THAT IF YOU CONVERT THIS PROGRAM TO SINGLE PRECISION, YOU WILL */
/*   NEED TO INCREASE EPS TO AROUND 0.5E-4 */
    /* Parameter adjustments */
    --b;
    --a;
    r__ -= 5;

    /* Function Body */
/* Computing 2nd power */
    d__1 = a[1];
/* Computing 2nd power */
    d__2 = a[2];
/* Computing 2nd power */
    d__3 = a[3];
    al = d__1 * d__1 + d__2 * d__2 + d__3 * d__3;
/* Computing 2nd power */
    d__1 = b[1];
/* Computing 2nd power */
    d__2 = b[2];
/* Computing 2nd power */
    d__3 = b[3];
    bl = d__1 * d__1 + d__2 * d__2 + d__3 * d__3;
    if (al <= 0. || bl <= 0.) {
	switch (ktwarn_("KTRROT", &c__100, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    al = 1 / sqrt(al);
    bl = 1 / sqrt(bl);
    cl = (a[1] * b[1] + a[2] * b[2] + a[3] * b[3]) * al * bl;
/* ---IF THEY ARE COLLINEAR, DON'T NEED TO DO ANYTHING */
    if (cl >= .99999950000000004) {
	return 0;
/* ---IF THEY ARE BACK-TO-BACK, USE THE AXIS PERP TO THEM AND X AXIS */
    } else if (cl <= -.99999950000000004) {
	if (abs(b[2]) > 5e-7) {
	    c__[0] = 0.;
	    c__[1] = -b[3];
	    c__[2] = b[2];
/* ---UNLESS THEY ARE PERPENDICULAR TO THE Y AXIS, */
	} else {
	    c__[0] = b[3];
	    c__[1] = 0.;
	    c__[2] = -b[1];
	}
/* ---OTHERWISE FIND ROTATION AXIS */
    } else {
	c__[0] = a[2] * b[3] - a[3] * b[2];
	c__[1] = a[3] * b[1] - a[1] * b[3];
	c__[2] = a[1] * b[2] - a[2] * b[1];
    }
/* Computing 2nd power */
    d__1 = c__[0];
/* Computing 2nd power */
    d__2 = c__[1];
/* Computing 2nd power */
    d__3 = c__[2];
    cl = d__1 * d__1 + d__2 * d__2 + d__3 * d__3;
    if (cl <= 0.) {
	switch (ktwarn_("KTRROT", &c__101, (ftnlen)6)) {
	    case 1:  goto L999;
	}
    }
    cl = 1 / sqrt(cl);
/* ---FIND ROTATION TO INTERMEDIATE AXES FROM A */
    d__[0] = a[2] * c__[2] - a[3] * c__[1];
    d__[1] = a[3] * c__[0] - a[1] * c__[2];
    d__[2] = a[1] * c__[1] - a[2] * c__[0];
    dl = al * cl;
    m[0] = a[1] * al;
    m[4] = a[2] * al;
    m[8] = a[3] * al;
    m[12] = 0.;
    m[1] = c__[0] * cl;
    m[5] = c__[1] * cl;
    m[9] = c__[2] * cl;
    m[13] = 0.;
    m[2] = d__[0] * dl;
    m[6] = d__[1] * dl;
    m[10] = d__[2] * dl;
    m[14] = 0.;
    m[3] = 0.;
    m[7] = 0.;
    m[11] = 0.;
    m[15] = 1.;
    ktmmul_(m, &r__[5], &r__[5]);
/* ---AND ROTATION FROM INTERMEDIATE AXES TO B */
    d__[0] = b[2] * c__[2] - b[3] * c__[1];
    d__[1] = b[3] * c__[0] - b[1] * c__[2];
    d__[2] = b[1] * c__[1] - b[2] * c__[0];
    dl = bl * cl;
    m[0] = b[1] * bl;
    m[1] = b[2] * bl;
    m[2] = b[3] * bl;
    m[4] = c__[0] * cl;
    m[5] = c__[1] * cl;
    m[6] = c__[2] * cl;
    m[8] = d__[0] * dl;
    m[9] = d__[1] * dl;
    m[10] = d__[2] * dl;
    ktmmul_(m, &r__[5], &r__[5]);
    return 0;
L999:
    return 1;
} /* ktrrot_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktvmul_(doublereal *m, doublereal *a, doublereal *b)
{
    static doublereal c__[4];
    static integer i__, j;

/*   4 BY 4 MATRIX TIMES 4 VECTOR: B=M*A. */
/*   ALL ARE DOUBLE PRECISION */
/*   IT IS SAFE TO CALL WITH B=A */
/*   FIRST SUBSCRIPT=ROWS, SECOND=COLUMNS */
    /* Parameter adjustments */
    --b;
    --a;
    m -= 5;

    /* Function Body */
    for (i__ = 1; i__ <= 4; ++i__) {
	c__[i__ - 1] = 0.;
	for (j = 1; j <= 4; ++j) {
	    c__[i__ - 1] += m[i__ + (j << 2)] * a[j];
/* L10: */
	}
/* L20: */
    }
    for (i__ = 1; i__ <= 4; ++i__) {
	b[i__] = c__[i__ - 1];
/* L30: */
    }
    return 0;
} /* ktvmul_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktmmul_(doublereal *a, doublereal *b, doublereal *c__)
{
    static doublereal d__[16]	/* was [4][4] */;
    static integer i__, j, k;

/*   4 BY 4 MATRIX MULTIPLICATION: C=A*B. */
/*   ALL ARE DOUBLE PRECISION */
/*   IT IS SAFE TO CALL WITH C=A OR B. */
/*   FIRST SUBSCRIPT=ROWS, SECOND=COLUMNS */
    /* Parameter adjustments */
    c__ -= 5;
    b -= 5;
    a -= 5;

    /* Function Body */
    for (i__ = 1; i__ <= 4; ++i__) {
	for (j = 1; j <= 4; ++j) {
	    d__[i__ + (j << 2) - 5] = 0.;
	    for (k = 1; k <= 4; ++k) {
		d__[i__ + (j << 2) - 5] += a[i__ + (k << 2)] * b[k + (j << 2)]
			;
/* L10: */
	    }
/* L20: */
	}
/* L30: */
    }
    for (i__ = 1; i__ <= 4; ++i__) {
	for (j = 1; j <= 4; ++j) {
	    c__[i__ + (j << 2)] = d__[i__ + (j << 2) - 5];
/* L40: */
	}
/* L50: */
    }
    return 0;
} /* ktmmul_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktinvt_(doublereal *a, doublereal *b)
{
    static doublereal c__[16]	/* was [4][4] */;
    static integer i__, j;

/* ---INVERT TRANSFORMATION MATRIX A */

/*   A = INPUT  : 4 BY 4 TRANSFORMATION MATRIX */
/*   B = OUTPUT : INVERTED TRANSFORMATION MATRIX */

/*   IF A IS NOT A TRANSFORMATION MATRIX YOU WILL GET STRANGE RESULTS */

/*   NOTE THAT IT IS SAFE TO CALL WITH A=B */

/* ---TRANSPOSE */
    /* Parameter adjustments */
    b -= 5;
    a -= 5;

    /* Function Body */
    for (i__ = 1; i__ <= 4; ++i__) {
	for (j = 1; j <= 4; ++j) {
	    c__[i__ + (j << 2) - 5] = a[j + (i__ << 2)];
/* L10: */
	}
/* L20: */
    }
/* ---NEGATE ENERGY-MOMENTUM MIXING TERMS */
    for (i__ = 1; i__ <= 3; ++i__) {
	c__[(i__ << 2) - 1] = -c__[(i__ << 2) - 1];
	c__[i__ + 11] = -c__[i__ + 11];
/* L30: */
    }
/* ---OUTPUT */
    for (i__ = 1; i__ <= 4; ++i__) {
	for (j = 1; j <= 4; ++j) {
	    b[i__ + (j << 2)] = c__[i__ + (j << 2) - 5];
/* L40: */
	}
/* L50: */
    }
    return 0;
} /* ktinvt_ */

/* ----------------------------------------------------------------------- */
doublereal ktmdpi_(doublereal *phi)
{
    /* System generated locals */
    doublereal ret_val, d__1;

    /* Builtin functions */
    double d_mod(doublereal *, doublereal *);

/* ---RETURNS PHI, MOVED ONTO THE RANGE [-PI,PI) */
    ret_val = *phi;
    if (ret_val <= 3.14159265358979324) {
	if (ret_val > -3.14159265358979324) {
	    goto L100;
	} else if (ret_val > -9.42477796076937972) {
	    ret_val += 6.28318530717958648;
	} else {
	    d__1 = 3.14159265358979324 - ret_val;
	    ret_val = -d_mod(&d__1, &c_b257) + 3.14159265358979324;
	}
    } else if (ret_val <= 9.42477796076937972) {
	ret_val += -6.28318530717958648;
    } else {
	d__1 = ret_val + 3.14159265358979324;
	ret_val = d_mod(&d__1, &c_b257) - 3.14159265358979324;
    }
L100:
    if (abs(ret_val) < 1e-15) {
	ret_val = 0.;
    }
    return ret_val;
} /* ktmdpi_ */

/* ----------------------------------------------------------------------- */
/* Subroutine */ int ktwarn_(char *subrtn, integer *icode, ftnlen subrtn_len)
{
    /* Format strings */
    static char fmt_10[] = "(/\002 KTWARN CALLED FROM SUBPROGRAM \002,a6,\
\002: CODE =\002,i4/)";

    /* Builtin functions */
    integer s_wsfe(cilist *), do_fio(integer *, char *, ftnlen), e_wsfe();
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Fortran I/O blocks */
    static cilist io___137 = { 0, 6, 0, fmt_10, 0 };


/*     DEALS WITH ERRORS DURING EXECUTION */
/*     SUBRTN = NAME OF CALLING SUBROUTINE */
/*     ICODE  = ERROR CODE:    - 99 PRINT WARNING & CONTINUE */
/*                          100-199 PRINT WARNING & JUMP */
/*                          200-    PRINT WARNING & STOP DEAD */
/* ----------------------------------------------------------------------- */
    s_wsfe(&io___137);
    do_fio(&c__1, subrtn, (ftnlen)6);
    do_fio(&c__1, (char *)&(*icode), (ftnlen)sizeof(integer));
    e_wsfe();
    if (*icode < 100) {
	return 0;
    }
    if (*icode < 200) {
	return 1;
    }
    s_stop("", (ftnlen)0);
    return 0;
} /* ktwarn_ */

#ifdef __cplusplus
	}
#endif
