// * This code is licensed under:
// * RunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.

#include <string>
#include <iostream>
#include <math.h>

#include <TROOT.h>
#include "CLHEP/config/CLHEP.h"
#include "CLHEP/config/iostream.h"
#include "CLHEP/config/iomanip.h"
#include "CLHEP/HepPDT/ParticleID.hh"
using namespace std;

Int_t charge3(Int_t id) {
// get 3-charge 

    int  nr, nx;
    int chg, extra;

       HepPDT::ParticleID pid( id );
        nx = pid.digit(HepPDT::n);
        nr = pid.digit(HepPDT::nr);
        extra = pid.extraBits();
//        cout << endl;
//        cout << setw(18) << id << ": " << nx << " " << nr
//                     << " " << pid.digit(HepPDT::nl)
//                     << " " << pid.digit(HepPDT::nq1) << " "
//                     << pid.digit(HepPDT::nq2) << " " << pid.digit(HepPDT::nq3)
//                     << " " <<  pid.digit(HepPDT::nj)
//                     << " extra bits " << extra << endl;


//        js = pid.jSpin();
//        HepPDT::Quarks cqks = pid.quarks( );
//        ls = pid.lSpin();
//        sid = pid.fundamentalID();
 
       chg = (Int_t)pid.threeCharge();

//        cout << setw(18) << id << " 3 charge "  << chg <<  endl;
 

        return chg;

   }
 



//////////////////////////////////////////////////////////////////////
string  GETparticlename(int name)
 {
 // int name corresponds to pdg particle code.
 string partname="";
 string sign ="+";
 string leptonsign = "-"; 
 
 if(name < 0) {
 sign = "-"; 
 leptonsign = "+";
 }
 name = abs(name);
 //cout << "leptonsign : " << leptonsign << endl;

// cout << name << endl;
 
 if(name == 1) {partname = "d"; return partname; }  
 if(name == 2) {partname = "u"; return partname; }  
 if(name == 3) {partname = "s"; return partname; } 
 if(name == 4) {partname = "c"; return partname; } 
 if(name == 5) {partname = "b"; return partname; } 
 if(name == 6) {partname = "t"; return partname; } 
 if(name == 7) {partname = "l"; return partname; } 
 if(name == 8) {partname = "h"; return partname; } 
 if(name == 9) {partname = "none"; return partname; } 
 if(name == 10) {partname = "none"; return partname; } 
 if(name == 11) {partname = "e"+leptonsign; return partname; } 
 if(name == 12) {partname = "nu_e"; return partname; }
 if(name == 13) {partname = "mu"+leptonsign; return partname; } 
 if(name == 14) {partname = "nu_mu"; return partname; } 
 if(name == 15) {partname = "tau"+leptonsign; return partname; } 
 if(name == 16) {partname = "nu_tau";  return partname; } 
 if(name == 17) {partname = "chi"+leptonsign; return partname; } 
 if(name == 18) {partname = "nu_chi"; return partname; } 
 if(name == 19) partname = "none";
 if(name == 20) partname = "none";
 if(name == 21) {partname = "gluon"; return partname; } 
 if(name == 22) {partname = "gamma"; return partname; } 
 if(name == 23) {partname = "Z0"; return partname; } 
 if(name == 24) {partname = "W"+sign; return partname; } 
 if(name == 25) {partname = "H0"; return partname; }

// most common mesons 
 if(name == 111) {partname = "pi0" ; return partname; } 
 if(name == 113) {partname = "rho0"; return partname; } 
 if(name == 115) {partname = "a_20"; return partname; } 
 if(name == 130) {partname = "K_L0"; return partname; } 
 if(name == 310) {partname = "K_S0"; return partname; }
 if(name == 311) {partname = "K0"; return partname; }
 if(name == 211) {partname = "pi"+sign; return partname; } 
 if(name == 213) {partname = "rho"+sign; return partname; } 

// most common baryons 
 if(name == 1114) {partname = "Delta-"; return partname; }
 if(name == 2112) {partname = "neutron"; return partname; }
 if(name == 2114) {partname = "Delta0"; return partname; }
 if(name == 2212) {partname = "proton"; return partname; }
 if(name == 2214) {partname = "Delta+"; return partname; }
 if(name == 2224) {partname = "Delta++"; return partname; }
 if(name == 3112) {partname = "Sigma-"; return partname; }
 if(name == 3114) {partname = "Sigma*-"; return partname; }
 if(name == 3122) {partname = "Lamba0"; return partname; }
 if(name == 3212) {partname = "Sigma0"; return partname; }
 if(name == 3214) {partname = "Sigma*0"; return partname; }
 if(name == 3222) {partname = "Sigma+"; return partname; }


// other stuff 
 if(name == 215) {partname = "a_2"+sign; return partname; } 
 if(name == 221) {partname = "eta"; return partname; } 
 if(name == 223) {partname = "omega"; return partname; } 
 if(name == 225) {partname = "f_20"; return partname; } 
 if(name == 313) {partname = "K*0"; return partname; }
 if(name == 315) {partname = "K*_20"; return partname; } 
 if(name == 321) {partname = "K"+sign; return partname; } 
 if(name == 323) {partname = "K*"+sign; return partname; } 
 if(name == 325) {partname = "K*_2"+sign; return partname; }
 if(name == 331) {partname = "eta`"; return partname; }
 if(name == 333) {partname = "phi"; return partname; } 
 if(name == 335) {partname = "f`_20"; return partname; }
 if(name == 411) {partname = "D"+sign; return partname; }
 if(name == 413) {partname = "D*"+sign; return partname; }
 if(name == 415) {partname = "D*_2"+sign; return partname; }
 if(name == 421) {partname = "D0"; return partname; }
 if(name == 423) {partname = "D*0"; return partname; }
 if(name == 425) {partname = "D*_20"; return partname; }
 if(name == 431) {partname = "D_s"+sign; return partname; }
 if(name == 433) {partname = "D*_s"+sign; return partname; }
 if(name == 435) {partname = "D*_2s"+sign; return partname; }
 if(name == 441) {partname = "eta_c"; return partname; }
 if(name == 443) {partname = "J/psi";  return partname; } 
 if(name == 445) {partname = "chi_2c0"; return partname; } 
 if(name == 511) {partname = "B0"; return partname; }
 if(name == 513) {partname = "B*0"; return partname; }
 if(name == 521) {partname = "B"+sign; return partname; }
 if(name == 523) {partname = "B*"+sign; return partname; }
 if(name == 531) partname = "B_s0";
 if(name == 533) partname = "B*_s0";
 if(name == 541) partname = "B_c"+sign;
 if(name == 543) partname = "B*_c"+sign;
 if(name == 551) partname = "eta_b";
 if(name == 553) partname = "Upsilon";
 if(name == 661) partname = "eta_t";
 if(name == 663) partname = "Theta";

// less common staff  
 if(name == 3224) partname = "Sigma*+";
 if(name == 3312) partname = "Xi-";
 if(name == 3314) partname = "Xi*-";
 if(name == 3322) partname = "Xi0";
 if(name == 3324) partname = "Xi*0";
 if(name == 3334) partname = "Omega-";
 if(name == 4112) partname = "Sigma_c0";
 if(name == 4114) partname = "Sigam*_c0";
 if(name == 4122) partname = "Lambda_c"+sign;
 if(name == 4212) partname = "Sigma_c+";
 if(name == 4214) partname = "Sigma*_c+";
 if(name == 4222) partname = "Sigma_c++";
 if(name == 4224) partname = "Sigma*_c++";
 if(name == 4132) partname = "Xi_c0";
 if(name == 4232) partname = "Xi_c+";
 if(name == 4312) partname = "Xi`_C0";
 if(name == 4314) partname = "Xi*_c0";
 if(name == 4322) partname = "Xi`_c+";
 if(name == 4324) partname = "Xi*_c+";
 if(name == 4332) partname = "Omega_c0";
 if(name == 4334) partname = "Omega*_c0";
 if(name == 5112) partname = "Sigma_b-";
 if(name == 5114) partname = "Sigma*_b-";
 if(name == 5122) partname = "Lambda_b0";
 if(name == 5212) partname = "Sigma_b0";
 if(name == 5214) partname = "Sigma*_b0";
 if(name == 5222) partname = "Sigma_b+";
 if(name == 5224) partname = "Sigma*_b+";
 if(name == 5232) partname = "Xi_b0";
 
 if(partname == "" ) partname = "not defined";


 return partname;
 }



//////////////////////////////////////////////////////////////////////
// get particle name
char *getname (int pid) {

   string sname = GETparticlename(pid);
   static char name[20];
   strcpy(name,sname.c_str());

   return name;
}










